      SUBROUTINE DGSET(ITEM,VALU)
C
C
C  DGSET SETS OPTIONS FOR FUTURE CALLS TO UGLINE, UGMARK, ETC.
C
C       A. BOYARSKI,   4/21/83
C
      INCLUDE 'dpmode.INC'
C
      CHARACTER*4 ITEM
      REAL VALU(1)
C   BUF IS THE ELEMENT BUFFER FOR UNIFIED GRAPHICS CALLS
      INTEGER BUF(1)
      INTEGER BUFLEN
      CHARACTER*4 OPTS(8)
      CHARACTER*6 MRKOPT
      CHARACTER*(*) TEXT
      CHARACTER*256 CHR1,CHR2
C
      CHARACTER*1 DOLAR,OPEN,CLOS,BLNK,PSYMS(10)
C     INTEGER*2 STATE(100)
      INTEGER*4 STATE(100)
      CHARACTER*1 FONT(100)
C
      CHARACTER*1 CB(7),CB1(7),CB2(7),RB1(7),RB2(7)
      REAL AX(1),AY(1)
      CHARACTER*4 DGNAM(3)
      EQUIVALENCE (TVAL,IVAL),(TEMP,ITEMP)
      INTEGER IARRAY(20)
      REAL XARRAY(10),AREA(4)
      CHARACTER*7 UGOPT
#if   defined(__OSF1)
      INTEGER*8 L	! for 64-bit pointer
#endif
      SAVE L,IENTRY	! for g77
C
      DATA BUFLEN/0/
C
      DATA OPTS/'XSPA','ANGL','DASH','BRIT','COLO','WINK','PLIM','ALIG'/
C
      DATA DOLAR/'$'/, OPEN/'{'/, CLOS/'}'/, BLNK/' '/
      DATA PSYMS/'0','1','2','3','4','5','6','7','8','9'/
C
      DATA CB,CB1,CB2,RB1,RB2/
     >   '^','_','>','<','+','+','+',
     >   '2','0','0','1','0','2','4',
     >   'X','X','Y','Y','Z','Z','Z',
     >   '3','1','1','0','1','3','5',
     >   'X','X','Y','Y','Z','Z','Z'/
C
C
      DATA DGNAM/'SET ','XCH ','GET '/
C
C
C
      IENTRY=1
      GO TO 5
C
C
C
      ENTRY DGXCH(ITEM,VALU)
      IENTRY=2
C
    5 TEMP=VALU(1)
      GO TO 7
C
C
C
      ENTRY DGGET(ITEM,VALU)
      IENTRY=3
C
    7 CALL UGDEFL('GET',IARRAY,XARRAY)
      TVAL=VALU(1)
      DO 10 I=1,8
   10 IF(ITEM.EQ.OPTS(I)) GO TO (100,200,300,400,500,600,700,800), I
      WRITE(ERUNIT,20) DGNAM(IENTRY),ITEM
   20 FORMAT(/,' DG',A3,' CALLED WITH ILLEGAL OPTION, =',A5)
      RETURN
C
C  XSPACING
C
  100 TEMP=XARRAY(1)
      IF(IENTRY.GT.2) GO TO 110
      XARRAY(1)=VALU(1)
      XARRAY(2)=0.0
      IF(XARRAY(1).LE.0.0) XARRAY(1)=.015
  110 IF(IENTRY.GE.2) VALU(1)=TEMP
      GO TO 5000
C
C  ANGLE
C
  200 TEMP=XARRAY(3)
      IF(IENTRY.LE.2) XARRAY(3)=VALU(1)
      IF(IENTRY.GE.2) VALU(1)=TEMP
      GO TO 5000
C
C  DASH
C
  300 ITEMP=IARRAY(5)
      IF(IENTRY.LE.2) IARRAY(5)=IVAL
      IF(IENTRY.GE.2) VALU(1)=TEMP
      GO TO 5000
C
C  BRIT
C
  400 ITEMP=IARRAY(1)
      IF(IENTRY.LE.2) IARRAY(1)=IVAL
      IF(IENTRY.GE.2) VALU(1)=TEMP
      GO TO 5000
C
C  COLOR
C
  500 ITEMP=IARRAY(2)
      IF(IENTRY.GE.3) GO TO 530
      IF(IVAL.EQ.0) IVAL=1
      IF(IENTRY.LE.2) IARRAY(2)=IVAL
  530 IF(IENTRY.GE.2) VALU(1)=TEMP
      GO TO 5000
C
C  WINK
C
  600 ITEMP=IARRAY(3)
      IF(IENTRY.LE.2) IARRAY(3)=IVAL
      IF(IENTRY.GE.2) VALU(1)=TEMP
      GO TO 5000
C
C       PLIMITS
C
  700 IF(IENTRY.EQ.3) CALL UGWDOW('GET',AREA,VALU)
      RETURN
C
C  ALIGNMENT (1=LEFT, 2=CENTER, 3=RIGHT)
C  ALIGNMENT (1=LEFT, 2=RIGHT, 3=CENTER)   for UGS old version ?
C
  800 ITEMP=IARRAY(6)
      IF(IENTRY.LE.2) IARRAY(6)=IVAL
      IF(IENTRY.GE.2) VALU(1)=TEMP
      GO TO 5000
C
C
C
 5000 IF(IENTRY.GE.3) RETURN
      CALL UGDEFL('SET',IARRAY,XARRAY)
      RETURN
C
C
C
      ENTRY DGBUF(BUF,N)
C  THIS ENTRY SUPPLIES THE ADDRESS OF THE ELEMENT BUFFER
#     if defined(__AIX)
      L= LOC(BUF)                                                       VAX780
#     else
      L=%LOC(BUF)                                                       VAX780
#     endif
      BUFLEN=N
C       ALSO SUPPLY BUF ADDRESS TO DGPUTX ROUTINE
      CALL DGBUFX(BUF,N)
      RETURN
C
C
C
      ENTRY DGINT(IC)
      IF(BUFLEN.NE.0) GO TO 5200
      WRITE(ERUNIT,5210)
 5210 FORMAT(/,' DGINT CALLED, BUT THERE IS NO BUFFER DEFINED')
CCCC      IF(ITRACE.EQ.1) CALL ERRTRA
      STOP
C

 5200 IF(IC.EQ.0) CALL UGINIT('CLEAR',%VAL(L),BUFLEN)                   VAX780
      IF(IC.EQ.1) CALL UGINIT('CONTINUE',%VAL(L),BUFLEN)                VAX780
C5200 IF(IC.EQ.0) CALL UGINIT('CLEAR',BUF,BUFLEN)                       IBM370
C     IF(IC.EQ.1) CALL UGINIT('CONTINUE',BUF,BUFLEN)                    IBM370
      RETURN
C
C
C
      ENTRY DGSYM(X,Y,ISYM)
C
      IF(ISYM.LE.0.OR.ISYM.GT.10) RETURN
      MRKOPT=' '
      IF(ISYM.GT.0) MRKOPT='MARK='//PSYMS(ISYM)
C     CALL UGMARK(MRKOPT,X,Y,BUF)                                       IBM370
      CALL UGMARK(MRKOPT,X,Y,%VAL(L))                                   VAX780
      RETURN
C
C
      ENTRY DGTXT(X,Y,TEXT)
C
C       COPY TEXT INTO A CHARACTER VARIABLE SO THAT TESTS MAY BE DONE
      M=MIN0(256,LEN(TEXT))
      IF(M.LE.0) RETURN
C
      CHR2=BLNK
      CHR1=TEXT
      IF(CHR1(1:1).EQ.DOLAR) GO TO 6500
      IF(CHR1(1:1).EQ.OPEN) GO TO 6000
      NN=M
C     IF(CHFMT.GE.2) GO TO 6800
      IF(CHFMT.GE.1) GO TO 6800			! coding error ?
C     CALL UGTEXT(' ',X,Y,CHR1(1:M),BUF)                                IBM370
      CALL UGTEXT(' ',X,Y,CHR1(1:M),%VAL(L))                            VAX780
      RETURN
C
C   I  IS CURRENT INDEX TO INPUT BUFFER, TEXT(I),
C   NN IS CURRENT INDEX TO OUTPUT BUFFERS, CHR1(NN) AND CHR2(NN)
C   K  IS CURRENT INDEX TO STATE(K), FONT(K)
C
 6000 I=0
      NN=0
      K=1
      FONT(1)=BLNK
      STATE(1)=0
      ISAVE=0
C
 6100 I=I+1
      IF(I.GT.M) GO TO 6800
      IF(CHR1(I:I).EQ.OPEN) GO TO 6140
      IF(CHR1(I:I).EQ.CLOS) GO TO 6200
C
      IF(NN.GE.256) GO TO 6800
      NN=NN+1
      CHR1(NN:NN)=CHR1(I:I)
      CHR2(NN:NN)=FONT(K)
      IF(CHR1(NN:NN).EQ.BLNK) CHR2(NN:NN)=BLNK
      GO TO 6100
C
C PROCESS THE { CONTROL BYTE
C
 6140 K=K+1
      FONT(K)=FONT(K-1)
      IF(I.GE.M) GO TO 6800
      I=I+1
      DO 6150 ICB=1,5
      IF(CB(ICB).EQ.CHR1(I:I)) GO TO 6160
 6150 CONTINUE
C
C      CHANGE TO NEW FONT
      STATE(K)=0
      FONT(K)=CHR1(I:I)
      GO TO 6100
C
C      ITS A CONTROL BYTE - SUPER/SUBSCRIPT OR SIZE CHANGE
 6160 IF(ICB.NE.5) GO TO 6170
      ICB=ICB+ISAVE
C       BUMP UP SAVING INDEX (FOR NEXT TIME)
      ISAVE=ISAVE+1
 6170 CONTINUE
      STATE(K)=ICB
C       CANT DO MORE THAN 3 LEVELS
      IF(ICB.GT.7) GO TO 6100
      IF(NN.GE.256) GO TO 6800
      NN=NN+1
      CHR1(NN:NN)=CB1(ICB)
      CHR2(NN:NN)=CB2(ICB)
      GO TO 6100
C
C PROCESS THE } CONTROL BYTE
C
 6200 IF(K.LE.1) GO TO 6100
      K=K-1
      IF(STATE(K+1).EQ.0) GO TO 6100
C
C      RESTORE CONTROL STATUS
      IRB=STATE(K+1)
      IF(IRB.GE.5) ISAVE=IRB-5
      IF(IRB.GT.7) GO TO 6100
      IF(NN.GE.256) GO TO 6800
      NN=NN+1
      CHR1(NN:NN)=RB1(IRB)
      CHR2(NN:NN)=RB2(IRB)
      GO TO 6100
C
C       HANDLE CHARACTERS IN PAIRED FORMAT
 6500 DO 6510 I=2,M,2
      J=I/2
      CHR1(J:J)=CHR1(I:I)
      IF(I.LT.M) CHR2(J:J)=CHR1(I+1:I+1)
 6510 CONTINUE
      NN=M/2
C
 6800 IF(NN.LE.1) UGOPT='FIXSIZE'
      IF(NN.GT.1) UGOPT=' '
C     CALL UGXTXT(UGOPT,X,Y,CHR1(1:NN),CHR2(1:NN),BUF)                  IBM370
      CALL UGXTXT(UGOPT,X,Y,CHR1(1:NN),CHR2(1:NN),%VAL(L))              VAX780
      RETURN
C
C
      ENTRY DGLIN(X,Y,IDRAW)
C
      CALL UGLINE(' ',X,Y,IDRAW,%VAL(L))                                VAX780
C     CALL UGLINE(' ',X,Y,IDRAW,BUF)                                    IBM370
      RETURN
C
C
      ENTRY DGLNS(AX,AY,N)
      CALL UGPLIN(' ',AX,AY,N,1,1,%VAL(L))                              VAX780
C     CALL UGPLIN(' ',AX,AY,N,1,1,BUF)                                  IBM370
      RETURN
C
C
      ENTRY DGPFL(AX,AY,N)
      CALL UGPFIL(' ',AX,AY,N,%VAL(L))                                  VAX780
C     CALL UGPFIL(' ',AX,AY,N,BUF)                                      IBM370
      RETURN
C
C
C
      ENTRY DGPNT(X,Y)
C
      CALL UGMARK(' ',X,Y,%VAL(L))                                      VAX780
C     CALL UGMARK(' ',X,Y,BUF)                                          IBM370
      RETURN
C
C
      ENTRY DGPTS(AX,AY,N)
      CALL UGPMRK(' ',AX,AY,N,%VAL(L))                                  VAX780
C     CALL UGPMRK(' ',AX,AY,N,BUF)                                      IBM370
      RETURN
C
C
      ENTRY DGPUT(IC,IB)
      IF(IC.EQ.0) CALL UGWRIT(' ',IB,%VAL(L))                           VAX780
C     IF(IC.EQ.0) CALL UGWRIT(' ',IB,BUF)                               IBM370
      RETURN
C
C
      ENTRY DGPIC(IC,IB)
      IF(IC.EQ.0) CALL UGPICT('CLEAR',IB)
      RETURN
C
C
      END
      SUBROUTINE DGBUFX(BUF,IBUF)
C DGBUFX CALLED BY DGBUF, (SUPPLIES BUF ADDRESS AND ITS LENGTH)
      INTEGER BUF(1)
#if   defined(__OSF1)
      INTEGER*8 L	! for 64-bit pointer
#endif
      SAVE L		! for g77
      DATA NBUF/0/
C
      NBUF=IBUF
#     if defined(__AIX)
      L= LOC(BUF)                                                       VAX780
#     else
      L=%LOC(BUF)                                                       VAX780
#     endif
      RETURN
C
C
      ENTRY DGPUTX(IB)
C
C  THIS IS CALLED OUT OF HANDYPAK'S UGXERR TO PUT OUT THE ELEMENT
C  BUFFER AND THEN CONTINUE THE SAME BUFFER
C
      IF(NBUF.LE.0) RETURN
       CALL UGWRIT(' ',IB,%VAL(L))                                       VAX780
       CALL UGINIT('CONTINUE',%VAL(L),NBUF)                              VAX780
C      CALL UGWRIT(' ',IB,BUF)                                           IBM370
C      CALL UGINIT('CONTINUE',BUF,NBUF)                                  IBM370
      RETURN
C
      END
      SUBROUTINE DGLEN(DLEN)
C
C  RETURNS DEVICE LENGTHS PER PROGRAMMER UNIT IN X AND Y
C
      REAL DLEN(2)
      CHARACTER STRING
      INTEGER DLIMIT(4)
C
      CALL UGINFO('WDOWSIZE',STRING,DLIMIT,DLEN)
      RETURN
      END
