      SUBROUTINE DPGR2(FX,FY,FZ,FZE,NX,NY,TITLE,SMAN)
C
C  **MEMBER** DPGR2
C
C  PUTS AN ISOMETRIC PROJECTION OF FZ VS FX,FY INTO GRAPHIC ELEMENT
C     (Z AXIS IS LOCATED ON LEFT-MOST PART OF PROJECTED PLOT)
C
      EXTERNAL FX,  FY,  FZ,  FZE
      CHARACTER*(*) TITLE
C
      INCLUDE 'dpmode.INC'
      INCLUDE 'dcom3d.INC'
      INCLUDE 'dcomti.INC'
      INCLUDE 'dabort.INC'
      CHARACTER*255 SUBTI
      EQUIVALENCE (SUBTI,SUBTIT(1))
C
      REAL SMAN(14)
      EQUIVALENCE (XMIN,ASCALE(1,1)),(DX,ASCALE(2,1)),(YMIN,ASCALE(1,2))
     > ,(DY,ASCALE(2,2)),(ZMIN,ASCALE(1,3)),(DZ,ASCALE(2,3))
C
C
      REAL  TITZ(3)
      REAL CORNER(2,5),FRAMSZ(3),XBOX(5),YBOX(5)
      REAL EXPZ(3)
      REAL ZUPD(2)
C
C
C       ASCALE HOLDS XMIN,DX,XTICS,XSUBS,YMIN,DY,YTICS,YSUBS
C
C       ISCALE HOLDS IXM,IDX,IPWRX,IYM,IDY,IPWRY
C
C
      REAL TICXY(3)
C      DEFINE UNIT VECTORS ALONG AXES, AND ALONG TICS
      REAL UA(4,2),UAX(4),UAY(4),UAZ(3),UAZB(3)
      EQUIVALENCE (UA(1,1),UAX(1)),(UA(1,2),UAY(1))
C      DEFINE DISTANCE ALONG AXES WHERE TITLE AND EXPONENT BEGIN
C
      REAL LOGTAB(9)
C
      REAL TANG(4), SINT(4), COST(4), XDRAW(2),YDRAW(2)
CC..#IFDEF GKSYS
C      REAL CHUP(2,4)
C..#ENDIF
C
      CHARACTER*8 TEMP8
      CHARACTER*4 CTEMP
C
C
      CHARACTER*20 KFONT
      CHARACTER*8 IFONT
      REAL DLEN(2)
      INTEGER DPSCAL,DMMY
C
C
C     THE NUMBERING SCHEME OF THE XY CORNERS AND SIDES OF THE FRAME IS:
C
C          Y
C          |
C
C        4         3        3
C           --------------
C          |              |
C          |              |
C          |              |
C        4 |              | 2
C          |              |
C          |              |
C          |              |
C           --------------     ------> X
C        1         1        2
C
      DATA FRAMSZ/3*0.4/
      DATA XBOX/.075,.925,.925,.075,.075/
      DATA YBOX/.050,.050,.900,.900,.050/
      DATA  TITZ/0.,0.,.20/
      DATA EXPZ/0.,0.,.65/
      DATA ZUPD/0.,-.04/
      DATA TICSML,TICLRG/0.020,0.040/
      DATA UAX/1.,0.,-1.,0./, UAY/0.,1.,0.,-1./, UAZ/0.,0.,1./
      DATA UAZB/1.,1.,0./
      DATA LOGTAB/0., .30103, .47712, .60206, .69897, .77815,
     >           .84510, .90309, .95424 /
      DATA TANG/0.,0.,0.,90./, SINT/0.,0.,0.,1./, COST/1.,1.,1.,0./
CC..#IFDEF GKSYS
C      DATA CHUP/0.,1., 0.,1., 0.,1., -1.,0./
C..#ENDIF
      DATA KFONT/' ID=     HAS NO DATA'/
C
C
      DATA PIO2/1.5707963268/
      DATA IFONT/' ID=    '/
      DATA IBLANK/4H    /
C
C
C
      IABORT=0
C       UNPACK TITLE INTO 4 SUB-TITLES
      CALL DPTITL(TITLE,NTITLE,1)
C       GET X & Y PROGRAMMER UNITS PER DEVICE UNIT (FOR CHAR SIZES)
C..#IFDEF DGSYS
      CALL DGLEN(DLEN)
CC..#ELIF GKSYS
C      DLEN(1)=1.0
C      DLEN(2)=1.0
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
C
C DEFINE 2-D LOCATION (X2C,Y2C) OF CENTER OF 3-D FRAME
C
      X2C=.55
      Y2C=.55
      Z3C=0.5*FRAMSZ(3)
      XL=X2C-0.5*FRAMSZ(1)
      XH=X2C+0.5*FRAMSZ(1)
      YL=Y2C-0.5*FRAMSZ(2)
      YH=Y2C+0.5*FRAMSZ(2)
      CORNER(1,1)=XL
      CORNER(1,2)=XH
      CORNER(1,3)=XH
      CORNER(1,4)=XL
      CORNER(1,5)=XL
      CORNER(2,1)=YL
      CORNER(2,2)=YL
      CORNER(2,3)=YH
      CORNER(2,4)=YH
      CORNER(2,5)=YL
C
      IF(NX.GT.0.AND.NY.GT.0) GO TO 5
C
C       THIS PLOT HAS NO DATA POINTS
      WRITE(KFONT(5:8),'(A4)') IDA
CC..#IFDEF GKSYS
C      CALL GTX(.3,.6,KFONT)
C..#ELIF DGSYS
      CALL DGTXT(.3,.6,KFONT)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
      GO TO 45
C
C       DO SCALING
C
    5 IF(IAUTO(2).NE.0) GO TO 13
      DO 10 I=1,4
   10 ASCALE(I,1)=SMAN(I)
C  13 CALL DPSCAL(FX,NX,1,IAUTO(2),ILOG(2),0,IZERO(2),
C    >            G2TIC(1,1),ASCALE(1,1),ISCALE(1,1),LOWIN)
   13 DMMY=DPSCAL(FX,NX,1,IAUTO(2),ILOG(2),0,IZERO(2),
     >            G2TIC(1,1),ASCALE(1,1),ISCALE(1,1),LOWIN)  ! for unix-fortran
      IF(IAUTO(3).NE.0) GO TO 20
      DO 17 I=1,4
   17 ASCALE(I,2)=SMAN(I+4)
C  20 CALL DPSCAL(FY,NY,1,IAUTO(3),ILOG(3),0,IZERO(3),
C    >            G2TIC(1,2),ASCALE(1,2),ISCALE(1,2),LOWIN)
   20 DMMY=DPSCAL(FY,NY,1,IAUTO(3),ILOG(3),0,IZERO(3),
     >            G2TIC(1,2),ASCALE(1,2),ISCALE(1,2),LOWIN)  ! for unix-fortran
   28 ITMP=IEDGE(1)
      IF(IEDGE(2).NE.0) ITMP=ITMP+2
      IF(IAUTO(1).NE.0) GO TO 35
      DO 30 I=1,4
   30 ASCALE(I,3)=SMAN(I+8)
C  35 CALL DPSCAL(FZ,NX,NY,IAUTO(1),ILOG(1),ITMP,IZERO(1),
C    >            G2TIC(1,3),ASCALE(1,3),ISCALE(1,3),2)
   35 DMMY=DPSCAL(FZ,NX,NY,IAUTO(1),ILOG(1),ITMP,IZERO(1),
     >            G2TIC(1,3),ASCALE(1,3),ISCALE(1,3),2)      ! for unix-fortran
      ELV=ELVANG
      ROT=ROTANG
      IF(G2ANGS.EQ.0) GO TO 40
C       USE MANUAL ROTATION/ELEVATION ANGLES
      ROT=SMAN(13)
      ELV=SMAN(14)
C
C       DEFINE SOME USEFUL VARIABLES
C
   40 ROT=AMOD(ROT,360.)
      IF(ROT.LT.0.) ROT=ROT+360.
      ROTION=ROT/57.28
      ELV=AMIN1(90.,AMAX1(-90.,ELV))
      ELVTIO=(90.-ELV)/57.28
      COSROT=COS(ROTION)
      SINROT=SIN(ROTION)
      COSELV=COS(ELVTIO)
      SINELV=SIN(ELVTIO)
      XROT0=-X2C*COSROT-Y2C*SINROT
      YROT0=X2C*SINROT-Y2C*COSROT
C
C   LCORNR IS THE LEFT-MOST CORNER OF THE X-Y PLANE
      LCORNR=1+MOD(INT(ROTION/PIO2), 4)
C INITIALIZE DP3LIN VARIABLES TO DRAW HIDDEN LINES.
      LHIDE=0
      UPDWN=1.0
      UPTAG=SIGN(1.0,COSELV)
      HTOL=.00005
C
C       SHOULD THE FRAME BE PUT UP, OR ONLY THE DATA
C
      IF (FRAME.EQ.0) GO TO 50
C
C PUT UP BOX
CC..#IFDEF GKSYS
C      CALL GPL(5,XBOX,YBOX)
C      CALL GQCHH(IGERR,XSPA)
C..#ELIF DGSYS
c     CALL DGLNS(XBOX,YBOX,5)	!!!!!
      CALL DGGET('XSPA',XSPA)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
C
      CSIZE=CSIZX
      EXPZ(3)=FRAMSZ(3)
C
C  WRITE TITLE
C
      NCHR=LENTI(1)
      IF(TITLSZ.NE.0) CSIZE=.015+TITLSZ*.01
CC..#IFDEF GKSYS
C      CALL GSCHH(CSIZE)
C      CALL GSTXAL(2,3)
C      CALL GTX(TX,YBOX(3)+.020+.55*CSIZE,
C     >         SUBTI(LOCTI(1)+1:LOCTI(1)+NCHR))
C      CALL GSTXAL(1,3)
C..#ELIF DGSYS
      CALL DGSET('XSPA',CSIZE)
      CALL DGSET('ALIGN',3)
      CALL DGTXT(0.5,YBOX(3)+.020+.55*CSIZE,
     >         SUBTI(LOCTI(1)+1:LOCTI(1)+NCHR))
      CALL DGSET('ALIGN',1)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
C
C       PUT UP ID, IF IDFONT SAYS SO
      IF(IDFONT.EQ.0 .OR. IDA.EQ.IBLANK) GO TO 45
      WRITE(IFONT(5:8),'(A4)') IDA
      IF(TITLSZ.NE.0) CSIZE=.012+TITLSZ*.005
CC..#IFDEF GKSYS
C      CALL GSCHH(CSIZE)
C      CALL GTX(XBOX(1),YBOX(3)+.010+.55*CSIZE,IFONT(2:8))
C..#ELIF DGSYS
      CALL DGSET('XSPA',CSIZE)
      CALL DGTXT(XBOX(1),YBOX(3)+.010+.55*CSIZE,IFONT(2:8))
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
C
C       NUMBER OF CALLS
C
   45 IF(ICALLS.EQ.0 .OR. NWCALL.EQ.0) GO TO 50
      IF(TITLSZ.NE.0) CSIZE=.015
CC..#IFDEF GKSYS
C      CALL GSCHH(CSIZE)
C..#ELIF DGSYS
      CALL DGSET('XSPA',CSIZE)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
      CALL DPGNUM(XBOX(1)+.02,YBOX(3)-.03)
C
C MAKE TWO PASSES, ONE FOR TOP HEIGHT FUNCTION, OTHER FOR BOTTOM
C
   50 DO 500 IUPDW=1,2
      UPDWN=1.0
      IF(IUPDW.GT.1) UPDWN=-1.0
      IF(IHIDE.NE.0) CALL DPLH(UPDWN,HTOL,0,0)
      LHIDE=IHIDE
C
C       DRAW FRONT OF BASE (FRAME) IN X-Y PLANE
C
   70 INVIS=0
      DO 106 I=1,3
      KN=MOD( (I-2) +LCORNR,4) + 1
      ZUPDW=ZUPD(IUPDW)
      IF(FRAME.EQ.0) ZUPDW=0.
      CALL DP3LIN(INVIS,CORNER(1,KN),CORNER(2,KN),ZUPDW)
      IF(I.EQ.1) GO TO 104
C  COMPUTE SLOPE AND SINE AND COSINE OF FRONT SIDES (DEVICE COORDS)
      TANG(I-1)=ATAN2((YPRO-Y2)*DLEN(2),(XPRO-X2)*DLEN(1))
      IF(TANG(I-1).GT.3.14159) TANG(I-1)=TANG(I-1)-6.28318
      SINT(I-1)=SIN(TANG(I-1))
      COST(I-1)=COS(TANG(I-1))
      TANG(I-1)=57.2958*TANG(I-1)
  104 X2=XPRO
      Y2=YPRO
  106 IF(FRAME.NE.0) INVIS=1
      DXMAG=DLEN(1)/DLEN(2)
        DXMAG = 1.0
      LHIDE=0
C
      IF(IUPDW.GT.1) GO TO 158
C
      IF(FRAME.EQ.0) GO TO 158
C       DRAW TICS FOR X-Y-Z AXES
C
      DO 155 IAXIS=1,3
C
C       IAXIS=1 OR 2 FOR X OR Y (OR Y OR X) AND 3 FOR Z
C       KN IS THE INITIAL XY CORNER NUMBER FOR THIS AXIS
C       KAXIS IS 1 WHEN X AXIS IS BEING DRAWN, 2 FOR Y, AND 3 FOR Z
C       LAXIS IS 1 FOR Z, 2 FOR X, 3 FOR Y2 AXES. (I.E. INDEX FOR ILOG)
C
      KN=LCORNR + MOD(IAXIS-1,2)
      IF (KN.GT.4)  KN=KN-4
      KPWR=KN+1
      IF(IAXIS.EQ.3) KPWR=LCORNR
      IF(KPWR.GT.4) KPWR=KPWR-4
      KAXIS=MOD(KN-1,2)+1
      IF(IAXIS.EQ.3) KAXIS=3
      SUBS=AMAX1(1.0,AINT(ASCALE(4,KAXIS)))
      TICS=AMAX1(1.0,ASCALE(3,KAXIS))
      IPWR=MOD(ISCALE(3,KAXIS)+500,1000) - 500
      NDECI=(ISCALE(3,KAXIS)+500)/1000
      FDECI=0.10**MAX0(0,NDECI-1)
      PWR=10.**IPWR *FDECI
      TICMAG=ISCALE(2,KAXIS)*10.**IPWR*FDECI/ASCALE(2,KAXIS)
      TICOFF=(ASCALE(1,KAXIS)/PWR-ISCALE(1,KAXIS))
     >        /ISCALE(2,KAXIS)
      TICSEP=FRAMSZ(KAXIS)/TICS*TICMAG
      NTIC=TICS + TICOFF + 1.9999
      BASE1=0.
      IF(COSELV.GE.0.) BASE1=TICLRG*UAZB(IAXIS)
C
C SET XSPACING FOR LABELS
      IF(TITLSZ.NE.0) CSIZE=.015+TITLSZ*.006
C SET ANGLE FOR TITLES AND LABELS
CC..#IFDEF GKSYS
C      CALL GSCHUP(CHUP(1,IAXIS),CHUP(2,IAXIS))
C      CALL GSCHH(CSIZE)
C..#ELIF DGSYS
      CALL DGSET('ANGLE',TANG(IAXIS))
      CALL DGSET('XSPA',CSIZE)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
      JANG=IAXIS
      IF (IAXIS.NE.3) GO TO 110
      JANG=4
C      FINISH Z AXIS
      CALL DP3LIN(0,CORNER(1,KN),CORNER(2,KN),0.)
      CALL DP3LIN(1,CORNER(1,KN),CORNER(2,KN),FRAMSZ(3))
C
C       LOOP OVER THE TICS (MAJOR AND SUB-TICS)
C
  110 MAXCHR=0
      DO 150 IT=1,NTIC
      JT=IT-1
      IF(KN.GE.3.AND.KAXIS.NE.3) JT=NTIC-IT
      LAXIS=MOD(KAXIS,3)+1
      ISUBM=SUBS
      IF(JT.EQ.NTIC-1) ISUBM=1
      IVAL=ISCALE(1,KAXIS)
      IF(ILOG(LAXIS).NE.0) GO TO 115
      IVAL=IVAL+JT*ISCALE(2,KAXIS)
      GO TO 120
  115 IVAL=IVAL+JT
  120 CALL DPRTOA(IVAL*FDECI,TEMP8,NCHR,8,NDECI)
      MAXCHR=MAX0(MAXCHR,NCHR)
C
C       MINOR TIC LOOP (SUB-TICS)
      DO 148 ISUB=1,ISUBM
      ISUB1=ISUB-1
      IF(KN.GE.3.AND.KAXIS.NE.3) ISUB1=ISUBM-ISUB
      FRACT=ISUB1/SUBS
      IF(ILOG(LAXIS).EQ.0) GO TO 125
      FRACT=LOGTAB(ISUB1+1)
      IF(ISUB1.EQ.1.AND.ISUBM.EQ.2) FRACT=LOGTAB(5)
C
C       FILL BEGINNING COORD OF NEXT TIC
  125 TEMP=(JT+FRACT-TICOFF)*TICSEP
      TICOUT=TEMP*(TEMP-FRAMSZ(KAXIS))
      TEMP=AMAX1(0.,AMIN1(FRAMSZ(KAXIS),TEMP))
      IF(KN.GE.3.AND.KAXIS.NE.3) TEMP=FRAMSZ(KAXIS)-TEMP
C
      DO 130 J=1,2
  130 TICXY(J)=CORNER(J,KN)+TEMP*UA(KN,J)*UAZB(IAXIS)
      TICXY(3)=TEMP*UAZ(IAXIS)
C
      TICLEN=TICLRG
C       NO LABELS FOR TICS LOCATED OUTSIDE OF FRAME
      IF(TICOUT.GT.0.001) GO TO 140
C       LEAVE OUT LAST TIC LABEL WHERE AXES 1 AND 2 MEET.
      IF(TICOUT.GT.-0.001 .AND. IAXIS.EQ.1) GO TO 140
      TICLEN=TICSML
      IF(ISUB1.NE.0) GO TO 140
      TICLEN=TICLRG
C
C       PUT UP LABEL FOR THIS MAJOR TIC
C   NOTATION:
C       A = PERP DIST FROM AXIS LINE TO MIDDLE OF CHARACTER TAG
C       B = DIST FROM THERE TO BEGINNING OF CHARACTER TAG,
C            ALONG DIRECTION OF AXIS.
C       A,B ARE MEASURED IN DEVICE COORDINATES AS IS CSIZE.
C       TANG IS ANGLE OF PROJECTED AXIS IN DEVICE COORDINATES,
C            I.E. AS SEEN ON THE ACTUAL PAPER.
C
      IF(IAXIS.NE.3) GO TO 132
C       SETUP STARTING COORD OF TAG FOR Z AXIS
      CALL DP3LIN(-1,TICXY(1),TICXY(2),TICXY(3))
      XPRO=XPRO-0.6*TICLEN-(NCHR-.5)*CSIZE/DXMAG
      GO TO 133
C
  132 CALL DP3LIN(-1,TICXY(1),TICXY(2),TICXY(3)-BASE1)
C       SETUP STARTING COORD OF TAG FOR XY AXES
CCC   A = 1.5*CSIZE*UPTAG
      A = (0.0075+1.0*CSIZE)*UPTAG
C..#IFDEF DGSYS
      CALL DGSET('ALIGN',3)
CC..#ELIF GKSYS
C      CALL GSTXAL(2,3)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
      XPRO = XPRO + A*SINT(JANG)
      YPRO = YPRO - A*COST(JANG)
C
  133 IF(ILOG(LAXIS).EQ.0) GO TO 135
C..#IFDEF DGSYS
      xpro=xpro-csize/dxmag	!!!!! patch for BUG ?
      CALL DGSET('ALIGN',2)
      CALL DGTXT(XPRO,YPRO,'10')
CC..#ELIF GKSYS
C      CALL GSTXAL(3,3)
C      CALL GTX(XPRO,YPRO,'10')
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
      A = -0.5*CSIZE*UPTAG
C     B = 0.9*CSIZE
      B = -0.9*CSIZE		!!!!! patch for BUG ?
C..#IFDEF DGSYS
      CALL DGSET('ALIGN',1)
CC..#ELIF GKSYS
C      CALL GSTXAL(1,3)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
      XPRO = XPRO + (A*SINT(IAXIS) - B*COST(IAXIS))/DXMAG
      YPRO = YPRO - A*COST(IAXIS) - B*SINT(IAXIS)
CC..#IFDEF GKSYS
C      CALL GQCHH(IGERR,XSPAC)
C      CALL GSCHH(.75*CSIZE)
C      CALL GTX(XPRO,YPRO,TEMP8(1:NCHR))
C      CALL GSCHH(XSPAC)
C      GO TO 140
C  135 CALL GTX(XPRO,YPRO,TEMP8(1:NCHR))
C..#ELIF DGSYS
      CALL DGGET('XSPA',XSPAC)
      CALL DGSET('XSPA',.75*CSIZE)
      CALL DGTXT(XPRO,YPRO,TEMP8(1:NCHR))
      CALL DGSET('XSPA',XSPAC)
      GO TO 140
  135 CALL DGTXT(XPRO,YPRO,TEMP8(1:NCHR))
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
C
C       DRAW THE TIC
  140 CONTINUE
      IF(ISUB.NE.1.AND.TICOUT.GT.-0.001) GO TO 148
      CALL DP3LIN(0,TICXY(1),TICXY(2),TICXY(3))
      XDRAW(1)=XPRO
      YDRAW(1)=YPRO
      IF(IAXIS.NE.3) CALL DP3LIN(-1,TICXY(1),TICXY(2),TICXY(3)-TICLEN)
      IF(IAXIS.EQ.3) XPRO=XPRO-0.5*TICLEN/DXMAG
      XDRAW(2)=XPRO
      YDRAW(2)=YPRO
CC..#IFDEF GKSYS
C      CALL GPL(2,XDRAW,YDRAW)
C..#ELIF DGSYS
      CALL DGLNS(XDRAW,YDRAW,2)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
  148 CONTINUE
  150 CONTINUE
C..#IFDEF DGSYS
      CALL DGSET('ALIGN',1)
CC..#ELIF GKSYS
C      CALL GSTXAL(1,3)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
C
C PUT UP EXPONENT, IF NEEDED
      IF(IPWR.EQ.0) GO TO 153
      CALL DPITOA(IPWR,CTEMP,NCHR,4,10)
      IF(IAXIS.EQ.3) GO TO 151
      TX=CORNER(1,KN) + UAZB(KAXIS)*.80*FRAMSZ(1)*UAX(KN)
      TY=CORNER(2,KN) + UAZB(KAXIS)*.80*FRAMSZ(2)*UAY(KN)
      CALL DP3LIN(-1,TX,TY,EXPZ(IAXIS)-BASE1)
CCC   A = 3.5*CSIZE*UPTAG
      A = (0.020+2.5*CSIZE)*UPTAG
      TX = XPRO + A*SINT(JANG)
      TY = YPRO - A*COST(JANG)
      GO TO 152
  151 CALL DP3LIN(-1,CORNER(1,KPWR),CORNER(2,KPWR),EXPZ(IAXIS)-BASE1)
      TX = XPRO-2.5*CSIZE
      TY = YPRO+0.06+.55*CSIZE
CC..#IFDEF GKSYS
C  152 CALL GSTXAL(3,3)
C      CALL GTX(TX,TY,'X10')
C..#ELIF DGSYS
  152 CALL DGSET('ALIGN',2)
      CALL DGTXT(TX,TY,'X10')
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
        B = 0.9*CSIZE
      TX=TX-(0.5*CSIZE*SINT(IAXIS)-B*COST(IAXIS))/DXMAG
      TY=TY+0.5*CSIZE*COST(IAXIS)+B*SINT(IAXIS)
CC..#IFDEF GKSYS
C      CALL GSCHH(0.75*CSIZE)
C      CALL GSTXAL(1,3)
C      CALL GTX(TX,TY,CTEMP(1:NCHR))
C      CALL GSCHH(CSIZE)
C..#ELIF DGSYS
      CALL DGSET('XSPA',0.75*CSIZE)
      CALL DGSET('ALIGN',1)
      CALL DGTXT(TX,TY,CTEMP(1:NCHR))
      CALL DGSET('XSPA',CSIZE)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
  153 CONTINUE
C
C      ALL DONE PUTTING UP TICS FOR THIS AXIS,
C      NOW PUT UP SUB-TITLE
C
      NCHR=LENTI(KAXIS+1)
      TX=CORNER(1,KN) + UAZB(KAXIS)*.50*FRAMSZ(1)*UAX(KN)
      TY=CORNER(2,KN) + UAZB(KAXIS)*.50*FRAMSZ(2)*UAY(KN)
      CALL DP3LIN(-1,TX,TY,TITZ(IAXIS)-BASE1)
CCC   A = 4.0*UPTAG*CSIZE
      A = (0.028+2.6*CSIZE)*UPTAG
CCC   IF(IPWR.NE.0) A = 5.5*CSIZE)*UPTAG
      IF(IPWR.NE.0) A = (0.037+3.6*CSIZE)*UPTAG
C     IF(IAXIS.EQ.3) A = -0.5*TICLEN-(MAXCHR+.5)*CSIZE/DXMAG
      IF(IAXIS.EQ.3) A = -0.5*TICLEN-(MAXCHR+.5)*CSIZE
      IF(TITLSZ.NE.0) CSIZE=.015+TITLSZ*.007
CC..#IFDEF GKSYS
C      IF(IAXIS.EQ.3) CALL GSCHUP(-1.0,0.)
C      CALL GSTXAL(2,3)
C..#ELIF DGSYS
      IF(IAXIS.EQ.3) CALL DGSET('ANGLE',90.)
      CALL DGSET('ALIGN',3)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
C     XPRO = XPRO + (A*SINT(JANG) - B*COST(JANG))/DXMAG
      XPRO = XPRO + A*SINT(JANG)
      YPRO = YPRO - A*COST(JANG)
      IF(IAXIS.EQ.3) XPRO=AMAX1(XBOX(1)+.60*CSIZE/DXMAG,
     >                    XPRO-.8*CSIZE/DXMAG)
CC..#IFDEF GKSYS
C      CALL GSCHH(CSIZE)
C      CALL GTX(XPRO,YPRO,SUBTI(LOCTI(KAXIS+1)+1:LOCTI(KAXIS+1)+NCHR))
C      CALL GSTXAL(1,3)
C..#ELIF DGSYS
      if (iaxis.eq.3.and.ilog(1).ne.0) xpro=xpro-2.*csize/dxmag !!!!! patch
      CALL DGSET('XSPA',CSIZE)
      CALL DGTXT(XPRO,YPRO,SUBTI(LOCTI(KAXIS+1)+1:LOCTI(KAXIS+1)+NCHR))
      CALL DGSET('ALIGN',1)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
  155 CONTINUE
C
C       RESTORE CHARACTER SIZE TO WHAT IT WAS BEFORE ENTRY TO DPGR2
CC..#IFDEF GKSYS
C      CALL GSCHH(XSPA)
C      CALL GSCHUP(0.,1.0)
C      CALL GSTXAL(1,3)
C..#ELIF DGSYS
      CALL DGSET('XSPA',XSPA)
      CALL DGSET('ANGLE',0.)
      CALL DGSET('ALIGN',1)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
C
C       DONE PUTTING UP FRAME,
C       NOW PUT UP THE DATA POINTS
C
C INITIALIZE DP3LIN FOR HIDDEN LINE REMOVAL
  158 LHIDE=IHIDE
      CALL DPGR2L(FX,FY,FZ,FZE,NX,NY,CORNER,LCORNR,FRAMSZ)
C
      IF(FRAME.EQ.0) GO TO 500
C
C FINISH OFF THE BASE LINES (MAY BE HIDDEN)
      DO 210 JUP=1,2
      INVIS=0
      DO 206 I=3,5
      KN=MOD( (I-2) +LCORNR,4) + 1
      CALL DP3LIN(INVIS,CORNER(1,KN),CORNER(2,KN),ZUPD(JUP))
  206 INVIS=1
      IF(JUP.NE.1.OR.IUPDW.NE.2) GO TO 210
C      DRAW VERTICLE LINES AT EACH CORNER OF BASE BOX
      DO 208 I=1,4
      CALL DP3LIN(0,CORNER(1,I),CORNER(2,I),ZUPD(1))
  208 CALL DP3LIN(1,CORNER(1,I),CORNER(2,I),ZUPD(2))
  210 CONTINUE
C
  500 CONTINUE
C
      LHIDE=0
C
      RETURN
      END
      SUBROUTINE DPGR2L(FX,FY,FZ,FZE,NX,NY,CORNER,LCORNR,FRAMSZ)
C
C  DRAWS PROJECTION OF A 3-D SURFACE GIVEN BY FZ(I,J) VS FX(I),FY(J).
C  DRAWN AS A SERIES OF LINES OR HISTS, OR A MESH OR LEGO PLOT.
C       G2LINS = 0,  DRAW LINES ALONG X BY STEPPING ALONG I.
C                1,  DRAW LINES ALONG Y BY STEPPING ALONG J.
C                2,  DRAW MESH, STEPPING FIRST ALONG I
C                3,  DRAW MESH, STEPPING FIRST ALONG J.
C                4,  DRAW HISTS ALONG X BY STEPPING ALONG I.
C                5,  DRAW HISTS ALONG Y BY STEPPING ALONG J.
C                6,  DRAW LEGO, STEPPING FIRST ALONG I
C                7,  DRAW LEGO, STEPPING FIRST ALONG J.
C
C  THE CLOSEST LINE SEGMENTS ARE PUT OUT FIRST IN ORDER SO THAT
C  THE HIDDEN LINE REMOVAL CAN BE DONE BY DP3LIN.
C
      EXTERNAL FX,  FY,  FZ,  FZE
C
      INCLUDE 'dpmode.INC'
      INCLUDE 'dcom3d.INC'
      INCLUDE 'dabort.INC'
C
      EQUIVALENCE (XMIN,ASCALE(1,1)),(DX,ASCALE(2,1)),
     >            (YMIN,ASCALE(1,2)),(DY,ASCALE(2,2)),
     >            (ZMIN,ASCALE(1,3)),(DZ,ASCALE(2,3))
C
      REAL CORNER(2,5),FRAMSZ(3)
      INTEGER IDELS(4,2)
      INTEGER ICNT(2),MXCNT(2),IBEG(2),IDEL(2),IZDEL(2),IZEDEL(2)
      LOGICAL BOTH, HALFI, HALFJ, VIS(2)
      REAL B1(2),B2(2),DIRN(2),REG(2),RLAST(2)
      REAL P(2),PL(2),W(2),WL(2)
      DATA IDELS/1,-1,-1,1, 1,1,-1,-1/
C
      IF(NX.LE.0 .OR. NY.LE.0) RETURN
C
      PDX=FRAMSZ(1)/ASCALE(3,1)/ASCALE(2,1)
      PDY=FRAMSZ(2)/ASCALE(3,2)/ASCALE(2,2)
      PDZ=FRAMSZ(3)/ASCALE(3,3)/ASCALE(2,3)
C
      K=1
      IF (MOD(G2LINS,2).NE.0) K=2
      M=3-K
      BOTH=(MOD(G2LINS/2,2).EQ.1)
      IHIST=MOD(G2LINS/4,2)
      KNEAR=MOD(LCORNR,4)+1
      KFAR=MOD(KNEAR+1,4)+1
C
C MXCNT IS ONE LARGER IN ORDER TO DRAW LAST EDGE LINE.
C  (AND ALSO, THE FIRST LOOP SAVES X,Y COORDS BUT DOESN'T PLOT THEM).
      MXCNT(1)=NX+1
      MXCNT(2)=NY+1
      DO 100 I=1,2
      IDEL(I)=IDELS(KNEAR,I)
      ICNT(I)=1
      VIS(I)=.FALSE.
      IF(IDEL(I).LT.0) GO TO 90
      IBEG(I)=0
      DIRN(I)=1.0
      B1(I)=CORNER(I,1)
      B2(I)=CORNER(I,3)
      GO TO 95
   90 IBEG(I)=MXCNT(I)+1
      DIRN(I)=-1.0
      B1(I)=CORNER(I,3)
      B2(I)=CORNER(I,1)
   95 IZDEL(I)=MIN0(1,MAX0(0,IDEL(I)))
      IZEDEL(I)=IZDEL(I)
  100 CONTINUE
      IZDEL(K)=IZDEL(K)-IDEL(K)
      HALFI=.FALSE.
      HALFJ=.FALSE.
C     IF(LOWIN.EQ.0.OR.BINCEN.EQ.0) GO TO 110
C     IF(BOTH.AND.IHIST.EQ.1) GO TO 110
C     IF(IHIST.EQ.0.OR.K.EQ.2) HALFI=.TRUE.
C     IF(IHIST.EQ.0.OR.K.EQ.1) HALFJ=.TRUE.
      IF(IHIST.EQ.0) THEN
         IF(LOWIN.NE.0.AND.BINCEN.NE.0) THEN
            IF(BOTH.OR.K.EQ.1) HALFJ=.TRUE.
            IF(BOTH.OR.K.EQ.2) HALFI=.TRUE.
         ENDIF
      ELSE
         IF(LOWIN.EQ.0) THEN
            IF(BOTH.OR.K.EQ.1) HALFJ=.TRUE.
            IF(BOTH.OR.K.EQ.2) HALFI=.TRUE.
         ENDIF
      ENDIF
C
  110 ILAST=0
      JLAST=0
C
C TOP OF LOOP, FOR BOTH I AND J INDICES
C
C COMPUTE NEXT J INDEX
C
  160 J=IBEG(2)+ICNT(2)*IDEL(2)
      IF(J.EQ.JLAST) GO TO 200
      IF(IABORT.NE.0) RETURN
      JLAST=J
      PL(2)=P(2)
      WL(2)=W(2)
      RLAST(2)=REG(2)
      IF(.NOT.HALFJ) GO TO 164
        YLAST=Y
        Y=FY(J)
        IF(ICNT(2).EQ.1) THEN
           YLAST=Y-(FY(J+IDEL(2))-Y)
        ENDIF
        YW=(Y-YLAST)*DIRN(2)
        YC=Y-YW/2.0
CL    IF(ICNT(2).EQ.1) YNEXT=FY(J)
CL    Y=YNEXT
CL    IF(ICNT(2).GE.MXCNT(2)) GO TO 200
CL    YNEXT=FY(J+IDEL(2))
CL    YC=Y+0.5*(Y-YNEXT)*DIRN(2)
      GO TO 166
  164 YC=FY(J)
  166 IF(ILOG(3).EQ.0) GO TO 180
      IF(YC.GT.0.0) GO TO 170
      YC=YMIN
      GO TO 180
  170 YC=ALOG10(YC)
  180 W(2)=(YC-YMIN)*PDY+CORNER(2,1)
      P(2)=AMIN1(YH,AMAX1(YL,W(2)))
      REG(2)=0.
      IF(DIRN(2)*(W(2)-B1(2)).LT.0.0) REG(2)=-1.0
      IF(DIRN(2)*(W(2)-B2(2)).GT.0.0) REG(2)=1.0
  200 CONTINUE
C
C COMPUTE NEXT I INDEX
C
  210 I=IBEG(1)+ICNT(1)*IDEL(1)
      IF(I.EQ.ILAST) GO TO 250
      ILAST=I
C
      PL(1)=P(1)
      WL(1)=W(1)
      RLAST(1)=REG(1)
      IF(.NOT.HALFI) GO TO 214
        XLAST=X
        X=FX(I)
        IF(ICNT(1).EQ.1) THEN
           XLAST=X-(FX(I+IDEL(1))-X)
        ENDIF
        XW=(X-XLAST)*DIRN(1)
        XC=X-XW/2.0
CL    IF(ICNT(1).EQ.1) XNEXT=FX(I)
CL    X=XNEXT
CL    IF(ICNT(1).GE.MXCNT(1)) GO TO 250
CL    XNEXT=FX(I+IDEL(1))
CL    XC=X+0.5*(X-XNEXT)*DIRN(1)
      GO TO 216
  214 XC=FX(I)
  216 IF(ILOG(2).EQ.0) GO TO 230
      IF(XC.GT.0.0) GO TO 220
      XC=XMIN
      GO TO 230
  220 XC=ALOG10(XC)
  230 W(1)=(XC-XMIN)*PDX+CORNER(1,1)
      P(1)=AMIN1(XH,AMAX1(XL,W(1)))
      REG(1)=0.
      IF(DIRN(1)*(W(1)-B1(1)).LT.0.0) REG(1)=-1.0
      IF(DIRN(1)*(W(1)-B2(1)).GT.0.0) REG(1)=1.0
  250 CONTINUE
C
C COMPUTE Z COORDINATE
C
  260 IF(ICNT(M).LE.1) GO TO 800
      ZWL=ZW
      IF(ICNT(M).GT.MXCNT(M)) GO TO 300
      IZ=I-IZDEL(1)
      JZ=J-IZDEL(2)
      IF(IZ.LE.0.OR.JZ.LE.0.OR.IZ.GT.NX.OR.JZ.GT.NY) THEN
         Z=ZMIN
      ELSE
         Z=FZ(IZ,JZ)
      ENDIF
CCCC  Z=FZ(I-IZDEL(1),J-IZDEL(2))
      IF(ILOG(1).EQ.0) GO TO 280
      IF(Z.GT.0.0) GO TO 270
      Z=ZMIN
      GO TO 280
  270 Z=ALOG10(Z)
  280 ZW=(Z-ZMIN)*PDZ
      ZKL=ZW
      ZLL=ZWL
CCCCC IF(UPDWN*ZKM.LT.0.) ZKM=0.
C FOR MESH MODE, ALSO COMPUTE NEXT Z IN M DIRECTION
      IF(IHIST.EQ.1.OR..NOT.BOTH) GO TO 295
      ZWL1=ZW1
CCCC  IF(K.EQ.1) Z=FZ(I-IZDEL(1),J-IZDEL(2)+IDEL(2))
      IF(K.EQ.1) JZ=JZ+IDEL(2)
CCCC  IF(K.EQ.2) Z=FZ(I-IZDEL(1)+IDEL(1),J-IZDEL(2))
      IF(K.EQ.2) IZ=IZ+IDEL(1)
      IF(IZ.LE.0.OR.JZ.LE.0.OR.IZ.GT.NX.OR.JZ.GT.NY) THEN
         Z=ZMIN
      ELSE
         Z=FZ(IZ,JZ)
      ENDIF
CCC   IF(K.EQ.1) Z=FZ(I-IZDEL(1),J-IZDEL(2)+IDEL(2))
CCC   IF(K.EQ.2) Z=FZ(I-IZDEL(1)+IDEL(1),J-IZDEL(2))
      IF(ILOG(1).EQ.0) GO TO 290
      IF(Z.GT.0.0) GO TO 285
      Z=ZMIN
      GO TO 290
  285 Z=ALOG10(Z)
  290 ZW1=(Z-ZMIN)*PDZ
      ZKM=ZW1
      ZLM=ZWL1
  295 IF(ICNT(K).LE.1) GO TO 800
C
C NOW THAT WE HAVE THE X,Y,Z OF NEW POINT, PUT IT UP.
C
  300 IF(IHIST.EQ.0) GO TO 500
C
C DO THE HISTOGRAM SHEETS OR LEGO PLOTS
 
      IF(BOTH) GO TO 330
C
C ITS A HISTOGRAM SHEET STYLE PLOT
C
      IF(VIS(K)) GO TO 320
      IF(REG(K).LT.0.0 .OR. RLAST(M).NE.0.0) GO TO 800
      VIS(K)=.TRUE.
      IF(K.EQ.1) CALL DP3LIN(0,CORNER(1,KNEAR),PL(2),0.)
      IF(K.EQ.1) CALL DP3LIN(1,CORNER(1,KFAR ),PL(2),0.)
      IF(K.EQ.2) CALL DP3LIN(0,PL(1),CORNER(2,KNEAR),0.)
      IF(K.EQ.2) CALL DP3LIN(1,PL(1),CORNER(2,KFAR ),0.)
      CALL DP3LIN(0,PL(1),PL(2),0.)
  320 CALL DP3LIN(1,PL(1),PL(2),ZLL)
      IF(K.EQ.1) CALL DP3LIN(1,P(1),PL(2),ZLL)
      IF(K.EQ.2) CALL DP3LIN(1,PL(1),P(2),ZLL)
      IF(REG(K).GT.0.0) GO TO 325
      IF(ICNT(K).NE.MXCNT(K)) GO TO 800
  325 IF(K.EQ.1) CALL DP3LIN(1,P(1),PL(2),0.)
      IF(K.EQ.2) CALL DP3LIN(1,PL(1),P(2),0.)
      GO TO 810
C
C ITS A LEGO PLOT
C
  330 CONTINUE
      IF(REG(1).LT.0.0 .OR. REG(2).LT.0.0) GO TO 800
      IF(RLAST(1).GT.0.0 .OR. RLAST(2).GT.0.0) GO TO 800
C
      IF(ZLL.EQ.0.0) GO TO 460
      CALL DP3LIN(0,PL(1),PL(2),0.)
      CALL DP3LIN(1,PL(1),PL(2),ZLL)
      IF(MOD(ERRS,2).EQ.0 .OR. COSELV*ZLL.LT.0.) GO TO 430
      XM=0.5*(WL(1)+W(1))
      IF((XM-XL)*(XM-XH).GT.0.0) GO TO 430
      YM=0.5*(WL(2)+W(2))
      IF((YM-YL)*(YM-YH).GT.0.0) GO TO 430
      ZHI=FZ(I-IZEDEL(1),J-IZEDEL(2))+SIGN(1.,COSELV)
     >                  *FZE(I-IZEDEL(1),J-IZEDEL(2),1)
      IF(ILOG(1).EQ.0) GO TO 420
      IF(ZHI.GT.0.0) GO TO 410
      ZHI=ZMIN
      GO TO 420
  410 ZHI=ALOG10(ZHI)
  420 ZHI=(ZHI-ZMIN)*PDZ
      CALL DP3LIN(0,XM,YM,ZLL)
      CALL DP3LIN(1,XM,YM,ZHI)
  430 CALL DP3LIN(0,P(1),PL(2),ZLL)
      CALL DP3LIN(1,P(1),PL(2),0.)
      CALL DP3LIN(1,PL(1),PL(2),0.)
      CALL DP3LIN(1,PL(1),P(2),0.)
      CALL DP3LIN(1,PL(1),P(2),ZLL)
      CALL DP3LIN(1,PL(1),PL(2),ZLL)
      CALL DP3LIN(1,P(1),PL(2),ZLL)
      IF(COSELV*ZLL.LT.0.) GO TO 455
  450 CALL DP3LIN(1,P(1),P(2),ZLL)
      CALL DP3LIN(1,PL(1),P(2),ZLL)
      GO TO 800
  455 CALL DP3LIN(0,PL(1),P(2),0.)
      GO TO 465
C       ZKM=0., DRAW THE BASE ONLY
  460 CALL DP3LIN(0,P(1),PL(2),0.)
      CALL DP3LIN(1,PL(1),PL(2),0.)
      CALL DP3LIN(1,PL(1),P(2),0.)
  465 CALL DP3LIN(1,P(1),P(2),0.)
      CALL DP3LIN(1,P(1),PL(2),0.)
      GO TO 800
C
C DRAW LINE STYLE PLOTS OR MESH PLOTS
C
  500 IF(BOTH) GO TO 600
C
C DRAW LINE STYLE SHEETS
C
  520 IF(VIS(K)) GO TO 530
      IF(REG(K).LT.0.0 .OR. RLAST(M).NE.0.0) GO TO 800
      VIS(K)=.TRUE.
      IF(W(K).NE.WL(K).AND.PL(K).NE.WL(K))
     >  ZLL=ZWL+(ZW-ZWL)/(W(K)-WL(K))*(B1(K)-WL(K))
      IF(K.EQ.1) CALL DP3LIN(0,CORNER(1,KNEAR),PL(2),0.)
      IF(K.EQ.1) CALL DP3LIN(1,CORNER(1,KFAR ),PL(2),0.)
      IF(K.EQ.2) CALL DP3LIN(0,PL(1),CORNER(2,KNEAR),0.)
      IF(K.EQ.2) CALL DP3LIN(1,PL(1),CORNER(2,KFAR ),0.)
      CALL DP3LIN(0,PL(1),PL(2),0.)
  530 CALL DP3LIN(1,PL(1),PL(2),ZLL)
      IF(REG(K).GT.0.0.AND.W(K).NE.WL(K)) ZKL=ZWL +
     >      (ZW-ZWL)/(W(K)-WL(K))*(P(K)-WL(K))
      IF(RLAST(K).GT.0.0) GO TO 535
      IF(ICNT(K).LT.MXCNT(K)) GO TO 800
  535 CALL DP3LIN(1,PL(1),PL(2),0.0)
      GO TO 810
C
  600 CONTINUE
C
C DRAW MESH PLOTS
C
      IF(REG(M).LT.0.0 .OR. RLAST(M).GT.0.0) GO TO 810
      IF(REG(K).LT.0.0 .OR. RLAST(K).GT.0.0) GO TO 800
      IF(VIS(K)) GO TO 605
      IF(W(K).EQ.WL(K).OR.PL(K).EQ.WL(K)) GO TO 610
      ZLL=ZWL+(ZW-ZWL)/(W(K)-WL(K))*(PL(K)-WL(K))
      ZLM=ZWL1+(ZW1-ZWL1)/(W(K)-WL(K))*(PL(K)-WL(K))
  605 IF(REG(K).LE.0.0 .OR. W(K).EQ.WL(K)) GO TO 610
      ZKL=ZWL+(ZW-ZWL)/(W(K)-WL(K))*(P(K)-WL(K))
      ZKM=ZWL1+(ZW1-ZWL1)/(W(K)-WL(K))*(P(K)-WL(K))
  610 IF(VIS(M)) GO TO 615
      IF(W(M).EQ.WL(M).OR.PL(M).EQ.WL(M)) GO TO 618
      ZTMP=ZLL+(ZLM-ZLL)/(W(M)-WL(M))*(PL(M)-WL(M))
      ZKL=ZKL+(ZKM-ZKL)/(W(M)-WL(M))*(PL(M)-WL(M))
      ZLL=ZTMP
  615 IF(REG(M).LE.0.0 .OR. W(M).EQ.WL(M)) GO TO 618
      ZTMP=ZKL+(ZKM-ZKL)/(W(M)-WL(M))*(P(M)-WL(M))
      ZLM=ZLL+(ZLM-ZLL)/(W(M)-WL(M))*(P(M)-WL(M))
      ZKM=ZTMP
C
  618 IF(VIS(K)) GO TO 650
      VIS(K)=.TRUE.
      IF(VIS(M)) GO TO 620
C       UPRIGHT AT ZLL
      CALL DP3LIN(0,PL(1),PL(2),0.0)
      CALL DP3LIN(1,PL(1),PL(2),ZLL)
C      BONDARY AT B1(K)
  620 CALL DP3LIN(0,PL(1),PL(2),ZLL)
      IF(K.EQ.1) CALL DP3LIN(1,PL(1),P(2),ZLM)
      IF(K.EQ.2) CALL DP3LIN(1,P(1),PL(2),ZLM)
      IF(REG(M).LE.0.0.AND.ICNT(M).LT.MXCNT(M)) GO TO 650
C      UPRIGHT AT ZLM
      IF(K.EQ.1) CALL DP3LIN(1,PL(1),P(2),0.0)
      IF(K.EQ.2) CALL DP3LIN(1,P(1),PL(2),0.0)
  650 IF(VIS(M)) GO TO 680
C      BOUNDARY AT B1(M)
      CALL DP3LIN(0,PL(1),PL(2),ZLL)
      IF(K.EQ.1) CALL DP3LIN(1,P(1),PL(2),ZKL)
      IF(K.EQ.2) CALL DP3LIN(1,PL(1),P(2),ZKL)
      IF(REG(K).LE.0.0.AND.ICNT(M).LT.MXCNT(M)) GO TO 680
C      UPRIGHT AT ZKL
      IF(K.EQ.1) CALL DP3LIN(1,P(1),PL(2),0.0)
      IF(K.EQ.2) CALL DP3LIN(1,PL(1),P(2),0.0)
  680 IF(K.EQ.1) CALL DP3LIN(0,PL(1),P(2),ZLM)
      IF(K.EQ.2) CALL DP3LIN(0,P(1),PL(2),ZLM)
      CALL DP3LIN(1,P(1),P(2),ZKM)
      IF(K.EQ.1) CALL DP3LIN(1,P(1),PL(2),ZKL)
      IF(K.EQ.2) CALL DP3LIN(1,PL(1),P(2),ZKL)
      IF(B2(K).NE.P(K).OR.B2(M).NE.P(M)) GO TO 800
C      UPRIGHT AT ZKM
      CALL DP3LIN(0,P(1),P(2),ZKM)
      CALL DP3LIN(1,P(1),P(2),0.0)
C
  800 CONTINUE
C
C RE-INITIATE I AND J LOOPS UNTIL DONE
C
      ICNT(K)=ICNT(K)+1
      IF(ICNT(K).LE.MXCNT(K)) GO TO 160
  810 ICNT(K)=1
      VIS(K)=.FALSE.
      ICNT(M)=ICNT(M)+1
      IF(REG(M).GE.0.0 .AND. ICNT(M).GT.2) VIS(M)=.TRUE.
      IF(ICNT(M).LE.MXCNT(M)) GO TO 160
C
C      IF(BOTH) RETURN
C
C FOR MESH OR LEGO PLOTS, PUT IN THE BASE LINES OF THE DATA
C  (ENABLE HIDDEN LINES)
C      LHIDE=0
C      CALL DP3LIN(0,XP,YP1,0.)
C      CALL DP3LIN(1,XP1,YP1,0.)
C      CALL DP3LIN(1,XP1,YP,0.)
C      LHIDE=IHIDE
C
      RETURN
      END
      SUBROUTINE DP3LIN(IC, X3, Y3, Z3)
C
C   DP3LIN TRANSFORMS THE 3-D POINT (X3,Y3,Z3) TO THE 2-D PROJECTED
C   COORD (XPRO,YPRO), AND ADDS THIS VECTOR TO THE GRAPHIC ELEMENT.
C   HIDDEN LINES ARE REMOVED IF LHIDE IS TRUE.
C
C   IC = -1, THE PROJECTED COORDS ARE COMPUTED BUT NOT DRAWN.
C   IC = 0,  INITIALIZES A VECTOR TO THE PROJECTED COORDS.
C   IC = 1,  DRAWS THE PROJECTED VECTOR TO THE NEW END POINT.
C
C   THE VARIABLES IN /DCOM3D/ ARE USED FOR THE PROJECTION.
C
C           HANDYPAK ROUTINE
C            A. BOYARSKI
C
C
      INCLUDE 'dcom3d.INC'
C
      REAL XVEC(2),YVEC(2),XDRAW(2),YDRAW(2)
      REAL XHF(2),YHF(2)
      LOGICAL CLIP
      REAL YBOX(2)
C
C FOLLOWING STATEMENT FUNCTIONS PROVIDE PROJECTION COORDS
C
      X2D(X3P,Y3P    )=X2C+X3P*COSROT+XROT0+Y3P*SINROT
      Y2D(X3P,Y3P,Z3P)=Y2C+(-X3P*SINROT+YROT0+Y3P*COSROT)*COSELV+
     >              (Z3P-Z3C)*SINELV
      DATA YBOX/.05,.90/
C
CCCC      AROT=X3*COSROT+XROT0+Y3*SINROT
CCCC      AELV=-X3*SINROT+YROT0+Y3*COSROT
C  USE NEXT THREE CARDS FOR TRUE PERSPECTIVE
C     ALL=EYED/(EYED+AELV*SINELV+(Z3C-Z3)*COSELV)
C     XPRO=X2C+AROT*ALL
C     YPRO=Y2C+(AELV*COSELV+(Z3-Z3C)*SINELV)*ALL
CCCC      XPRO=X2C+AROT
CCCC      YPRO=Y2C+(AELV*COSELV+(Z3-Z3C)*SINELV)
C
      XPRO=X2D(X3,Y3)
      YPRO=Y2D(X3,Y3,Z3)
C      WRITE(6,5) IC,X3,Y3,Z3,XPRO,YPRO                                   DBUG
C    5 FORMAT(' DP3LIN ENTRY',I4,5F8.3)                                   DBUG
      IF(IC.LT.0) RETURN
      IF(LHIDE.NE.0) GO TO 10
      XDRAW(1)=XDRAW(2)
      YDRAW(1)=YDRAW(2)
      XDRAW(2)=XPRO
      YDRAW(2)=YPRO
CC..#IFDEF GKSYS
C      IF(IC.GT.0) CALL GPL(2,XDRAW,YDRAW)
C..#ELIF DGSYS
      IF(IC.GT.0) CALL DGLNS(XDRAW,YDRAW,2)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
      RETURN
C
   10 IF(IC.EQ.0) GO TO 600
C
      XHF(2)=XPRO
      YHF(2)=YPRO
C
C GET PROJECTIONS OF BOTH ENDS OF THIS VECTOR
C
  100 XVEC(1)=XHF(1)
      YVEC(1)=YHF(1)
      XVEC(2)=XHF(2)
      YVEC(2)=YHF(2)
      CLIP=.FALSE.
C
      IF(YVEC(1).LE.YVEC(2)) GO TO 170
C
C SCISOR ON YLOW, NEG Y VECTOR
C
      IF(YVEC(2).GE.YBOX(1)) GO TO 160
         IF(YVEC(1).LE.YBOX(1)) GO TO 400
         XVEC(2)=XVEC(1)-((YVEC(1)-YBOX(1))/
     >           (YVEC(1)-YVEC(2)))*(XVEC(1)-XVEC(2))
         YVEC(2)=YBOX(1)
         CLIP=.TRUE.
C
C SCISOR ON YHIGH, NEG Y VECTOR
C
  160 IF(YVEC(1).LE.YBOX(2)) GO TO 200
         IF(YVEC(2).GE.YBOX(2)) GO TO 400
         XVEC(1)=XVEC(2)+((YBOX(2)-YVEC(2))/
     >           (YVEC(1)-YVEC(2)))*(XVEC(1)-XVEC(2))
         YVEC(1)=YBOX(2)
         CLIP=.TRUE.
         GO TO 200
C
C SCISOR ON YLOW, POS Y VECTOR
C
  170 IF(YVEC(1).GE.YBOX(1)) GO TO 180
         IF(YVEC(2).LE.YBOX(1)) GO TO 400
         XVEC(1)=XVEC(2)-((YVEC(2)-YBOX(1))/
     >           (YVEC(2)-YVEC(1)))*(XVEC(2)-XVEC(1))
         YVEC(1)=YBOX(1)
         CLIP=.TRUE.
C
C SCISOR ON YHIGH, POS Y VECTOR
C
  180 IF(YVEC(2).LE.YBOX(2)) GO TO 200
         IF(YVEC(1).GE.YBOX(2)) GO TO 400
         XVEC(2)=XVEC(1)+((YBOX(2)-YVEC(1))/
     >           (YVEC(2)-YVEC(1)))*(XVEC(2)-XVEC(1))
         YVEC(2)=YBOX(2)
         CLIP=.TRUE.
C
C DON'T DO HIDDEN LINE REMOVAL IF LHIDE IS 0
  200 IF(LHIDE.NE.0) GO TO 500
CC..#IFDEF GKSYS
C      CALL GPL(2,XVEC,YVEC)
C..#ELIF DGSYS
      CALL DGLNS(XVEC,YVEC,2)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
      GO TO 600
C
  400 CLIP=.TRUE.
      GO TO 510
C
  500 CONTINUE
C
C PUT UP THE VISIBLE PORTION OF THE VECTOR
      CALL DPLH(XVEC,YVEC,2,1)
C UPDATE THE HORIZONS FOR THE FULL (VISIBLE AND INVISIBLE) VECTOR
  510 IF(CLIP) CALL DPLH(XHF,YHF,2,0)
C
C ALL DONE, SAVE THE LAST POINT
  600 XHF(1)=XPRO
      YHF(1)=YPRO
      RETURN
C
      END
      SUBROUTINE DPLH(XVEC,YVEC,NPT,IDRAW)
C
C  DRAWS POLYLINES WITH HIDDEN LINES REMOVED.
C
C    XVEC(I),YVEC(I), I=2,NPT ARE INPUT COORDINATES OF VECTORS
C    TO BE DRAWN. THE FIRST AND LAST POINT ARE NOT JOINED.
C    IF NPT IS 0, THEN THE HEIGHT INTERNAL HEIGHT FUNCTION IS
C    INITIALIZED, AND XVEC(1) AND YVEC(1) ARE INPUT VARIABLES FOR
C    UPDWN (THE UP OR DOWN VERSION OF THE HEIGHT FUNCTION) AND
C    HTOL (THE TOLERANCE FOR TEST OF EQUAL X CORRDINATES).
C
C  EACH PAIR OF POINTS IS TREATED HERE AS AN INDEPENDANT VECTOR.
C  EACH VECTOR IS ANALYSED FOR THOSE PORTIONS ABOVE THE CURRENT HEIGHT
C  FUNCTION AND ONLY THE VISIBLE PORTIONS ARE PLOTTED. THE HEIGHT
C  FUNCTION IS UPDATED WHENEVER A NEW PORTION OF A VECTOR IS PLOTTED.
C
C   DEFINITION OF INTERNAL VARIABLES:
C     (VXA,VYA) AND (VXB,VYB) ARE END POINTS OF THE VECTOR TO BE PLOTTED
C     (VX1,VY1) AND (VX2,VY2) ARE END POINTS OF VECTOR WITHIN THIS
C               SEGMENT OF THE HEIGHT FUNCTION
C     (VX1,HY1) IS POINT ON THE HEIGHT FUNCTION BENEATH VX1
C     (VX2,HY2) IS POINT ON THE HEIGHT FUNCTION BENEATH VX2
C
C  UPDWN = 1.0 (-1.) MEANS LINES ARE DRAWN ABOVE (BELOW) HEIGHT FUNCTION
C
      REAL XVEC(2),YVEC(2),XDRW(2),YDRW(2)
C
      INTEGER HDIM
C ... LARGE 2-D PLOTS NEED MORE STORAGE FOR H FUNCTION
CC..#IFDEF PC_F77L
C      PARAMETER (HDIM=1000)
C..#ELSE
C     PARAMETER (HDIM=4000)
      PARAMETER (HDIM=20000)
C..#ENDIF
      REAL H(HDIM)
      INTEGER IH(HDIM)
      EQUIVALENCE (H(1),IH(1))
C
C  THERE ARE 4 WORDS PER HEIGHT FUNCTION NODE:
C     IH(K  ) IS THE FORWARD POINTER TO NEXT (LARGER X) NODE
C     IH(K+1) IS BACWARD POINTER TO PREVIOUS (LESSER X) NODE
C      H(K+2) IS VALUE OF X AT THIS NODE
C      H(K+3) IS VALUE OF Y AT THIS NODE
C
C     K AND KN ARE THE CURRENT AND NEXT POINTER TO THE HEIGHT FUNCTION
C
      REAL VX(2),VY(2)
      EQUIVALENCE (VX1,VX(1)),(VX2,VX(2)),(VY1,VY(1)),(VY2,VY(2))
C
      IF(NPT.GE.2) GO TO 30
C
C INITIALIZE THE HEIGHT FUNCTION TO 'FREE'
      UPDWN=XVEC(1)
      HTOL=YVEC(1)
      IH(1)=5
      IH(2)=0
      H(3)=-1.E10
      H(4)=-UPDWN*1.E10
      IH(5)=0
      IH(6)=1
      H(7)=1.E10
      H(8)=-UPDWN*1.E10
C
      I2=4*(HDIM/4)-3
      DO 20 I=9,I2,4
      IH(I)=I+4
   20 IH(I+1)=0
      IH(I2)=0
      KFREE=9
      K=1
      RETURN
C
   30 CONTINUE
C
C LOOP OVER ALL POINTS, DRAWING VECTORS AS NEEDED
      DO 500 IVEC=2,NPT
      VXA=XVEC(IVEC-1)
      VXB=XVEC(IVEC)
      VYA=YVEC(IVEC-1)
      VYB=YVEC(IVEC)
C
      IF(VXB.LT.VXA) GO TO 80
C RX TELLS DIRECTION OF X COMPONENT OF PROJECTED VECTOR
      RX=1.0
      KFWD=0
      KBACK=1
      GO TO 200
   80 RX=-1.0
      KFWD=1
      KBACK=0
C
C FIND HEIGHT FUNCTION SEGMENT WHICH CONTAINS FIRST POINT
  200 IF(RX*(H(K+2)-VXA).LE.0.) GO TO 210
      K=IH(K+KBACK)
      GO TO 200
C
  210 KN=IH(K+KFWD)
      IF(RX*(VXA-H(KN+2)).LT.0.) GO TO 220
      K=KN
      GO TO 210
C
  220 IF(ABS(VXA-VXB).GE.HTOL) GO TO 223
C
C ITS A VERTICAL LINE, HANDLE IT SEPARATELY
C ONLY DO THE PLOT, DON'T UPDATE THE HT FUNCTION.
      VYMIN=AMIN1(VYA*UPDWN,VYB*UPDWN)
      VYMAX=AMAX1(VYA*UPDWN,VYB*UPDWN)
      HSLOPE=(H(KN+3)-H(K+3))/(H(KN+2)-H(K+2))
      HY=UPDWN*(H(K+3)+HSLOPE*(VXA-H(K+2)))
  221 KP=IH(K+KBACK)
      IF(KP.EQ.0) GO TO 222
      IF(H(KP+2).NE.VXA) GO TO 222
      HY=AMIN1(HY,UPDWN*H(KP+3))
      K=KP
      GO TO 221
  222 HY=AMAX1(HY,VYMIN)
      IF((HY-VYMAX).GE.0.) GO TO 500
      IF(IDRAW.EQ.0) GO TO 500
      XDRW(1)=VXA
      YDRW(1)=UPDWN*HY
      XDRW(2)=VXA
      YDRW(2)=UPDWN*VYMAX
CC..#IFDEF GKSYS
C      CALL GPL(2,XDRW,YDRW)
C..#ELIF DGSYS
      CALL DGLNS(XDRW,YDRW,2)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
      GO TO 500
C
C SET UP FOR THE LOOP OVER HT SEGMENTS
  223 VX1=VXA
      VY1=VYA
      VSLOPE=(VYA-VYB)/(VXA-VXB)
C
C SET FLAG TO BEGIN A NEW VECTOR
  225 NEWVEC=1
C
C RETURN HERE AFTER EACH HEIGHT SEGMENT
  230 IF(RX*(VXB-H(KN+2)).GT.0.) GO TO 240
      VX2=VXB
      VY2=VYB
      GO TO 250
  240 VX2=H(KN+2)
      VY2=VY1+VSLOPE*(H(KN+2)-VX1)
C
  250 HSLOPE=(H(KN+3)-H(K+3))/(H(KN+2)-H(K+2))
      HY1=H(K+3)+HSLOPE*(VX1-H(K+2))
      DY1=UPDWN*(VY1-HY1)
      IF(ABS(DY1).LT.HTOL) DY1=0.0
      HY2=H(K+3)+HSLOPE*(VX2-H(K+2))
      DY2=UPDWN*(VY2-HY2)
      IF(ABS(DY2).LT.HTOL) DY2=0.0
C
C DETERMINE WHEN TO BEGIN OR END A PLOT VECTOR
C      WRITE(6,255) K,VX1,VY1,VX2,VY2,HY1,HY2,DY1,DY2                    DBUG
C  255 FORMAT(' AT255',I6,8G12.5)                                        DBUG
      IF(DY1.LE.0.0 .AND. DY2.LT.0.0) GO TO 400
      IF(DY1.LT.0.0 .AND. DY2.LE.0.0) GO TO 400
      IF(DY1*DY2.GE.0.0) GO TO 270
C
C VECTOR CROSSES THIS HEIGHT SEGMENT, FIND INTERSECTION POINT
      HX=VX1 + DY1/(DY1-DY2)*(VX2-VX1)
      HY=H(K+3) + HSLOPE*(HX-H(K+2))
      IF(DY1.GE.0.0) GO TO 265
         VX1=HX
         VY1=HY
         DY1=0.0
         GO TO 270
  265 VX2=HX
      VY2=HY
      HY2=HY
      DY2=0.0
C
  270 IF(NEWVEC.EQ.0) GO TO 275
C
C START A NEW VECTOR AND SAVE ITS COORDS FOR UPDATE TO HEIGHT FUNCTION
  272 IF(IDRAW.NE.0) THEN
         XDRW(2)=VX1
         YDRW(2)=VY1
      ENDIF
      NEWVEC=0
C      WRITE(6,273) VX1,VY1                                              DBUG
C  273 FORMAT(1X,'AT273 DGLIN',2G12.4,' 0')                              DBUG
      KBEG=K
      XBEG=VX1
      VYBEG=VY1
      HYBEG=H(K+3)+HSLOPE*(VX1-H(K+2))
C
C END THE VECTOR, IFF NEEDED
  275 IF(RX*(H(KN+2)-VXB).GE.0.) GO TO 300
      IF(DY2.GT.0.0) GO TO 400
C      IF(RX*(VSLOPE-HSLOPE).GT.0.0) GO TO 400
C      IF(RX*(H(KN+2)-VX2).GT.0.0) GO TO 300
CC CONTINUE THE VECTOR IF NEXT SEG NOT TOO STEEP
C      KNN=IH(KN+KFWD)
C      VYNN=VY2 + VSLOPE*(H(KNN+2)-VX2)
C      IF(UPDWN*(VYNN-H(KNN+3)).GE.0.0) GO TO 400
C
  300 IF(IDRAW.NE.0) THEN
         XDRW(1)=XDRW(2)
         YDRW(1)=YDRW(2)
         XDRW(2)=VX2
         YDRW(2)=VY2
CC..#IFDEF GKSYS
C         CALL GPL(2,XDRW,YDRW)
C..#ELIF DGSYS
         CALL DGLNS(XDRW,YDRW,2)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
      ENDIF
      NEWVEC=1
C      WRITE(6,301) VX2,VY2                                              DBUG
C  301 FORMAT(1X,'AT301 DGLIN',2G12.4,' 1')                              DBUG
C
C UPDATE THE HEIGHT FUNCTION
C  FIRST FREE UP HEIGHT SEGMENTS BELOW PLOTTED VECTOR
  330 K1=KBEG
      KN=IH(K1+KFWD)
      KP=IH(K1+KBACK)
      IF(KP.EQ.0) GO TO 335
      IF(RX*(H(KP+2)-XBEG).LT.0.) GO TO 335
      KBEG=KP
      GO TO 330
C
  335 IF(RX*(H(KN+2)-VX2).LT.0.) GO TO 340
      KNN=IH(KN+KFWD)
      IF(KNN.EQ.0) GO TO 345
      IF(RX*(H(KNN+2)-VX2).GT.0.) GO TO 345
  340 K1=KN
      KN=IH(K1+KFWD)
      IH(K1)=KFREE
      KFREE=K1
      GO TO 335
C
C CHECK FOR ENOUGH FREE SPACE
  345 K1=KFREE
      DO 346 I=1,4
      IF(K1.EQ.0) GO TO 400
  346 K1=IH(K1)
C
C INSERT (VX1,HY1), IF NEEDED
  350 K=KBEG
      IF(H(KBEG+2).EQ.XBEG) GO TO 360
C
      IH(K+KFWD)=KFREE
      K1=KFREE
      KFREE=IH(KFREE)
      IH(K1+KBACK)=K
      H(K1+2)=XBEG
      H(K1+3)=HYBEG
      K=K1
C
C INSERT (VX1,VY1), IF NEEDED
  360 IF(H(K+2).EQ.XBEG.AND.ABS(H(K+3)-VYBEG).LE.HTOL) GO TO 370
C
      IH(K+KFWD)=KFREE
      K1=KFREE
      KFREE=IH(KFREE)
      IH(K1+KBACK)=K
      H(K1+2)=XBEG
      H(K1+3)=VYBEG
      K=K1
C
C INSERT (VX2,VY2), IF NEEDED
  370 IF(H(KN+2).EQ.VX2.AND.ABS(H(KN+3)-VY2).LE.HTOL) GO TO 390
C
      IH(K+KFWD)=KFREE
      K1=KFREE
      KFREE=IH(KFREE)
      IH(K1+KBACK)=K
      H(K1+2)=VX2
      H(K1+3)=VY2
      K=K1
C
C INSERT (VX2,HY2), IF NEEDED
  380 IF(H(KN+2).EQ.VX2) GO TO 390
      IF(DY2.EQ.0.0) GO TO 390
C
      IH(K+KFWD)=KFREE
      K1=KFREE
      KFREE=IH(KFREE)
      IH(K1+KBACK)=K
      H(K1+2)=VX2
      H(K1+3)=HY2
      K=K1
C
C LINK UP TO OTHER END NODE
  390 IH(K+KFWD)=KN
      IH(KN+KBACK)=K
C      K1=1                                                              DBUG
C  395 CONTINUE                                                          DBUG
C      WRITE(6,396) K1,IH(K1),IH(K1+1),KN,H(K1+2),H(K1+3)                DBUG
C  396 FORMAT(' HIGT FUNC',4I6,2X,2G15.7)                                DBUG
C      K1=IH(K1)                                                         DBUG
C      IF(K1.NE.0) GO TO 395                                             DBUG
C
  400 IF(RX*(H(KN+2)-VXB).GE.0.) GO TO 500
C
C SET UP THE NEXT SEGMENT LOOP
      VX1=H(KN+2)
      VY1=VY2+VSLOPE*(VX1-VX2)
      N=0
  410 K=KN
      KN=IH(KN+KFWD)
      N=N+1
C      WRITE(6,411) N,K,KN,H(K+2),H(K+3),H(KN+2),H(KN+3)                 DBUG
C  411 FORMAT(1X,'NEXT=',3I6,4G12.5)                                     DBUG
      IF(H(K+2).EQ.H(KN+2)) GO TO 410
      IF(N.EQ.1) GO TO 230
C ITS A VERTICAL SEGMENT OF HEIGHT FUNCTION, NEED TO CHECK IF
C VECTOR CROSSES THIS VERTICAL SEGMENT
      DY=UPDWN*(H(K+3)-VY2)
      IF(DY2*DY.LT.0.0) GO TO 230
C IT CROSSES, SO NEED TO BEGIN OR END THE VECTOR
      IF(DY2.LT.0.0) GO TO 225
      IF(DY2.GT.0.0) GO TO 300
      IF(DY1.LT.0.0 .AND. DY.LE.0.0) GO TO 225
      GO TO 230
C
  500 CONTINUE
      RETURN
C
      END
