      SUBROUTINE HEXEC(IARG,F,NF,C,NC)
C
C   **MEMBER** HEXEC
C
C   THIS IS THE GENERAL DISPLAY DRIVER FOR HISTOGRAMS IN /HCOM/.
C   THE ID THAT IS STORED IN /DPMODE/ DETERMINES WHICH DISPLAY
C   IS TO BE MADE.
C
      INCLUDE 'dpmode.INC'
#include      "hcom.INC2"
      INCLUDE 'dcomfp.INC'
      INCLUDE 'dcomtc.INC'
      INCLUDE 'dcscal.INC'
C
      EXTERNAL HX,HY,H2Y,HZ,HYE,HZE
      INTEGER HPNTR
      REAL SCALES(4,4)
#if   defined(__OSF1)
      INTEGER*8 OFFSET
#else
      INTEGER*4 OFFSET
#endif
#if   defined(__OSF1) && !defined(__TASO)
      PARAMETER (OFFSET='100000000'X)	! may not work on other systems...
#else
      PARAMETER (OFFSET=0)
#endif
C
C       IF IARG IS SUPPLIED, THEN USE IT AS THE ID.
      NARG=NARGS()
      IF(NARG.GT.0) IDARG=IARG
C
C       WHAT DEVICE ARE WE TO PERFORM ON ? (CLEAR, LP, SCOPE)
C
      IF(IDEV.GT.1) GO TO 10
C
C       ITS A CLEAR OPERATION (NOT REALLY A DEVICE)
      CALL HCLR(IDARG)
      GO TO 60
C
C       ASSURE THAT THIS HISTOGRAM EXISTS
C
   10 IF(HPNTR(IDARG).LE.0) GO TO 60
C       HEXEC ONLY HANDLES 1-D AND 2-D HISTS, SO CHECK ND
      ND=M(NODE+5)
      IF(ND.LT.1.OR.ND.GT.2) GO TO 60
C
C  Fill SCALE array from default HSCALE, or from hist (if set).
      MDISP=NODE+M(NODE+14)
      DO 18 I=1,3
         DO 16 J=1,4
         IF(R(MDISP+2+4*I+3).NE.0.0) THEN
            SCALES(J,I)=R(MDISP+J+4*I+3)
         ELSE
            SCALES(J,I)=HSCALE(J,I)
         ENDIF
   16    CONTINUE
   18 CONTINUE
      SCALES(1,4)=ROTANG
      IF(R(MDISP+20).NE.0.0) SCALES(1,4)=R(MDISP+20)
      SCALES(2,4)=ELVANG
      IF(R(MDISP+21).NE.0.0) SCALES(2,4)=R(MDISP+21)
C
      CALL HEXEC1(0)
C
      MPARM=NODE+M(NODE+10)
      MTITL=NODE+M(NODE+13)
      MDISP=NODE+M(NODE+14)
      NX=0
      NY=0
      IF(M(NODE+12).LE.0) GO TO 20
      NX=M(MPARM+5)
      IF(M(MPARM+1).EQ.15) NX=M(NODE+M(NODE+12)+2)
      NY=M(MPARM+9)
C
C      IS THIS A SCATTER PLOT, AND IS IT TO BE PLOTTED AS SUCH?
   20 IF(ND.EQ.2.AND.M(MPARM+13).GT.0.AND.M(MDISP+7).EQ.0
     >  .AND.IDEV.GT.2.AND.SLICE.EQ.0) THEN
C
C        NUMBER OF BYTES IN TITLE
         CALL DPTH2C(M(MTITL+1),CTITLE,NTB)
C        DO SCATTERPOINT PLOT
         CALL HSCPLT(CTITLE(1:NTB))
C
      ELSEIF(ND.EQ.1) THEN
         JMULT=IMULT
C          Allow unlimited number of points (beyond default 1000)
         IMULT=1000000
         CALL NARGSET(8)
         IF(NARG.GE.3) THEN
            CALL DUT1(HX,HY,HYE,NX,M(MTITL+1),SCALES,F,NF)
         ELSE
C..#IFDEF VAX_VMS
            CALL DUT1(HX,HY,HYE,NX,M(MTITL+1),
     >        SCALES,%VAL(M(MDISP+3)+OFFSET),M(MDISP+4))
CC..#ELSE
C           CALL DUT1(HX,HY,HYE,NX,M(MTITL+1),
C    >        SCALES,M(MDISP+3),M(MDISP+4))
C..#ENDIF
         ENDIF
         IMULT=JMULT
C
      ELSEIF(ND.EQ.2) THEN
         CALL NARGSET(12)
         IF(NARG.GE.5) THEN
            CALL DUT2(HX,H2Y,HZ,HZE,NX,NY,
     >        M(MTITL+1),SCALES,F,NF,C,NC)
         ELSEIF(NARG.GE.3) THEN
            CALL DUT2(HX,H2Y,HZ,HZE,NX,NY,
     >        M(MTITL+1),SCALES,F,NF,0,0)
         ELSE
C..#IFDEF VAX_VMS
            CALL DUT2(HX,H2Y,HZ,HZE,NX,NY,
     >           M(MTITL+1),SCALES,%VAL(M(MDISP+3)+OFFSET),M(MDISP+4),
     >               %VAL(M(MPARM+16)+OFFSET),M(MPARM+17))
CC..#ELSE
C           CALL DUT2(HX,H2Y,HZ,HZE,NX,NY,
C    >           M(MTITL+1),SCALES,M(MDISP+3),M(MDISP+4),
C    >           M(MPARM+16),M(MPARM+17))
C..#ENDIF
         ENDIF
C
      ENDIF
C
C       RESTORE ANY OPTIONS THAT WERE SET FROM THE NODE
      CALL HEXEC1(1)
C
   60 IF(NARG.GT.0) IDARG=0
      RETURN
C
      END
