      SUBROUTINE HEXEC1(II)
C
C  **MEMBER** HEXEC1
C
C HEXEC1 IS CALLED BY HEXEC. IT HANDLES THE FILLING AND RESTORING
C OF /DPMODE/ OPTIONS FROM THOSE STORED IN THE HISTOGRAM IN /HCOM/.
C
C   II = 0 MEANS FILL DPMODE FROM THE HISTOGRAM.
C   II = 1 MEANS RESTORE DPMODE AS IT WAS BEFORE II=0 CASE .
C
#include      "hcom.INC"
      INCLUDE 'dpmode.INC'
      INCLUDE 'dcomfp.INC'
C
      INTEGER IMODE(1)
      REAL RMODE(1)
      EQUIVALENCE (IDEV,IMODE(1),RMODE(1))
      INTEGER DSAVE(68)
      INTEGER ITEM(68)
      LOGICAL LTMP
      EQUIVALENCE (LTMP,ITMP)
C
      INTEGER IDX(9),JEDGE(2)
      INTEGER BLANK,HCUM,BINS
      CHARACTER*4 CTMP
C
      DATA DSAVE/68*0/
C
C ITEM PROVIDES THE LOCATION IN IMODE FOR THE OPTION SPECIFIED
C IN THE OPTS ARRAY IN SUBPROGRAM HOPTN1.
C
      DATA ITEM/
     >   8,  9, 10, 11, 12,
     >  13, 15, 16,119,  0,
     1  39, 40, 41, 42, 55,
     >  56, 57, 60,  0, 63,
     2  64, 65, 67, 68, 69,
     >  80, 81, 85,108,116,
     3   0,  0,  1,  5,  6,
     >   7, 17, 18, 19, 20,
     4  21, 22, 23, 24, 25,
     >  26, 45, 62, 70, 71,
     5  77, 36, 66,107, 37,
     >  74, 58, 59,149,  0,
     6 123,124,125,126,141,
     > 142,143,144/
C
      DATA BLANK/4H    /,IDX/4,1,7,3,0,6,5,2,8/,HCUM,BINS/4HHCUM,4HBINS/
C       IDX TRANSLATES ORDER OF OVERFLOW WORDS IN HCOM TO DPMODE.
C
C
C ASSUME THAT NODE ALREADY POINTS TO THE DESIRED HISTOGRAM
C
C MAKE SURE THIS A 1 OR 2-D HIST
      IF(M(NODE+5).LT.1.OR.M(NODE+5).GT.2) RETURN
C
      MOPT=NODE+M(NODE+14)+15
      IF(M(NODE+5).EQ.2) MOPT=MOPT+6
C
C SAVE CURRENT DEVICE NUMBER
      IDEVS=IMODE(1)
C
      IF(II.EQ.1) GO TO 200
C
C ------------------------------------------------------------------
C
C TRANSFER HISTOGRAM OPTIONS TO DPMODE.
C
      ND=M(NODE+5)
      ISTAT1=ISTATS
      LOWIN1=LOWIN
      LOWIN=1
      STATYP=BINS
      FYMAX1=FYMAX
C       ERRS CAN BE SET FOR EFF/ASM, LATER ON. SO SAVE HERE.
      ERRSV=ERRS
C
C       SET UP POINTERS
C
      MPARM=NODE+M(NODE+10)
      MDISP=NODE+M(NODE+14)
      IDA=M(NODE+6)
C      SET TO ASYMMETRIC ERRORS IF ASM OR EFF, WITH YALT )
      IMS=M(MPARM+1)
      IF(IMS.GE.9.AND.IMS.LE.14.AND.M(MDISP+6).EQ.0) ERRS=2
C      SET OMIT, BASED ON SETTING OF HOMIT
      JEDGE(1)=IEDGE(1)
      JEDGE(2)=IEDGE(2)
      ITMP=1
      IF(M(MPARM+3).NE.0) ITMP=0
      IEDGE(1)=ITMP
      IEDGE(2)=ITMP
C
C -------------------------------------------------------------------
C
C TRANSFER HISTOGRAM DISPLAY OPTIONS TO DPNODE
C
      DO 100 I=1,3
      ITEMP=M(MOPT+I)
      DO 80 J=1,32
      IF(ITEMP.EQ.0) GO TO 100
      IF(ITEMP.GT.0) GO TO 80
C
C STATUS BIT J IN WORD I IS ON, SO HANDLE THIS ITEM
C
      JJ=32*(I-1)+J
      IF(JJ.GT.68) GO TO 500
      K=ITEM(JJ)
      IF(K.EQ.0) GO TO 80
      DSAVE(JJ)=IMODE(K)
C
C WHAT GROUP IS THIS ITEM IN ? (BIT, BYTE, HALF, OR WORD)
C
CREAL      IF(JJ.GT.68) GO TO 70
      IF(JJ.GT.58) GO TO 60
      IF(JJ.GT.56) GO TO 50
      IF(JJ.GT.32) GO TO 40
C BIT DATA
CCC   MASK=ISHFT(1,32-JJ)
C RPLACE PREVIOUS STATEMENT WITH NEXT 3, PROFORT COMPILER BUG
      KB32=32-JJ
      KB16=MOD(KB32,16)
      MASK=ISHFT(ISHFT(1,KB16),KB32-KB16)
      IMODE(K)=0
      IF(IAND(M(MOPT+4),MASK).NE.0) IMODE(K)=1
      GO TO 80
C
C BYTE DATA
C       CHAR option needs special treatment
   40 IF(K.EQ.45) THEN
         WRITE(CTMP,'(A1)') L(4*MOPT+JJ-32+16)
         READ (CTMP,'(A4)') IMODE(K)
      ELSE
         LTMP=L(4*MOPT+JJ-32+16)
         IMODE(K)=ITMP
      ENDIF
      GO TO 80
C
C HALFWORD INTEGER DATA
   50 IMODE(K)=H(2*MOPT+JJ-56+20)
      GO TO 80
C
C HALFWORD (100.*REAL) DATA
   60 RMODE(K)=H(2*MOPT+JJ-58+22)/1000.
      GO TO 80
C
C REAL WORD DATA (NOT USED)
CREAL   70 RMODE(K)=R(MOPT+JJ-68+16)
C
   80 ITEMP=ISHFT(ITEMP,1)
C
  100 CONTINUE
C
C ------------------------------------------------------------------
C
C      SET FYMAX, IF THIS IS 'L*1' OR 'I*2'
      FYMAX=0.
      IF(R(MDISP+1).EQ.0.0) GO TO 111
      IF(M(MPARM+1).EQ.1) FYMAX=L1MAX/R(MDISP+1)
      IF(M(MPARM+1).EQ.2) FYMAX=I2MAX/R(MDISP+1)
      IF(M(MPARM+1).EQ.3) FYMAX=FLOAT(I4MAX)/R(MDISP+1)
C
C       FILL NUMBER OF CALLS FROM HCOM INTO DPMODE
  111 NWCALL=0
      IF(M(NODE+12).LE.0) GO TO 115
      LMBIN=NODE+M(NODE+12)+M(MPARM+2)
      IF(M(MPARM+3).NE.0) GO TO 112
      NWCALL=1
      NCALLS(1)=M(LMBIN)
      GO TO 115
  112 IF(ND.EQ.2) GO TO 113
      NWCALL=3
      NCALLS(1)=M(LMBIN-1)
      NCALLS(2)=M(LMBIN)
      NCALLS(3)=M(LMBIN-2)
      GO TO 115
  113 DO 114 I=1,9
  114 NCALLS(I)=M(LMBIN-IDX(I))
      NWCALL=9
C
C       CALCULATE MEANS AND SIGMAS, IF SO INSTRUCTED (ISTAT.NE.0)
C
  115 IF(ISTATS.EQ.0.AND.M(MDISP+2).EQ.0) GO TO 120
C
C       ISTATS=1 -- MEANS STATISTICS IN /DPMODE/ ARE FILLED AND
C                    SHOULD BE DISPLAYED BY THE DUT'S.
C       ISTATS=2 -- MEANS STATISTICS ARE TO BE CALCULATED ONLY.
C       ISTATS=3 -- MEANS STATISTICS ARE TO BE CALCULATED AND DISPLAYED
C
      IF(ISTATS.NE.2) ISTATS=3
      IF(M(NODE+11).EQ.0.OR.SLICE.NE.0) GO TO 120
C      IF USER SPECIFIED LIMITS FOR STATS, THEN CALC. STATS FROM BINS
      IF(ISLIM1.NE.0.OR.ISLIM2.NE.0) GO TO 120
      IF(ND.EQ.2.AND.(ISLIM3.NE.0.OR.ISLIM4.NE.0)) GO TO 120
      MSTATS=NODE+M(NODE+11)
C
C       GO CALCULATE THE MEANS AND SIGMA'S (ENTRY POINT IN DSTAT2)
C
      CALL HSFILL(ND,R(MSTATS+1),D((MSTATS/2)+1))
      IF(ISTATS.EQ.3) ISTATS=1
      IF(ISTATS.EQ.2) ISTATS=0
      STATYP=HCUM
C
  120 CONTINUE
C
      GO TO 500
C
C ------------------------------------------------------------------
C ------------------------------------------------------------------
C
C RESTORE DPMODE FROM THE SAVED VALUES IN DSAVE
C
  200 DO 300 I=1,3
      ITEMP=M(MOPT+I)
      DO 280 J=1,32
      IF(ITEMP.EQ.0) GO TO 300
      IF(ITEMP.GT.0) GO TO 280
      JJ=32*(I-1)+J
      IF(JJ.GT.68) GO TO 350
      K=ITEM(JJ)
      IF(K.EQ.0) GO TO 280
      IMODE(K)=DSAVE(JJ)
  280 ITEMP=ISHFT(ITEMP,1)
  300 CONTINUE
C
C ------------------------------------------------------------------
C
C RESTORE ANY OPTIONS THAT WERE SET FROM THE NODE
C
  350 ISTATS=ISTAT1
      LOWIN=LOWIN1
      IDA=BLANK
      STATYP=BLANK
      NWCALL=0
      FYMAX=FYMAX1
      ERRS=ERRSV
      IEDGE(1)=JEDGE(1)
      IEDGE(2)=JEDGE(2)
C
C
C IF DEVICE NUMBER HAS CHANGED, SELECT THE NEW ONE
C
  500 IF(IDEVS.NE.IMODE(1)) CALL DPSLCT(DEVTYP(IMODE(1)))
C
      RETURN
      END
