      SUBROUTINE HMAP
C
C   **MEMBER** HMAP
C
C  MAKE A MAP OF THE MEMORY UTILIZATION IN THE /HCOM/ MEMORY POOL.
C
C
#include      "hcom.INC"
C
      WRITE(6,20) (M(I+SHMOFS),I=1,17)
   20 FORMAT('1  MEMORY MAP OF /HCOM/        # OF NODES =',I6/,
     >  '0M(2-17)=',15I6,A6)
C
C
      IF(NNODES.LE.0) RETURN
      WRITE(6,30)
   30 FORMAT(' NODE     LOC  HSHPTR  HASHID  SEQPTR      ID   ',
     > 'CLASS    A4ID  NODSIZ  USRINIT NPNTRS  OFFSETS....')
C
      NODE=NODE1+SHMOFS
      DO 100 INODE=1,NNODES
      IF(INODE.NE.1) NODE=M(NODE+3)+SHMOFS
      LAST=9+MIN0(6,M(NODE+9))
      WRITE(6,50,ERR=100) INODE,NODE,(M(NODE+I),I=1,LAST)
   50 FORMAT(I5,4I8,4X,I4,I8,A8,9I7)
  100 CONTINUE
      WRITE(6,110) NODEND,M(NODEND+SHMOFS+1)
  110 FORMAT('0NODEND =',I6,'    BACKWARD POINTER =',I6)
C
C       HASH TABLES
      WRITE(6,150) (M(HSHLOC+SHMOFS+I-1),I=1,HSHLEN)
  150 FORMAT(//' HASH POINTERS',/(1X,10I6,3X,10I6))
      WRITE(6,160) (M(HSHCNT+SHMOFS+I-1),I=1,HSHLEN)
  160 FORMAT(//' HASH COUNTERS',/(1X,10I6,3X,10I6))
      RETURN
      END
