      SUBROUTINE DGSCRN(CMND)
C
C  **MEMBER** DGSCRN
C
C  DGSCRN FLIPS TEK4010 SCREEN TO ALPHANUMERIC OR GRAPHIC MODE.
C
C    CALL DGSCRN('GRAF')    FLIPS TO GRAPHIC SCREEN
C    CALL DGSCRN('TEXT')    FLIPS TO TEXT (ALPHANUMERIC) MODE
C
C    CALL DGESC(CMND,STRG,LEN) STORES ESCAPE STRINGS
C
C
      INCLUDE 'dpmode.INC'
C
      CHARACTER*4 CMND,CLOS,GRAF,TEXT,ESCG,ESCT
C     LOGICAL*1 G(40),T(40),STRG(1)
      CHARACTER*1 G(40),T(40),STRG(1),ESC
      CHARACTER*1 HEX(16),CLPAR
      CHARACTER*40 CSTR
      CHARACTER*3 CTEK
#if   defined(__OSF1)
      PARAMETER (EXC='')
#else
      PARAMETER (ESC=Z'1B')
#endif
      DATA CLOS/'CLOS'/,GRAF/'GRAF'/,TEXT/'TEXT'/
      DATA ESCG/'ESCG'/,ESCT/'ESCT'/,CLPAR/')'/
C
CC..#IFDEF VM_CMS
C     DATA G/Z27,1H",1H0,1Hg,Z27,1H7,Z27,1H[,1H6,1H0,3*1H;,1H6,1H0,1Hp,
C    >       24*1H /
C     DATA T/Z27,1H",1H0,1Hg,Z27,1H[,3*1H;,1H4,1H8,1Hp,Z27,1H8,26*1H /
C     DATA LENG/16/, LENT/14/
C..#ELIF VAX_VMS
      DATA G/ESC,1H",1H0,1Hg,ESC,1H7,ESC,1H[,1H6,1H0,3*1H;,1H6,1H0,1Hp,
     >       24*1H /
      DATA T/ESC,1H",1H0,1Hg,ESC,1H[,3*1H;,1H4,1H8,1Hp,ESC,1H8,26*1H /
      DATA LENG/16/, LENT/14/
CC..#ELSE
C     DATA G/40*1H /, T/40*1H /
C     DATA LENG/ 0/, LENT/ 0/
C..#ENDIF
C
      DATA HEX/'0','1','2','3','4','5','6','7',
     >         '8','9','A','B','C','D','E','F'/
C
C
C WHEN CALLED BY DPCLOS, FLIP TO TEXT IF POSSIBLE.
      IF(CMND.NE.CLOS) GO TO 10
         GO TO 25
C
   10 WRITE(CTEK,'(A3)') DEVTYP(IDEV)
      IF(CTEK.NE.'TEK') RETURN
C
      IF(CMND.NE.GRAF) GO TO 20
         IF(LENG.LE.0) RETURN
CC..#IFDEF VM_CMS
C        IRET=IWRASC(G,LENG)
C..#ELIF VAX_VMS
C        WRITE(5,'(1X,40A1)') (G(I),I=1,LENG)
CC..#ELSE
         WRITE(*,'(1X,40A1)') (G(I),I=1,LENG)
C..#ENDIF
         SCREEN=1
         RETURN
C
   20 IF(CMND.NE.TEXT) RETURN
   25    IF(LENT.LE.0) RETURN
CC..#IFDEF VM_CMS
C        IRET=IWRASC(T,LENT)
C..#ELIF VAX_VMS
C        WRITE(5,'(1X,40A1)') (T(I),I=1,LENT)
CC..#ELSE
         WRITE(*,'(1X,40A1)') (T(I),I=1,LENT)
C..#ENDIF
         SCREEN=0
         RETURN
C
C
      ENTRY DGESC(CMND,STRG,LEN)
C
      IF(LEN.LE.0) GO TO 200
      L=MIN0(LEN,40)
C
      WRITE(CSTR,'(40A1)') (STRG(I),I=1,L)
C
C FIRST CHARACTER IS 'Z' FOR HEX INPUT STRING
      IF(CSTR(1:1).NE.'Z') GO TO 140
C
C UNPACK HEX-PAIRED DIGITS
      IF(L.LE.2) GO TO 200
      DO 120 J=2,L,2
      I=J/2
      I1=-1
      I2=-1
      DO 110 K=1,16
      IF(CSTR(J:J)  .EQ.HEX(K)) I1=K-1
  110 IF(CSTR(J+1:J+1).EQ.HEX(K)) I2=K-1
      IF(I1.LT.0.OR.I2.LT.0) GO TO 200
      IF(CMND.NE.ESCG) GO TO 115
      READ(CSTR(J:J+1),'(Z2)') G(I)
      LENG=I
      GO TO 120
  115 IF(CMND.NE.ESCT) GO TO 120
      READ(CSTR(J:J+1),'(Z2)') T(I)
      LENT=I
  120 CONTINUE
      RETURN
C
C UNPACK SIMPLE STRING
  140 DO 150 I=1,L
      IF(CMND.EQ.ESCG) G(I)=STRG(I)
  150 IF(CMND.EQ.ESCT) T(I)=STRG(I)
      IF(CMND.EQ.ESCG) LENG=L
      IF(CMND.EQ.ESCT) LENT=L
      RETURN
C
  200 WRITE(ERUNIT,210) CMND,(STRG(I),I=1,L),CLPAR
  210 FORMAT(' DOPT ',A4,' has bad HEX data(=',41A1)
      RETURN
      END
