      SUBROUTINE DJOBDAY(I,VAL)
C
C
C   IF I=0, THEN VAL RETURNS 8-CHARACTER JOBNAME STRING;
C           'JOBNAME' WHEN CALLED FROM BATCH JOB, OR
C           'UUUHH:MM', WHERE UUU IS ACCOUNT ID AND HH:MM IS TIME,
C           WHEN CALLED FROM USER'S OWN VIRTUAL MACHINE.
C   IF I=1, THEN VAL RETURNS AN 8-CHARACTER DATE STRING.
C   IF I=2, THEN VAL RETURNS AN 8-CHARACTER TIME STRING.
C
      CHARACTER VAL*8
C
CC..#IFDEF VM_CMS
C     CHARACTER A(2)*8
C     INTEGER NOW(8)
C     CHARACTER*3 MON(12)/'JAN','FEB','MAR','APR','MAY','JUN',
C    >                    'JUL','AUG','SEP','OCT','NOV','DEC'/
CC
CC
C     CALL DATIM(NOW)
CC     DATIM is an IBM FORTVS library routine which
CC     returns NOW(3) = seconds (0-59)
CC                 4  = minutes (0-59)
CC                 5  = hour (0-23)
CC                 6  = day of the month (1-31)
CC                 7  = month of the year (1-12)
CC                 8  = year (4 digits).
CC
C     IF(I.EQ.0) THEN
CC
CC         GET NAME
CC
C        J=IQJOB(A,2)
CC       IQJOB is a SLAC routine which
CC       returns A(1) = jobname, or '********' if not batch
CC               A(2) = userid
CC
C        IF(A(1).EQ.'********') THEN
CC            this user is running interactively on cms
CC            (use 3-character account and time instead of jobname)
C           WRITE(VAL,'(A,I2,'':'',I2)') A(2)(1:3),NOW(5),NOW(4)
C           IF(VAL(4:4).EQ.' ') VAL(4:4)='0'
C           IF(VAL(7:7).EQ.' ') VAL(7:7)='0'
CC
C        ELSE
CC             THIS USER IS RUNNING IN BATCH - GET JOB NAME
C           VAL=A(1)
C        ENDIF
CC
C     ELSEIF(I.EQ.1) THEN
CC
CC         GET DATE
CC
C        WRITE(VAL,'(1X,I2,A3,I2)') NOW(6),MON(NOW(7)),MOD(NOW(8),100)
C        IF(VAL(7:7).EQ.' ') VAL(7:7)='0'
C     ELSE
CC
CC         GET TIME
CC
C     WRITE(VAL,'(I2,'':'',I2)') NOW(5),NOW(4)
C        IF(VAL(4:4).EQ.' ') VAL(4:4)='0'
C     ENDIF
C..#ELIF VAX_VMS
C     LOGICAL*1 L1(12),DATIDX(7)
C     DATA DATIDX/1,2,4,5,6,8,9/
CC
C     IF(I.EQ.0) THEN
C        CALL TIME(L1)
C        WRITE(VAL,'(8A1)') (L1(J),J=1,8)
C     ELSEIF(I.EQ.1) THEN
C        CALL DATE(L1)
C        WRITE(VAL,'(1X,7A1)') (L1(DATIDX(J)),J=1,7)
C     ELSE
C        CALL TIME(L1)
C        WRITE(VAL,'(8A1)') (L1(J),J=1,8)
C     ENDIF
CC..#ELIF PC_F77L
CC    F77L routines return date and time as follows:
CC    'MM/DD/YY' in DATE and 'HH:MM' in TIME (':SS' discarded)
CC
C     IF(I.EQ.0) THEN
C        VAL='PCJOB'
C     ELSEIF(I.EQ.1) THEN
C        CALL DATE(VAL(2:8))
C        VAL(1:1)=' '
C     ELSE
C        CALL TIME(VAL)
C     ENDIF
CC..#ELIF UNIX
C     CHARACTER*3 MON(12)/'JAN','FEB','MAR','APR','MAY','JUN',
C    >                    'JUL','AUG','SEP','OCT','NOV','DEC'/
CC
C     IF(I.EQ.0) THEN
C        VAL = 'UNIX'
C     ELSEIF(I.EQ.1) THEN
C        CALL fdate(IYR,IMO,IDA)
C        WRITE(VAL,'(I2,A3,I2)') IDA,MON(IMO),IYR
C     ELSE
C        CALL ftime(ISECS)
C        WRITE(VAL,'(I2,'':'',I2)') ISECS/3600,MOD(ISECS/60,60)
C        IF(VAL(4:4).EQ.' ') VAL(4:4)='0'
C     ENDIF
CC..#ELSE
      CHARACTER*24 FDATE,S
      IF (I.EQ.0) THEN
         VAL = 'UNIX'
      ELSEIF(I.EQ.1) THEN
         S = FDATE()
         WRITE(VAL,'(A2,A3,A2)') S(9:10),S(5:7),S(23:24)
      ELSE
         S = FDATE()
         WRITE(VAL,'(A5)') S(12:16)
      ENDIF
C..#ENDIF
C
      RETURN
C
      END
