      SUBROUTINE DPGAVG(X,Y)
C
C  **MEMBER** DPGAVG
C
C  PUTS UP THE STATISTICS FOR 1-D PLOTS ON GRAPHIC DEVICES
C  AT THE BEGINNING POINT (X,Y) ON THE PLOT.
C
      INCLUDE 'dpmode.INC'
      INCLUDE 'dcomli.INC'
      CHARACTER*255 BUF2C
      EQUIVALENCE (BUF2(1),BUF2C)
C
      CHARACTER*1 PLUS,MINUS,CLPAR,E,BLNK
C
      CHARACTER*1 ITEM(7,2)
      INTEGER NTEM(2)
C
      REAL VAL(2,2)
      EQUIVALENCE (VAL(1,1),XAVG)
      DATA PLUS,MINUS,CLPAR,E,BLNK/'+','-',')','E',' '/
      DATA ITEM/'<','X','>','=','(',' ',' ',
     >          ' ',' ',' ','S','D','=','('/
      DATA NTEM/5,7/
C
C  DEFINE ROUNDING FUNCTION
      IRND(XX)=XX+SIGN(.5,XX)
C
      N=1
C
C DO XAVG AND XDAVG ON FIRST PASS, XSIG AND XDSIG ON SECOND
C
      DO 100 J=1,2
      TEMP1=ABS(VAL(1,J))
      TEMP2=ABS(VAL(2,J))
      IF(TEMP1.GT.100.*TEMP2) GO TO 10
C       ERROR DETERMINES THE EXPONENT
      IP=2
      IF(TEMP2.GT.0.0) IP=ALOG10(TEMP2)
      IF(TEMP2.LT.1.0) IP=IP-1
C       ALLOW FOR 2 DIGITS
      IP=IP-1
      GO TO 20
C       VALUE DETERMINES THE EXPONENT
   10 IP=4
      IF(TEMP1.GT.0.0) IP=ALOG10(TEMP1)
      IF(TEMP1.LT.1.0) IP=IP-1
C       ALLOW FOR 4 DIGITS
      IP=IP-3
   20 PX=10.**IP
C
      KL=NTEM(J)
      DO 30 K=1,KL
   30 BUF2(N+K-1)=ITEM(K,J)
      N=N+KL
      CALL DPITOA(IRND(VAL(1,J)/PX),BUF2(N),NCHR,5,10)
      N=N+NCHR
      BUF2(N)=BLNK
      BUF2(N+1)=PLUS
      BUF2(N+2)=MINUS
      BUF2(N+3)=BLNK
      N=N+4
      CALL DPITOA(IRND(VAL(2,J)/PX),BUF2(N),NCHR,4,10)
      N=N+NCHR
      BUF2(N)=CLPAR
      BUF2(N+1)=E
      N=N+2
      CALL DPITOA(IP,BUF2(N),NCHR,3,10)
      N=N+NCHR
  100 CONTINUE
C
      K=N-1
C..#IFDEF DGSYS
      CALL DGTXT(X,Y,BUF2C(1:K))
CC..#ELIF GKSYS
C      CALL GTX(X,Y,BUF2C(1:K))
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
      RETURN
      END
