      SUBROUTINE DPLIMS
C
C   **MEMBER** DPLIMS
C
C       SET SCALING LIMITS FOR THIS DEVICE BY APPLYING THE OFFSET
C       AND SIZE IN GOFSET AND GSIZE TO THE ORIGINAL SCREEN SIZE
C
      INCLUDE 'dpmode.INC'
      INCLUDE 'dcomwn.INC'
C
      REAL DLIMIT(4),PLIMIT(4)
CC..#IFDEF GKSYS
C      REAL RWINDO(4),CWINDO(4),RVIEWP(4),CVIEWP(4)
C      INTEGER TUS
C..#ENDIF
C
C       CAN ONLY DO THIS FOR GRAPHIC DEVICES.
      IF(IDEV.LE.2) RETURN
C
C       SET DEVICE LIMITS
CC..#IFDEF GKSYS
C      CALL GQWKT(IDEV,IER,TUS,RWINDO,CWINDO,RVIEWP,CVIEWP)
C      IF(RWINDO(2).GT.0.0 .AND. RWINDO(4).GT.0.0) THEN
C         XR=RWINDO(2)
C         YR=RWINDO(4)
C      ELSE
CC        metafile device - set manually
C         XR=1.0
C         YR=1.0
C       return
C      ENDIF
C..#ELIF DGSYS
      CALL UGDSPC('GET',XR,YR,AFF)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
C       CALCULATE SIZES FOR THIS WINDOW, IF WINDOWING IS ON
      IF(WINDOW.EQ.0.OR.IWNDW(IDEV).LE.0) GO TO 68
      XWNDW=XR/NXWNDW
      YWNDW=YR/NYWNDW
      DLIMIT(1)=MOD(IWNDW(IDEV)-1,NXWNDW)*XWNDW + GOFSET(1)*XWNDW
      DLIMIT(2)=((NWNDWS-IWNDW(IDEV))/NXWNDW)*YWNDW + GOFSET(2)*YWNDW
      DLIMIT(3)=DLIMIT(1) + GSIZE(1)*XWNDW
      DLIMIT(4)=DLIMIT(2) + GSIZE(2)*YWNDW
      GO TO 69
   68 DLIMIT(1)=GOFSET(1)*XR
      DLIMIT(2)=GOFSET(2)*YR
      DLIMIT(3)=DLIMIT(1)+GSIZE(1)*XR
      DLIMIT(4)=DLIMIT(2)+GSIZE(2)*YR
   69 PLIMIT(1)=(1.-XR)/2.
      PLIMIT(2)=(1.-YR)/2.
      PLIMIT(3)=PLIMIT(1)+XR
      PLIMIT(4)=PLIMIT(2)+YR
C       SET PROGRAMMER LIMITS, IF CHARACTERS AND MARGINS ARE TO
C       REMAIN FIXED IN SIZE.
      IF(CHSCAL.NE.0) GO TO 70
      RX=PLIMIT(3)-PLIMIT(1)
      RY=PLIMIT(4)-PLIMIT(2)
      PLIMIT(1)=PLIMIT(1)+GOFSET(1)*RX
      PLIMIT(2)=PLIMIT(2)+GOFSET(2)*RY
      PLIMIT(3)=PLIMIT(1)+GSIZE(1)*RX
      PLIMIT(4)=PLIMIT(2)+GSIZE(2)*RY
   70 CONTINUE
CC..#IFDEF GKSYS
C      CALL GSWN(1,PLIMIT(1),PLIMIT(3),PLIMIT(2),PLIMIT(4))
C      CALL GSVP(1,DLIMIT(1),DLIMIT(3),DLIMIT(2),DLIMIT(4))
C      CALL GSELNT(1)
C..#ELIF DGSYS
      CALL UGWDOW('PUT',DLIMIT,PLIMIT)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
C
      RETURN
C
      END
