      SUBROUTINE DPWDOW(ICTL,NX,NY,IWDOW)
C
C   **MEMBER** DPWDOW
C
C  SETS THE WINDOWING FOR GRAPHIC DEVICES.
C
C   ICTL   INTEGER (INPUT) TURNS WINDOWING ON/OFF
C                 ICTL = 0  TURN OFF WINDOWING
C                        1  TURN WINDOWING
C                        2  TURN OFF AND THEN ON WINDOWING
C   NX,NY  INTEGER (INPUT) SUPPLY THE NUMBER OF WINDOWS
C                 IF NOT SUPPLIED, 2,2 IS THE DEFAULT.
C   IWDOW  INTEGER (INPUT) IS THE BEGINNING WINDOW
C                 IF NOT SUPPLIED, 1 IS THE DEFAULT.
C
      INCLUDE 'dpmode.INC'
      INCLUDE 'dcomwn.INC'
C
C
      NARG=NARGS()
C
C
C DO PAGE CONTROL STUFF (END A PAGE?)
C
      IF(ICTL.EQ.0.OR.ICTL.EQ.2) THEN
         ITEMP=WINDOW
         WINDOW=-1
         IF(ITEMP.NE.0) CALL DPICT(1)
         WINDOW=0
C          IGNORE OTHER ARGS IF WINDOWING IS BEING TURNED OFF
         IF(ICTL.EQ.0) RETURN
      ENDIF
C
C CONTINUE FOR ICTL 1 OR 2 (START UP NEW WINDOWING SESSION)
C SET NUMBER OF WINDOWS TO DEFAULT, IF ARGS ARE NOT PRESENT
C
      NXWNDW=2
      NYWNDW=2
      IF(NARG.GT.1) THEN
         NXWNDW=NX
         NYWNDW=NY
      ENDIF
      NWNDWS=NXWNDW*NYWNDW
C
C SET WINDOW NUMBER TO 1 IF IWDOW ARG NOT PRESENT
C
      JW=1
      IF(NARG.GE.4) JW=IWDOW
      DO 10 I=3,20
   10 IWNDW(I)=-JW
C
C DO PAGE CONTROL STUFF (BEGIN A PAGE)
C
      ITEMP=WINDOW
      WINDOW=-2
      IF(ITEMP.EQ.0) CALL DPICT(0)
      WINDOW=1
C
      RETURN
      END
