      SUBROUTINE HCHELP(IUNIT,OUNIT)
C
C   **MEMBER** HCHELP
C
C  print out help from CHP, to unit IUNIT.
C
      INTEGER IUNIT,OUNIT
      CHARACTER*1 IN,QUIT
      DATA QUIT/'Q'/
C
      WRITE(OUNIT,10)
   10 FORMAT(
     >/' CHP (Conversational HandyPak) command summary',
     >/'  UPPER CASE means manditory, lower case or [] is optional',
     >//' DOPT    OPT [parm1 [parm2]]',
     >/' dpSLCt  OPT [inter]           !Comment',
     >/' dpCLOs                        ! starts a comment',
     >/' dpWDow  {0|1} [nx ny [iw]]    ! window control',
     >/' hBlock  ID IC [n [a [i]]]',
     >/' hCLR    ID',
     >/' hCOMb   C1 ID1 OPER C2 ID2 ID3 TITLE',
     >/' hCUM1   ID X[/R] W[/R] [err[/R]]  !  /R remembers Exxx, and',
     >/'    X W [err]  ! then this does hCUM1 with remembered Exxxs.',
     >/' hCUM2   ID X[/R] Y[/R] W[/R] [err[/R]]  ! Same as for hCUM1.',
     >/' hDEF1   ID MS NX XL XW TITLE',
     >/' hDEF2   ID MS NX NY XL YL XW YW TITLE',
     >/' hDEL    ID',
     >/' hGet    ID [opt]',
     >/' hMap',
     >/' hOPTN   OPT [parm [id]]',
     >/' hOUt    ID [device]')
      WRITE(OUNIT,13)
   13 FORMAT(/,' ENTER Q TO QUIT, CR TO CONTINUE')
      READ(IUNIT,15,END=18) IN
   15 FORMAT(A1)
      IF(IN.EQ.QUIT) RETURN
   18 CONTINUE
CC..#IFDEF VM_CMS
C      REWIND IUNIT
C..#ENDIF
C
      WRITE(OUNIT,20)
   20 FORMAT(
     >/' hPntr   ID [item]',
     >/' hSET1   ID X W [e]',
     >/' hSET2   ID X Y W [e]',
     >/' hSLIce  ID XORY [ibeg iwdth [device]]',
     >/' hSPace',
     >/' hSTat   ID OPT',
     >/' dpTXt   ''text'' [x y] [DATA] [SIZE s] [ANGLe a] [COLOR N]',
     >/' hWrite  [id [{lun | ''filename''} [irew]]]',
     >/' hREAd   [id [{lun | ''filename''} [irec [ictl [id2]]]]',
     >/' SET     OPT PARM1 [parm2] -- same as DOPT OPT PARM1 parm2',
     >/' SHow    OPT               -- same as DOPT GET,OPT',
     >/' RES     OPT               -- same as DOPT RES,OPT')
      WRITE(OUNIT,22)
   22 FORMAT(
     > ' SET/ID  OPT PARM ...      -- same as HOPTN OPT PARM ID, but',
     >/'  e.g. can set scales by SET/ID HMSC 0. 1. 5. 0. 0. 2. 4. 2.'
     >/' SHow/ID OPT               -- same as HOPTN GET,OPT XX ID',
     >/' RES/ID  OPT               -- same as HOPTN RES,OPT XX ID',
     >/' OPS     CCCC...           -- send CCCC.. to operating system',
     >/' CInput  IUNIT | filename  -- unit or file for input commands',
     >/' END     [unit]            -- ends input file, then use unit',
     >/' HELp                      -- prints this command menu',
     >/' Quit                      -- exit from CHP',/)
      RETURN
      END
