      SUBROUTINE HDEFN(ID,MS,ND,NB,B,W,TITLE)
C
      CHARACTER*(*) TITLE
      CHARACTER*4 MS
      INTEGER NB(2)
      INTEGER HPNTR
      REAL B(2),W(2)
C
      INCLUDE 'hcom.INC'
      INCLUDE 'dpmode.INC'
      INCLUDE 'dcomfp.INC'
      INCLUDE 'hretcd.INC'
C
      INTEGER  ALL, A4ID, HPAK
      CHARACTER*4 TYPE(15), C4MS, CTEMP
C
      INTEGER NW(6)
      EQUIVALENCE (NWPRM,NW(1)),(NWSTAT,NW(2)),(NWHIST,NW(3)),
     >            (NWTITL,NW(4)),(NWDISP,NW(5)),(NWUSER,NW(6))
C
C      LIST OF OPTIONS TO BE SET FOR THIS NEW HIST USING HOPTC
      CHARACTER*4 NEWOPT(19),TMPOPT(2)
      INTEGER ITEMP(20)
      CHARACTER*1 XY(2)
      INTEGER HOPTN1,DMMY
C
      DATA XY/'X','Y'/
      DATA TYPE/'L*1 ','I*2 ','I*4 ','R*4 ','E*4 ','M*4','WEV','A*4',
     >          'EFF ','EF2 ','EF1 ','ASM ','AS2 ','AS1 ','LPT '/
      DATA ALL/4HALL /, HPAK/4HHPAK/
      DATA NEWOPT/'STAT','SLIM','SOMI','SOUT','HBIN','HOMI',
     >  'HLOW','HWID','HNOR','HMSC','TITL','USIZ','MTER',
     >  'CONT','NCON','FUNC','NFUN','YALT','ISOM'/
      DATA TMPOPT/'GET,',' '/
C
C
      IRETCD=0
      IF(ND.EQ.2) GO TO 10
      IF(ND.EQ.1) GO TO 15
      IRETCD=1
      RETURN
C
   10 NWPRM=18
      NBINS=IABS(NB(1)*NB(2))
      NWDISP=37
      GO TO 20
C
   15 NWPRM=8
      NBINS=IABS(NB(1))
      NWDISP=31
C
   20 IF(HPNEW.NE.HPAK) CALL HINIT(2000)
C     NWNODE MUST BE EVEN FOR PROPER R*8 BOUND ALIGNMENT IN STATS
      NWNODE=16
C
C       NWSTAT IS SET TO 0 HERE (HOPTC SETS IT)
      NWSTAT=0
C
      IRETCD=1
      IF(ID.EQ.0.OR.ID.EQ.ALL) RETURN
      CALL HID2A4(ID,A4ID)
C
C
C        NUMBER OF WORDS AND BYTES IN TITLE
   70 MAXTB=LEN(TITLE)
      NTB=0
      DO 80 I=1,MAXTB
      NTB=I
      IF(TITLE(I:I).EQ.'@') GO TO 90
   80 CONTINUE
   90 NWTITL=(NTB+3)/4
C
C        MAKE TESTS FOR VALIDITY OF ARGUMENTS
C
C        DUPLICATE ID
C
      IF(HPNTR(ID).EQ.0) GO TO 120
      WRITE(ERUNIT,100) A4ID
  100 FORMAT(/,' ID ',A4,' ALREADY EXISTS -- NEW HIST NOT MADE')
      IF(ITRACE.NE.0) CALL ERRTRA
      RETURN
C
C      MODE OF STORAGE
  120 C4MS=MS
      CALL DPUPPR(C4MS)
CCCCC      IF(MS.GE.-1.AND.MS.LE.13) GO TO 190
      DO 140 I=1,15
      IMS=I
  140 IF(C4MS(1:3).EQ.TYPE(I)(1:3)) GO TO 200
  160 WRITE(ERUNIT,180) ND,MS,A4ID
  180 FORMAT(/,' HDEF',I1,' ERR: MS ARG=',A4,' NOT LEGAL, ID= ',A4)
      IF(ITRACE.NE.0) CALL ERRTRA
      RETURN
CCCCC  190 IMS=MS+2
C        'LPT' MS DOESNT NEED CHECKING FOR BINS PARMS
  200 IF(IMS.EQ.15) GO TO 280
C        CHECK FOR ZERO BIN WIDTH, TOO LARGE A BIN WIDTH
C        OR TOO FEW BINS OR TOO MANY BINS.
      DO 220 I=1,ND
      IF(NB(I).LE.0 .OR. NB(I).GT.1000000) GO TO 240
      IF(ABS(W(I)).LE.FPSML.OR.ABS(W(I)).GE.FPBIG) GO TO 240
      IF(ND.NE.2) GO TO 220
      IF(ABS(W(I)*NB(I)).GE.FPBIG) GO TO 240
  220 CONTINUE
      GO TO 320
  240 WRITE(ERUNIT,250) ND,A4ID
  250 FORMAT(/,' BAD HDEF',I1,' ARG -- IGNORE ID=',A4)
      WRITE(ERUNIT,260) FPSML,FPBIG,(XY(I),NB(I),XY(I),W(I),I=1,ND)
  260 FORMAT(10X,'N < 1  OR N > 999999  OR W <',1P,G10.2,'  OR W >',
     >       G10.2/(10X,'N',A1,' =',I6,'  W',A1,' =',G12.3))
      IF(ITRACE.NE.0) CALL ERRTRA
      RETURN
C       HANDLE SPECIAL CASE OF 'LPT' STORAGE
  280 IF(ND.EQ.1) GO TO 285
      WRITE(ERUNIT,281) A4ID
  281 FORMAT(/,' HDEF2 ILLEGAL MS ARG (''LPT'') FOR  -- ID=',A4)
      RETURN
  285 NWHIST=2*NBINS+2
      GO TO 330
C
  320 GO TO (321,322,323,323,324,324,324,325,324,323,
     >       322,324,323,322), IMS
      GO TO 160
  321 NWHIST=(NBINS+3)/4
      GO TO 330
  322 NWHIST=(NBINS+1)/2
      GO TO 330
  323 NWHIST=NBINS
      GO TO 330
  324 NWHIST=2*NBINS
      GO TO 330
  325 NWHIST=3*NBINS
      GO TO 330
C
C       ADD A WORD FOR STORING NUMBER OF CALLS
  330 NWHIST=NWHIST+1
C
      NWUSER=0
C
      NWTOT=NWNODE+NWHIST+NWPRM+NWTITL+NWSTAT+NWDISP+NWUSER
C
C        CHECK AVAILABLE SPACE--QUIT IF FULL
      IOVER=NODEND+NWTOT-NHCOM
      IF(IOVER.LT.0) GO TO 400
      WRITE(ERUNIT,340) NHCOM,IOVER,A4ID
  340 FORMAT(/,' HCOM(',I9,') TOO SMALL BY',I9,' WDS FOR ID=',
     >      A4)
      RETURN
C
C
C
 
C       CONSTRUCT NEW NODE
C
  400 NNODES=NNODES+1
C
C       GET LOC OF CURRENT LAST NODE, AND MAKE IT LINK TO NEW ONE
      LNODE=M(NODEND+1)
      M(LNODE+3)=NODEND
      NODE=NODEND
      IF(M(HSHCNT+HASHID).GT.0) GO TO 410
C
C       FIRST ENTRY FOR THIS HASHID -- NODE POINTS TO ITSELF
      M(NODE+1)=NODE
      GO TO 415
C
C       LINK THIS NODE INTO EXISTING HASH CHAIN (BREAK CHAIN TO DO IT)
  410 NODBRK=M(HSHLOC+HASHID)
      M(NODE+1)=M(NODBRK+1)
      M(NODBRK+1)=NODE
C
  415 M(HSHLOC+HASHID)=NODE
      M(HSHCNT+HASHID)=M(HSHCNT+HASHID)+1
C
      M(NODE+2)=HASHID
      M(NODE+3)=NODE1
      M(NODE+4)=ID
      M(NODE+5)=ND
      M(NODE+6)=A4ID
      M(NODE+7)=NWTOT
      M(NODE+8)=NWUSER
      M(NODE+9)=6
      NODEND=NODEND+NWNODE
C NWNODE AND NWPRM MUST BE EVEN TO ASSURE THAT STATS IS R*8 ALIGNED
      DO 420 I=1,6
      M(NODE+9+I)=NODEND-NODE
      IF(NW(I).LE.0) M(NODE+9+I)=0
  420 NODEND=NODEND+NW(I)
C       NEXT NODE MUST BEGIN ON EVEN WORD BOUNDARY (I.E. NODEND EVEN)
      NODEND=NODEND+MOD(NODEND,2)
C
C       SAVE BACKWARD POINTER TO THIS NEW LAST NODE
      M(NODEND+1)=NODE
C
C
C      FILL PARAMETER SUB-NODE
      MPARM=NODE+M(NODE+10)
      M(MPARM+1)=IMS
      M(MPARM+2)=NWHIST
      M(MPARM+3)=0
      M(MPARM+4)=0
      M(MPARM+5)=NB(1)
      R(MPARM+6)=B(1)
      R(MPARM+7)=W(1)
      R(MPARM+8)=B(1)+NB(1)*W(1)
      IF(ND.NE.2) GO TO 600
      M(MPARM+9)=NB(2)
      R(MPARM+10)=B(2)
      R(MPARM+11)=W(2)
      R(MPARM+12)=B(2)+NB(2)*W(2)
      DO 460 I=13,18
  460 M(MPARM+I)=0
C
C       TEST IF SCATTERPLOT IS TO BE INCLUDED
      IF(C4MS(4:4).NE.'S') GO TO 600
      IF(SCTUNI.EQ.0) GO TO 600
C
C       ALLOCATE NEXT SCATTER PLOT NUMBER
  480 IF(SCTTOT.LT.SCTMAX) GO TO 500
      WRITE(ERUNIT,490) SCTMAX,A4ID
  490 FORMAT(/,' SCATTER PLOT LIMIT=',I3,
     >         ' REACHED, SCATPOINTS NOT SAVED FOR ID=',A4)
      GO TO 600
C
C      FILL SEQUENCE NUMBER FOR THIS SCATTER PLOT
  500 SCTTOT=SCTTOT+1
      M(MPARM+13)=SCTTOT
      R(MPARM+14)=1024./(NB(1)*W(1))
      R(MPARM+15)=1024./(NB(2)*W(2))
C      WIPE OUT NCALL WORD, SO THAT HCLR WONT BUMP SCTTOT
      M(NODE+M(NODE+12)+M(MPARM+2))=0
C
C       COPY TITLE INTO NODE
C
  600 MTITL=NODE+M(NODE+13)
      DO 610 K=1,NWTITL
      K4=4*K-3
      CTEMP=TITLE(K4:)
  610 READ(CTEMP,'(A4)') M(MTITL+K)
C
C       DISPLAY OPTIONS
C
      MDISP=NODE+M(NODE+14)
      R(MDISP+1)=1.0
      DO 720 K=2,NWDISP
  720 R(MDISP+K)=0.
C     CALL HOPTN1('GET,DEF0',R(MDISP+NWDISP-15),0)
      DMMY=HOPTN1('GET,DEF0',R(MDISP+NWDISP-15),0)	! for unix-fortran
C
C       SET DEFAULT OPTIONS (IF ANY)
      DO 730 I=1,19
      TMPOPT(2)=NEWOPT(I)
      CALL HOPTC(ALL,TMPOPT,ITEMP)
      IF(IRETCD.NE.0) GO TO 730
C       THIS OPTION HAS A DEFAULT, SO SET THIS HIST ALSO
      CALL HOPTC(ID,TMPOPT(2),ITEMP)
  730 CONTINUE
C
CC     SET TO ASYMMETRIC ERRORS IF ASM OR EFF
C     IF(IMS.GE.9.AND.IMS.LE.14) CALL HOPTC(ID,'ERROR',2)
C      IF MS='LPT', DONT STORE OVERFLOWS IN EDGE BINS
      IF(IMS.NE.15) GO TO 740
      CALL HOPTC(ID,'HOMIT',1)
      CALL HOPTC(ID,'XOMIT',0)
  740 CONTINUE
C
      CALL HCLR(ID)
C
      IRETCD=0
C
      RETURN
      END
