      INTEGER FUNCTION HNEXT(IOPT)
C
C  **MEMBER** HNEXT
C
C   HNEXT RETURNS THE ID OF THE NEXT NODE IN SEQUENCE IN /HCOM/.
C   IF IOPT IS 0, HNEXT RUTURNS THE ID OF THE FIRST NODE IN /HCOM/.
C   IF IOPT IS NON-ZERO, THE ID OF THE NEXT NODE IN SEQUENCE AFTER THE
C   CURRENTLY ACTIVE NODE IS RETURNED IN HNEXT.
C   IF THERE IS NO NEXT NODE, HNEXT RETURNS 0.
C
      INCLUDE 'hcom.INC'
C
      HNEXT=0
      IF(NNODES.LE.0) RETURN
      IF(IOPT.NE.0) GO TO 10
C RETURN ID OF FIRST NODE
      HNEXT=M(NODE1+4)
      RETURN
C
C GET NEXT NODE, AND RETURN ITS ID
   10 KNODE=M(NODE+3)
      IF(KNODE.EQ.NODE1) RETURN
      HNEXT=M(KNODE+4)
      RETURN
C
      END
