      SUBROUTINE HOUT(ID,HDEV)
C
      INTEGER HDEV(2)
C
C   OUTPUTS THE CONTENTS OF HISTOGRAM # ID WITH THE OPTIONS AS
C   SPECIFIED BY THE OPTIONS IN THIS HIST OR THE COMMON BLOCK /DPMODE/.
C   THE ARGUMENT DEV IS OPTIONAL, AND IF SPECIFIED IT SUPPLIES
C   THE NAME OF THE DEVICE ON WHICH THE HISTOGRAM IS OUTPUT.
C
C   ADDED MODIFICATION BY M. KELSEY (SLD) 1 JUNE 1990.
C   FOR KEYBOARD/INTERACTIVE DEVICES, IF THE USER TYPES "Q" AT THE
C   PROMPT FOR PAGE SCROLLING, OUTPUT IS TERMINATED.
C
      INCLUDE 'hcom.INC'
      INCLUDE 'dpmode.INC'
      INCLUDE 'hretcd.INC'
C
      COMMON/DCOMKB/ STRING
      CHARACTER*4 STRING
C
      INTEGER ALL,HPAK,HPNTR
      DATA ALL/4HALL /, HPAK/4HHPAK/
C
      NARG=NARGS()
      IF(NARG.LT.0) NARG=1
      IF(HPNEW.NE.HPAK) CALL HINIT(2000)
      IF(NARG.LE.1) GO TO 8
      CALL DPSLCT(HDEV)
      IF(IRETCD.EQ.0) GO TO 8
C
    4 WRITE(ERUNIT,6)
    6 FORMAT(/,' HOUT -- DEVICE ARG IGNORED'/)
C
    8 IF(ID.EQ.0) RETURN
C
   10 IF(NNODES.LE.0) RETURN
      IF (ID.EQ.ALL) GO TO 20
      IF (HPNTR(ID).EQ.0) RETURN
      NOUT=1
      GO TO 50
C
   20 NOUT=NNODES
      NODE=NODE1
C
   50 IPLOT=1
C       CLEAR USER KEYBOARD BUFFER (to detect a user 'Quit')
      STRING = ' '
C
      DO 500 INOD=1,NOUT
C
C  HOUTU IS A HOOK FOR USER HISTOGRAM PROCESSING
C  THE FIRST ARGUMENT IS THE HISTOGRAM ID
C  THE SECOND IS A FLAG FOR THE USER ROUTINE
C   1 => BEFORE HEXEC CALL
C   2 => AFTER HEXEC CALL
C
      CALL HOUTU(M(NODE+4),1)
      CALL NARGSET(1)
      CALL HEXEC(M(NODE+4))
      CALL HOUTU(M(NODE+4),2)
C
C  TRAP USER INPUT OF "Q" OR "q" AND EXIT
      IF ((STRING(1:1).EQ.'Q').OR.(STRING(1:1).EQ.'q')) GOTO 999
C
  500 IF(ID.EQ.ALL) NODE=M(NODE+3)
C
  999 RETURN
      END
