      LOGICAL FUNCTION HSCUNI(I)
C
C   **MEMBER** HSCUNI
C
C  I (INPUT) IS A UNIT NUMBER FOR THE SCATTERPLOT SCRATCH FILE.
C  HSCUNI RETURNS TRUE IF THERE IS A SCATTERPLOT FILE, FALSE
C  OTHERWISE. HSCUNI ALSO EXISTS AS AN ENTRY POINT IN DMSCAT
C  (WHICH ALWAYS RETURNS FALSE). IF HSCUNI RETURNS FALSE, THEN
C  NO SCATTERPOINTS WILL BE MADE.
C
      INCLUDE 'nargcom.INC'
C
C  NEXT LINE IS FOR LAHEY F77L, TO CORRECT THEIR NARGS VALUE FOR FUNCTION
C  CALLS. NARGS RETURNS 1 TOO MANY IN THAT CASE. NARG0F REMEMBERS IT.
      NARG0F=NARGS()-1
C
      HSCUNI=.FALSE.
      IF(I.LE.0) RETURN
      HSCUNI=.TRUE.
      OPEN(I,FORM='UNFORMATTED',STATUS='SCRATCH')
      RETURN
      END
