C
      FUNCTION NARGS()
C
C  SPECIAL VERSION FOR THE PC, TO RETURN THE NUMBER OF ARGUMENTS IN A CALL.
C  THE INPUT VALUE N IS STORED AND THE PREVIOUS VALUE IS RETURNED BY THE
C  FUNCTION VALUE. THIS ALLOWS A USER TO SPECIFY THE NUMBER OF ARGUMENTS
C  IN A SUBROUTINE CALL, AND THE CALLED SUBROUTINE CAN RETREIVE THE NUMBER,
C  AS FOLLOWS:
C      CALL NARGSET(J)
C      CALL SUB(A1,A2,....,AJ)
C  THEN THE ROUTINE SUB CAN CALL NARGS TO FIND OUT J, THE NUMBER OF ARGS, AS
C      SUBROUTINE SUB(B1,B2,....,BJ,...BK)
C      J=NARGS()
C  AND SUBSEQUENT CALLS TO NARGS WOULD RETURN -1, FOR NOT SET CONDITION.
C
      INCLUDE 'nargcom.INC'
      EXTERNAL NARGDAT
C
C
      NARGS=NARGL
      NARGL=-1
      RETURN
      END
C
      BLOCK DATA NARGDAT
      INCLUDE 'nargcom.INC'
      DATA NARGL/-1/, NARG0F/0/
      END
