      SUBROUTINE DGSET(ITEM,VALU)
      REAL VALU(1)
C
C              BUFFER FOR UNIFIED GRAPHICS CALLS
C
      COMMON / SCPBUF / NBUF,SCPBUF(500)
      INTEGER SCPBUF
C
C
C   **MEMBER** DGSET
C   **ALIAS** DGBUF
C   **ALIAS** DGPUTX
C
C   SETS UP OPTION ARGUMENTS FOR FUTURE CALLS TO UGLINE, UGMARK, ETC.
C
      INCLUDE 'HPK$SOURCE:DPMODE.FOR'
      INCLUDE 'UGS$SOURCE:UGMCACBK.FOR'
C
C   BUF IS THE ELEMENT BUFFER FOR UNIFIED GRAPHICS CALLS
      INTEGER BUF(1)
      INTEGER BUFLEN
      DATA BUFLEN/0/
C
C
      INTEGER OPTS(7)
      DATA OPTS/'XSPA','ANGL','DASH','BRIT','COLO','WINK','PLIM'/
C
      INTEGER*4 TEXTP(2),TEXTS(2)
      LOGICAL*1 TEXT(N)
      CHARACTER CPRI*100,CSEC*100
      CHARACTER*(*) CHAR
C
      REAL AX(1),AY(1)
C
      INTEGER DGNAM(3)
      DATA DGNAM/'SET ','XCH ','GET '/
C
      INTEGER ICOL(7)
      DATA ICOL/'WHI ','RED ','GRE ','BLU ','YEL ','MAG ','CYA '/
      EQUIVALENCE (TVAL,IVAL),(TEMP,ITEMP)
      CHARACTER STRING
      INTEGER IARRAY(20)
      REAL XARRAY(10),AREA(4)
C
C
      IENTRY=1
      GO TO 5
C
C
C
      ENTRY DGXCH(ITEM,VALU)
      IENTRY=2
C
    5 TEMP=VALU(1)
      GO TO 7
C
C
C
      ENTRY DGGET(ITEM,VALU)
      IENTRY=3
C
    7 CALL UGINFO('SEGDEFL',STRING,IARRAY,XARRAY)
      TVAL=VALU(1)
      DO 10 I=1,7
   10 IF(ITEM.EQ.OPTS(I)) GO TO (100,200,300,400,500,600,700), I
      WRITE(ERUNIT,20) DGNAM(IENTRY),ITEM
   20 FORMAT('0DG',A3,' CALLED WITH ILLEGAL OPTION, =',A5)
      RETURN
C
C  XSPACING
C
  100 TEMP=XARRAY(2)
      IF(IENTRY.LE.2) XARRAY(2)=VALU(1)
      IF(IENTRY.GE.2) VALU(1)=TEMP
      GO TO 5000
C
C  ANGLE
C
  200 TEMP=XARRAY(3)
      IF(IENTRY.LE.2) XARRAY(3)=VALU(1)
      IF(IENTRY.GE.2) VALU(1)=TEMP
      GO TO 5000
C
C  DASH
C
  300 ITEMP=IARRAY(5)
      IF(IENTRY.LE.2) IARRAY(5)=IVAL
      IF(IENTRY.GE.2) VALU(1)=TEMP
      GO TO 5000
C
C  BRIT
C
  400 ITEMP=IARRAY(1)
      IF(IENTRY.LE.2) IARRAY(1)=IVAL
      IF(IENTRY.GE.2) VALU(1)=TEMP
      GO TO 5000
C
C  COLOR
C
  500 ITEMP=IARRAY(2)
      IF(IENTRY.GE.3) GO TO 530
      IF(IVAL.GE.1 .AND. IVAL.LE.7) GO TO 515
      IF(IVAL.EQ.0) IVAL=1
      IF(IVAL.EQ.1) GO TO 515
      NCOL=1
      DO 512 I=1,7
  512 IF(IVAL.EQ.ICOL(I)) NCOL=I
      IVAL=NCOL
  515 IF(IENTRY.LE.2) IARRAY(2)=IVAL
  530 IF(IENTRY.GE.2) VALU(1)=TEMP
      GO TO 5000
C
C  WINK
C
  600 ITEMP=IARRAY(3)
      IF(IENTRY.LE.2) IARRAY(3)=IVAL
      IF(IENTRY.GE.2) VALU(1)=TEMP
      GO TO 5000
C
C       PLIMITS
C
  700 IF(IENTRY.EQ.3) CALL UGWDOW('GET',AREA,VALU)
      RETURN
C
C
C
 5000 IF(IENTRY.GE.3) RETURN
      CALL UGDEFL('SET',IARRAY,XARRAY)
      RETURN
C
C
C
      ENTRY DGBUF(BUF,N)
C  THIS ENTRY SUPPLIES THE ADDRESS OF THE ELEMENT BUFFER
      L=%LOC(BUF)
      BUFLEN=N
C       ALSO SUPPLY BUF ADDRESS TO DGPUTX ROUTINE
      CALL DGBUFX(BUF,N)
      RETURN
C
C
C
      ENTRY DGINT(IC)
C 	WRITE(6,*) IC,BUFLEN
      IF(BUFLEN.NE.0) GO TO 5200
      WRITE(ERUNIT,5210)
 5210 FORMAT('0DGINT CALLED, BUT THERE IS NO BUFFER DEFINED')
CCCC      IF(ITRACE.EQ.1) CALL ERRTRA
      STOP
C
 5200 IF(IC.EQ.0) CALL UGINIT('CLEAR',%VAL(L),BUFLEN)
      IF(IC.EQ.1) CALL UGINIT('CONTINUE',%VAL(L),BUFLEN)
      RETURN
C
C
      ENTRY DGTXT(X,Y,TEXT,N)
C
C     MAKE UP A DESCRIPTOR FOR TEXT ARRAY OF LENGTH N

	TEXTP(1) = N
	TEXTP(2) = %LOC(TEXT)

C  Test if the extended character set is loaded

	Call UGZ002(0,MCACN,IPOINT)
	Call UGP001(%VAL(IPOINT),INT)
	IF(INT.LE.0) Then
	  Call UGTEXT( ' ',X,Y,TEXTP,%VAL(L) )
	Else
	  CALL	UGCHAR( 'XTOP', CPRI, CSEC, TEXTP, N )
	  TEXTP(1) = N
	  TEXTP(2) = %LOC(CPRI)
	  TEXTS(1) = N
	  TEXTS(2) = %LOC(CSEC)
	  CALL	UGXTXT( ' ', X, Y, TEXTP, TEXTS, %VAL(L) )
	Endif
      RETURN
C
C
      ENTRY DGCHR(X,Y,CHAR)
      CALL UGXTXT(' ',X,Y,CHAR,SPAC,%VAL(L))
      RETURN
C
C
C
      ENTRY DGLIN(X,Y,IDRAW)
C
      CALL UGLINE(' ',X,Y,IDRAW,%VAL(L))
      RETURN
C
C
      ENTRY DGLNS(AX,AY,N)
      CALL UGPLIN(' ',AX,AY,N,1,1,%VAL(L))
      RETURN
C
C
C
      ENTRY DGPNT(X,Y)
C
      CALL UGMARK(' ',X,Y,%VAL(L))
      RETURN
C
C
      ENTRY DGPTS(AX,AY,N)
      CALL UGPMRK(' ',AX,AY,N,%VAL(L))
      RETURN
C
C
      ENTRY DGPUT(IC,IB)
      IF(IC.EQ.0) CALL UGWRIT(' ',IB,%VAL(L))
      RETURN
C
C
      ENTRY DGPIC(IC,IB)
      IF(IC.EQ.0) CALL UGPICT('CLEAR',IB)
      RETURN
C
C
      END
      SUBROUTINE DGPUTX(IB)
C
C  THIS IS CALLED OUT OF HANDYPAK'S UGXERR TO PUT OUT THE ELEMENT
C  BUFFER AND THEN CONTINUE THE SAME BUFFER
C
      INTEGER BUF(1)
      DATA NBUF/0/
C
      IF(NBUF.LE.0) RETURN
      CALL UGWRIT(' ',IB,%VAL(L))
      CALL UGINIT('CONTINUE',%VAL(L),NBUF)
      RETURN
C
C
C
      ENTRY DGBUFX(BUF,IBUF)
C DGBUFX CALLED BY DGBUF, (SUPPLIES BUF ADDRESS AND ITS LENGTH)
      NBUF=IBUF
      L=%LOC(BUF)
      RETURN
      END
      SUBROUTINE DPCLOS
C
C   **MEMBER** DPCLOS
C
C  CLOSE ALL GRAPHIC DEVICES AND SCATTERPLOT FILE.
C
      INCLUDE 'HPK$SOURCE:DPMODE.FOR'
C
C              HPAK BUFFER MEMORY
C
      COMMON / HNODE/ HASHID,NODE
      COMMON / HCOM / NNODES,IHCOM(2),NHCOM,NODEND,NODE1,
     >                HSHLOC,HSHCNT,HSHLEN,SCTLOC,SCTLEN,SCTUNI,
     >                SCTUSE,SCTREC,SCTTOT,SCTMAX,HPNEW
      INTEGER M(2000),HASHID,HSHLOC,HSHCNT,HSHLEN,SCTLOC,SCTLEN,SCTUNI,
     >                SCTUSE,SCTREC,SCTTOT,SCTMAX,HPNEW
      REAL R(1)
      INTEGER*2 H(1)
      LOGICAL*1 L(1)
      LOGICAL LW(1)
      REAL*8 D(1)
      EQUIVALENCE (NNODES,M(1),L(1),LW(1),H(1),R(1),D(1))
C
C
      INTEGER HPAK,IOPEN(8)
      DATA HPAK/'HPAK'/
      CHARACTER SDUM
C
      CALL UGINFO('OPENDEV',SDUM,IOPEN)
      IF(IOPEN(1).GT.0) CALL UGCLOS('ALL')
C
C      RESET CURRENT DEVICE TO PRINTER
      IDEV=2
C
C      CLOSE SCATTERPLOT FILE, IF IT IS IN USE
      IF(HPNEW.NE.HPAK) RETURN
      IF(SCTTOT.LE.0) RETURN
      SCTTOT=0
      SCTUSE=-1
      REWIND SCTUNI
      ENDFILE SCTUNI
C
      CLOSE(UNIT=SCTUNI,DISP='DELETE',ERR=10)                           VAX780
   10 RETURN
      END
      SUBROUTINE DPICT(K)
C
C  **MEMBER** DPICT
C
C  CONTROLS INITIALIZATION AND OUTPUTTING OF THE GRAPHIC BUFFER
C  FOR GRAPHIC DEVICES.  DOES NOTHING FOR NON-GRAPHIC DEVICES.
C
C  THE ARGUMENT K SPECIFIES INITIALIZATION OR OUTPUT.
C  IF INTER IS 1, THEN A PAUSE IS DONE AFTER EVERY PICTURE. A
C  CARRIAGE RETURN IS THEN NECESSARY TO CONTINUE WITH THE JOB.
C
C    K = 0  BUFFER IS INITIALIZED.
C    K = 1  BUFFER IS OUTPUTTED
C
      INCLUDE 'HPK$SOURCE:DPMODE.FOR'
      INTEGER IARRAY(8)
      REAL RARRAY(2),AREA(4)
      DATA AREA/0.,0.,1.,1./
C      INTEGER ATCODE                                                    IBM370
      CHARACTER*4 ATCODE                                                VAX780
C
C
      LOGICAL*1 L1BUF(27),L1JOB(8),L1DAT(8)
      EQUIVALENCE (JBNAM(1),L1JOB(1)),(JBDAT(1),L1DAT(1))
      DATA L1BUF/'H','A','N','D','Y','P','A','K',19*' '/
C
      INTEGER JB1(3),JB2(3)
C      STRING POINTERS AND LENGTHS FOR HANDYPAK/JOB FONT
      DATA JB1/11,1,1/, JB2/17,8,27/
C
C
      IF(IDEV.GT.2) GO TO 50
C
C       DONT DO ANYTHING FOR NON-GRAPHIC DEVICES
      IF(IDEV.LE.2) RETURN
C      NEXT STATEMENT WILL NEVER BE EXECUTED - IT IS HERE TO
C      ASSURE THAT UGXERR IS LOADED FROM HANDYPAK AND NOT
C      FROM UG LIB ON VAX
      CALL UGXERR
C      ALSO ASSURE THAT ENTRY DPLIMS IS MADE AVAIL TO LOAD FOR VM
C      CALL DPSLCT(IDEV)                                                 IBM370
C
C       FOR INTERACTIVE PANEL APPLICATION (INTER=2), DONT DO ANY
C       CALLS TO DGPUT OR DGPIC SINCE DEXEC DOES IT.
C
   50 IF(K.NE.0) GO TO 100
      IF(INTER.EQ.2) GO TO 55
C
C       INITIALIZE THE BUFFER
      IF(INTER.eq.0) GO TO 54
      IF(OVRPLT.NE.0) GO TO 60
      CALL DGPIC(0,0)
   54 CALL DGINT(0)
   55 IF(OVRPLT.EQ.0) NOVRG=0
C
C      ALSO SET THE UG PROGRAMMER LIMITS FROM GSIZE AND GOFSET
   60 CALL DPLIMS
      RETURN
C
C
C       OUTPUT THE BUFFER
  100 IF(INTER.EQ.2) GO TO 115
C
C       SEND OUT THE GRAPHIC BUFFER CONTENTS
  110 CALL DGPUT(0,0)
      CALL DGINT(0)
C
C       COUNT UP NUMBER OF PLOTS WHEN OVERPLOTTING IS BEING DONE
  115 IF(OVRPLT.EQ.0) GO TO 120
      NOVRG=NOVRG+1
      RETURN
C
C       PUT UP JOB NAME, DATE FONT
C
  120 IF(JBFONT.EQ.0) GO TO 150
C      PUT OUT PREVIOUS BUFFER, IF ANY
      IF(INTER.EQ.2) GO TO 130
      CALL DGPUT(0,0)
      CALL DGINT(0)
      CALL UGWDOW('PUT',AREA,AREA)
  130 XSPA=.012
      CALL DGXCH('XSPA',XSPA)
      DO 140 I=1,8
      L1BUF(I+10)=L1JOB(I)
  140 L1BUF(I+19)=L1DAT(I)
      I=JBFONT
      IF(I.LT.1.OR.I.GT.3) I=3
      CALL DGTXT(.006,.01,L1BUF(JB1(I)),JB2(I))
      IF(INTER.NE.2) CALL DGPUT(0,0)
      CALL DGSET('XSPA',XSPA)
C
  150 IF(INTER.EQ.0) CALL DGPIC(0,0)
      IF(OVRPLT.EQ.0) NOVRG=0
C IF THIS DEVICE HAS A KEYBOARD, THEN DO A PAUSE
      IF(INTER.EQ.5) THEN
	CALL UGINFO('CONTROLS',STRING,IARRAY,RARRAY)
	IF(IARRAY(5).EQ.0) RETURN
	CALL UGENAB('LOCATOR')
	CALL UGECTL('LOCATOR',ATCODE,IARRAY,DEVTYP(19),DEVTYP(20))
      ELSE IF(INTER.EQ.1) THEN
	CALL UGINFO('CONTROLS',STRING,IARRAY,RARRAY)
	IF(IARRAY(1).EQ.0) RETURN
	CALL UGENAB('KEYBOARD')
	CALL UGEVNT(' ',-1.0,ATCODE,IARRAY,RARRAY)
	CALL DGPIC(0,0)
      ENDIF
      RETURN
C
      END
C      LOGICAL FUNCTION DPSLCT(DEV,/INTDEV/)                             IBM370
      LOGICAL FUNCTION DPSLCT(DEV,INTDEV)                               VAX780
      INTEGER DEV(2)
C
C   **MEMBER** DPSLCT
C   **ALIAS** DPLIMS
C
C   SELECTS THE UG DEVICE SPECIFIED BY DEV AND SETS IDEV IN
C   THE /DPMODE/ COMMON BLOCK TO THIS DEVICE INDEX.
C   THE SCALING LIMITS AND SCISSORING LIMITS ARE ALSO SET ACCORDING
C   TO THE VALUES IN GSIZE AND GOFSET IN /DPMODE/
C
C   THE ARGUMENT DEV MAY BE EITHER AN INTEGER DEVICE INDEX (1-20),
C   OR A DEVICE NAME (8-CHARACTER).
C
C   IF THE DEV IS VALID, DPSLCT RETURNS .TRUE., OTHERWISE .FALSE.
C
C   INTDEV (OPTIONAL) SUPPLIES THE VALUE FOR INTER.  IF NOT SUPPLIED
C   THEN INTER REMAINS UNCHANGED.
C
      INCLUDE 'HPK$SOURCE:DPMODE.FOR'
C
      INTEGER DPAK
      DATA DPAK/'DPAK'/
C
      REAL*8 DDEV,BLANK
      INTEGER DEV2(2),PRIN4
      EQUIVALENCE (DEV2(1),DDEV)
      DATA PRIN4/'PRIN'/, BLANK/'        '/
C    VARIABLES FOR MANIPULATING THE SCALING LIMITS
      REAL PLIMIT(4),DLIMIT(4),AREA(4)
      DATA AREA/0.,0.,1.,1./
C
C      VALUES FOR PROCESSING UGOPEN
      INTEGER IOPEN(9)
      REAL*8 OPT(6)
      CHARACTER*48 CHOPT                                                VAX780
      EQUIVALENCE (OPT(1),CHOPT)                                        VAX780
      DATA OPT/' ',',',',',' ',' ','*'/
      REAL*8 FULSC,GENIL
      DATA FULSC/',FULSCR '/,GENIL/',GENIL  '/
      INTEGER VEP
      DATA VEP/'VEP1'/
      CHARACTER SDUM
C
C
      IF(DPNEW.NE.DPAK) CALL DPINIT(500)
C
      DPSLCT=.FALSE.
C
C       SET INTER IF SECOND ARG IS THERE
      IF(NARGS(0).GE.2) INTER=INTDEV
C
C       ACCEPT AN INTEGER DEVICE INDEX
      I=DEV(1)
      IF(I.LE.0.OR.I.GT.20) GO TO 12
C       CHECK FOR ACCEPTABLE INDEX
      IF(DEVTYP(I).NE.BLANK) GO TO 20
      WRITE(ERUNIT,10) I
   10 FORMAT('0DPSLCT -- DEVICE #',I3,'  INVALID - NO DEVTYP NAME')
      RETURN
C
C      ACCEPT 'PRIN' AS A SHORT FORM FOR 'PRINTER' IN DEV ARGUMENT
   12 I=2
      IF(DEV(1).EQ.PRIN4) GO TO 90
C
C       SEARCH TABLE OF DEVTYP'S FOR THIS DEVICE
      DEV2(1)=DEV(1)
      DEV2(2)=DEV(2)
      DO 15 I=1,20
   15 IF(DDEV.EQ.DEVTYP(I)) GO TO 20
C        DEV IS NOT A RECOGNIZED DEVICE
      WRITE(ERUNIT,18) DDEV,DEVTYP
   18 FORMAT('0DPSLCT -- ',A8,' IS AN UNKNOWN DEVICE',
     > ' - KNOWN ONES ARE:',/(10A10))
      RETURN
C
   20 IF(I.LE.2) GO TO 90
      IF(I.EQ.7 .OR. I.EQ.19) INTER = 1
C
C       CHECK WHETHER THIS GRAPHIC DEVICE IS TO BE OPENED
C
      CALL UGINFO('OPENDEV',SDUM,IOPEN)
      NOPEN=IOPEN(1)
      IF(NOPEN.LE.0) GO TO 55
      DO 50 J=1,NOPEN
   50 IF(IOPEN(J+1).EQ.I) GO TO 60
C
C       THIS DEVICE HAS NOT BEEN OPENED BY UGOPEN, SO OPEN IT
C       AND GIVE IT AN IDENTITY NUMBER I.
C
   55 OPT(1)=DEVTYP(I)
C      OPT(3)=DEVTYP(I)
      DDEV=DEVTYP(I)
C      FULL SCREEN OPTION
      OPT(4)=BLANK
C      LINE DENSITY (FOR VERSATEC ONLY)
      OPT(5)=BLANK
      IF(LINDEN.NE.0.AND.DEV2(1).EQ.VEP) OPT(5)=GENIL
C      CALL UGOPEN(OPT,I)                                                IBM370
      CALL UGOPEN(CHOPT,I)                                              VAX780
      WRITE(6,58) DEVTYP(I),I,OPT(4),OPT(5)
   58 FORMAT('0UG DEVICE=',A10,' HAS BEEN OPENED WITH IDENT=',I6,2X,2A8)
      SCRN=1.0
      IF(FULSCR.EQ.1) SCRN=0.0
      CALL UGDSPC('PUT',1.,1.,SCRN)
C
      NDEVS=NDEVS+1
C
C       SELECT THE GRAPHIC DEVICE
   60 CALL UGSLCT(' ',I)
      GO TO 65
C
C
      ENTRY DPLIMS
C
      I=IDEV
C
C       SET SCALING LIMITS FOR THIS DEVICE BY APPLYING THE OFFSET
C       AND SIZE IN GOFSET AND GSIZE TO THE ORIGINAL SCREEN SIZE
   65 DO 66 I=1,4
      DLIMIT(I)=AREA(I)
   66 PLIMIT(I)=AREA(I)
C       SET DEVICE LIMITS
      XR=DLIMIT(3)-DLIMIT(1)
      YR=DLIMIT(4)-DLIMIT(2)
      DLIMIT(1)=DLIMIT(1)+GOFSET(1)*XR
      DLIMIT(2)=DLIMIT(2)+GOFSET(2)*YR
      DLIMIT(3)=DLIMIT(1)+GSIZE(1)*XR
      DLIMIT(4)=DLIMIT(2)+GSIZE(2)*YR
C       SET PROGRAMMER LIMITS ALSO, BUT ONLY IF CHARACTERS ARE TO
C       REMAIN FIXED IN SIZE.
      IF(CHSCAL.NE.0) GO TO 70
      RX=PLIMIT(3)-PLIMIT(1)
      RY=PLIMIT(4)-PLIMIT(2)
      PLIMIT(1)=PLIMIT(1)+GOFSET(1)*RX
      PLIMIT(2)=PLIMIT(2)+GOFSET(2)*RY
      PLIMIT(3)=PLIMIT(1)+GSIZE(1)*RX
      PLIMIT(4)=PLIMIT(2)+GSIZE(2)*RY
   70 CALL UGWDOW('PUT',DLIMIT,PLIMIT)
C
   90 IDEV=I
      DPSLCT=.TRUE.
C
      RETURN
C
      END
      SUBROUTINE UGCHAR(OPTNS,CPRI,CSEC,CEXT,NCHAR)
C
C ********  THE SLAC UNIFIED GRAPHICS SYSTEM (VAX-11 VERSION)  ********
C *   CONVERT BETWEEN CHARACTER PAIRS AND UG EXTENDED CHARACTER SET   *
C *                                                                   *
C *  THIS SUBROUTINE MAY BE USED TO CONVERT BETWEEN CHARACTER PAIRS   *
C *  AND THE UNIFIED GRAPHICS EXTENDED CHARACTER SET.                 *
C *                                                                   *
C *  THE CALLING SEQUENCE IS:                                         *
C *    CALL UGCHAR(OPTNS,CPRI,CSEC,CEXT,NCHAR)                        *
C *  WHERE OPTNS, CPRI, CSEC, AND CEXT ARE CHARACTER STRINGS; AND     *
C *  NCHAR IS A FIXED POINT VALUE.                                    *
C *                                                                   *
C *                          ROBERT C. BEACH                          *
C *                    COMPUTATION RESEARCH GROUP                     *
C *                STANFORD LINEAR ACCELERATOR CENTER                 *
C *                                                                   *
C *********************************************************************
C
      CHARACTER*(*) OPTNS,CPRI,CSEC,CEXT
      INTEGER       NCHAR
C
      INTEGER*4     INOS(11)
      DATA          INOS/2,1,4,2,1,'PTOX',
     X                     1,4,2,2,'XTOP'/
      INTEGER*4     EXOS(2),EXFG
      EQUIVALENCE   (EXFG,EXOS(2))
C
C  CPPX: THE PRIMARY CHARACTERS.
      CHARACTER*1   CPPX(256)
      CHARACTER*1   CPPX1(64)
      EQUIVALENCE   (CPPX1(1),CPPX(1))
      CHARACTER*1   CPPX2(64)
      EQUIVALENCE   (CPPX2(1),CPPX(65))
      CHARACTER*1   CPPX3(64)
      EQUIVALENCE   (CPPX3(1),CPPX(129))
      CHARACTER*1   CPPX4(64)
      EQUIVALENCE   (CPPX4(1),CPPX(193))
C  CPSX: THE SECONDARY CHARACTERS.
      CHARACTER*1   CPSX(256)
      CHARACTER*1   CPSX1(64)
      EQUIVALENCE   (CPSX1(1),CPSX(1))
      CHARACTER*1   CPSX2(64)
      EQUIVALENCE   (CPSX2(1),CPSX(65))
      CHARACTER*1   CPSX3(64)
      EQUIVALENCE   (CPSX3(1),CPSX(129))
      CHARACTER*1   CPSX4(64)
      EQUIVALENCE   (CPSX4(1),CPSX(193))
C
      CHARACTER*1   XPRI,XSEC
C
      INTEGER*2     INT1,INT2
C
      DATA          CPPX1
     X  /  ' ',  ' ',  ' ',  ' ',  ' ',  ' ',  ' ',  ' ',
     X     ' ',  ' ',  ' ',  ' ',  ' ',  ' ',  ' ',  ' ',
     X     ' ',  ' ',  ' ',  ' ',  ' ',  ' ',  ' ',  ' ',
     X     ' ',  ' ',  ' ',  ' ',  ' ',  ' ',  ' ',  ' ',
     X     ' ',  '!',  '"',  '#',  '$',  '%',  '&',  '''',
     X     '(',  ')',  '*',  '+',  ',',  '-',  '.',  '/',
     X     '0',  '1',  '2',  '3',  '4',  '5',  '6',  '7',
     X     '8',  '9',  ':',  ';',  '<',  '=',  '>',  '?'/
      DATA          CPPX2
     X  /  '@',  'A',  'B',  'C',  'D',  'E',  'F',  'G',
     X     'H',  'I',  'J',  'K',  'L',  'M',  'N',  'O',
     X     'P',  'Q',  'R',  'S',  'T',  'U',  'V',  'W',
     X     'X',  'Y',  'Z',  '(',  '/',  ')',  '^',  '_',
     X     'U',  'A',  'B',  'C',  'D',  'E',  'F',  'G',
     X     'H',  'I',  'J',  'K',  'L',  'M',  'N',  'O',
     X     'P',  'Q',  'R',  'S',  'T',  'U',  'V',  'W',
     X     'X',  'Y',  'Z',  'A',  '|',  'Z',  '~',  ' '/
      DATA          CPPX3
     X  /  'Q',  'I',  'X',  ':',  'E',  'P',  'I',  '?',
     X     'L',  'R',  'F',  'S',  '<',  'N',  'H',  'W',
     X     '0',  '1',  '2',  '3',  '4',  '5',  '6',  '7',
     X     '8',  '9',  ' ',  ' ',  ' ',  ' ',  'E',  'F',
     X     'U',  'O',  'D',  'D',  'L',  'R',  'B',  'J',
     X     'M',  'N',  '2',  'U',  'V',  'E',  '>',  'A',
     X     '0',  '1',  '2',  '3',  '4',  '5',  '6',  '7',
     X     '8',  '9',  '<',  '+',  '*',  'G',  '=',  '>'/
      DATA          CPPX4
     X  /  'L',  'A',  'B',  'G',  'D',  'E',  'Z',  'H',
     X     'Q',  'I',  'K',  'L',  'M',  'N',  'X',  'O',
     X     'P',  'R',  'S',  'T',  'U',  'F',  'C',  'Y',
     X     'W',  'R',  '1',  '2',  '3',  '4',  '5',  '6',
     X     '0',  'A',  'B',  'G',  'D',  'E',  'Z',  'H',
     X     'Q',  'I',  'K',  'L',  'M',  'N',  'X',  'O',
     X     'P',  'R',  'S',  'T',  'U',  'F',  'C',  'Y',
     X     'W',  '1',  '2',  '3',  '4',  '5',  '6',  '0'/
      DATA          CPSX1
     X  /  'S',  'S',  'S',  'S',  'S',  'S',  'S',  'S',
     X     'S',  'S',  'S',  'S',  'S',  'S',  'S',  'S',
     X     'S',  'S',  'S',  'S',  'S',  'S',  'S',  'S',
     X     'S',  'S',  'S',  'S',  'S',  'S',  'S',  'S',
     X     ' ',  ' ',  ' ',  ' ',  ' ',  ' ',  ' ',  ' ',
     X     ' ',  ' ',  ' ',  ' ',  ' ',  ' ',  ' ',  ' ',
     X     ' ',  ' ',  ' ',  ' ',  ' ',  ' ',  ' ',  ' ',
     X     ' ',  ' ',  ' ',  ' ',  ' ',  ' ',  ' ',  ' '/
      DATA          CPSX2
     X  /  ' ',  ' ',  ' ',  ' ',  ' ',  ' ',  ' ',  ' ',
     X     ' ',  ' ',  ' ',  ' ',  ' ',  ' ',  ' ',  ' ',
     X     ' ',  ' ',  ' ',  ' ',  ' ',  ' ',  ' ',  ' ',
     X     ' ',  ' ',  ' ',  'S',  'S',  'S',  ' ',  ' ',
     X     'A',  'L',  'L',  'L',  'L',  'L',  'L',  'L',
     X     'L',  'L',  'L',  'L',  'L',  'L',  'L',  'L',
     X     'L',  'L',  'L',  'L',  'L',  'L',  'L',  'L',
     X     'L',  'L',  'L',  'S',  ' ',  'S',  ' ',  'S'/
      DATA          CPSX3
     X  /  'S',  'S',  'S',  'S',  'S',  'S',  'X',  'S',
     X     'S',  'S',  'S',  'S',  'S',  'S',  'S',  'S',
     X     'C',  'C',  'C',  'C',  'C',  'C',  'C',  'C',
     X     'C',  'C',  'S',  'S',  'S',  'S',  'C',  'C',
     X     'X',  'S',  'S',  'A',  'A',  'A',  'A',  'S',
     X     'X',  'X',  'S',  'S',  'S',  'X',  'S',  'X',
     X     'P',  'P',  'P',  'P',  'P',  'P',  'P',  'P',
     X     'P',  'P',  'X',  'S',  'S',  'S',  'S',  'X'/
      DATA          CPSX4
     X  /  'X',  'H',  'H',  'H',  'H',  'H',  'H',  'H',
     X     'H',  'H',  'H',  'H',  'H',  'H',  'H',  'H',
     X     'H',  'H',  'H',  'H',  'H',  'H',  'H',  'H',
     X     'H',  'X',  'U',  'U',  'U',  'U',  'U',  'U',
     X     'U',  'G',  'G',  'G',  'G',  'G',  'G',  'G',
     X     'G',  'G',  'G',  'G',  'G',  'G',  'G',  'G',
     X     'G',  'G',  'G',  'G',  'G',  'G',  'G',  'G',
     X     'G',  'V',  'V',  'V',  'V',  'V',  'V',  'S'/
C
C  SCAN THE OPTIONS LIST.
      EXFG=0
      CALL UGOPTN(OPTNS,INOS,EXOS)
C
C  PROCESS 'PTOX' OPTION IF IT IS GIVEN.
      IF (EXFG.NE.1) GO TO 200
      DO 103 INT1=1,NCHAR
        XPRI=CPRI(INT1:INT1)
        XSEC=CSEC(INT1:INT1)
        DO 101 INT2=1,256
          IF (CPPX(INT2).NE.XPRI) GO TO 100
          IF (CPSX(INT2).NE.XSEC) GO TO 100
          XPRI=CHAR(INT2-1)
          GO TO 102
  100     CONTINUE
  101   CONTINUE
  102   CEXT(INT1:INT1)=XPRI
  103 CONTINUE
C
C  PROCESS 'XTOP' OPTION IF IT IS GIVEN.
  200 IF (EXFG.NE.2) GO TO 300
      DO 201 INT1=1,NCHAR
        INT2=ICHAR(CEXT(INT1:INT1))+1
        CPRI(INT1:INT1)=CPPX(INT2)
        CSEC(INT1:INT1)=CPSX(INT2)
  201 CONTINUE
C
C  RETURN TO CALLER.
  300 RETURN
C
      END
	Subroutine UGP001(IDATA,INT)
	INTEGER*2 IDATA(*)
	INT = IDATA(6)
	RETURN
	END
