      SUBROUTINE DOPTC(IOPT,IVAL,IVAL2)
      CHARACTER*4 IOPT(2)
      INTEGER IVAL(2)
C
C   **MEMBER** DOPTC
C
C  THESE ARE INTERFACE ROUTINES WHICH RETRIEVE/FILL VALUES FROM/INTO
C  THE /DPMODE/ COMMON BLOCK.
C
C
      INCLUDE 'dpmode.INC'
      INCLUDE 'dcomop.INC'
      INCLUDE 'dcscal.INC'
      INTEGER IHSCALE(4,4)
      EQUIVALENCE (HSCALE(1,1),IHSCALE(1,1))
      INCLUDE 'hretcd.INC'
C
C  RETURN CODES:
C
C      IRETCD = 0  successfull operation
C               1  illegal option
C               2  VAL arg is wrong type
C
C
        SAVE /DPHEAD/
      COMMON /DPHEAD/ IHDR(24)
      CHARACTER*4 IHDR
      CHARACTER*1 C1HDR(96)
      EQUIVALENCE (IHDR(1),C1HDR(1))
C
      INTEGER ITEXT4(2)
      REAL*8 TEXT8,DBLANK
      EQUIVALENCE (TEXT8,ITEXT4(1))
      CHARACTER*8 CTEMP8
C
      INTEGER INDX(110)
      CHARACTER*4 OPTS(110), OPT, OPT1, GETC, RESC, BLANK, ALL, CTEMP
      CHARACTER*1 L1TEMP(4),LRBT(2,2),LEFT,RIGHT,BOT,TOP,AT,L1BLNK
      EQUIVALENCE (LRBT(1,1),LEFT),(LRBT(2,1),RIGHT),
     >            (LRBT(1,2),BOT),(LRBT(2,2),TOP)
      LOGICAL LTEMP
      EQUIVALENCE (ITEMP,LTEMP,RTEMP),(ITEMP2,RTEMP2),(L1TEMP(1),CTEMP)
C
      INTEGER IMODE(1)
      EQUIVALENCE (IMODE(1),IDEV)
C
      INTEGER DPAK
      CHARACTER*4 SYNOPT(9)
      INTEGER SYNDX(9)
C
      DATA OPTS/
     > 'A4ID','CHSC','PNTD','TISI','CENT',
     > 'CHAR','L2CO','DEVI','ESCT','ESCG',
     > 'EJEC','SYMS','ERRO','EUNI','FRAM',
     > 'GCOU','GRAT','HIST','MARK','ID  ',
     > 'ITRA','ITIC','LCOU','LCOL','LINE',
     > 'LOGS','AUTO','G2AN','OFFS','OMIT',
     > 'OUNI','OVER','LLIN','RESC','SLBE',
     > 'PNTS','SLDI','SLIC','SIZE','NAME',
     > 'SLWI','L2SY','L2SU','IDEV','2DLI',
     > 'XLOG','XAUT','XTIC','L2CA','XZER',
     > 'YLOG','YAUT','YTIC','YZER','L2ZA',
     > 'DATE','TICD','QUAD','MARG','LMAR',
     > 'RMAR','BMAR','TMAR','HEAD','LOWI',
     > '#CAL','IDFO','FULS','LIND','X2TI',
     > 'Y2LO','Y2AU','Y2TI','Y2ZE','ZLOG','ZAUT','ZTIC','ZZER',
     > 'XSUB','YSUB','X2SU','Y2SU','ZSUB','XSMO','YSMO',
     > 'COLO','ROTA','ELVA','SMOO','WSMO','OVPR','NUMF',
     > 'JBFO','CHFM','XSIZ','YSIZ','XOFF','YOFF','HIDE','WAIT',
     > 'MAXP',9*'    '/
C
C      INDX GIVES LOCATION IN IMODE FOR THE OPTION, OR 0 IF NOT THERE
      DATA INDX/
     >  76,115, 55,104, 40,  45, 70,  1,  0,  0,
     >  80,103, 37,  4, 41,  43, 64, 65,120, 75,
     >  63, 18,  0, 66, 36,   0,  0, 60,125,  0,
     >   0, 42, 77, 55, 58,  74, 57, 56,123, 97,
     >  59, 71, 67,  1, 62,   9,  6, 17, 68, 12,
     >   8,  5, 19, 11, 69,  99, 81,  1,  0,141,
     > 143,142,144,  1, 39,  85,106,105,102, 21,
     >  10,  7, 23, 13,  8,   5, 25, 11, 18, 20,
     >  22, 24, 26,145,146, 107,139,140,108,149,
     > 110,116,117,118,123, 124,125,126,119,121,
     >  83, 9*0/
C
      DATA DBLANK/8H        /
      DATA   NOPTS/101/
      DATA GETC,RESC/'GET,','RES,'/, BLANK/'    '/
      DATA LRBT/'L','R','B','T'/, AT/'@'/, L1BLNK/' '/
      DATA DPAK/4HDPAK/
      DATA ALL/'ALL '/
C
      DATA SYNOPT/'XMAN','YMAN','Y2MA','ZMAN','MANU','XDIR','NCAL',
     >            'LSUM','G2IO'/
      DATA SYNDX /   47,    52,    72,    76,    27,    45,    66,
     >               43,    45/
C
C
      NARG=NARGS()
      IF(NARG.LT.0) NARG=2
C
      OPT=IOPT(1)
      OPT1=IOPT(1)
      CALL DPUPPR(OPT)
      CALL DPUPPR(OPT1)
      IF(OPT.EQ.GETC.OR.OPT.EQ.RESC) OPT=IOPT(2)
      CALL DPUPPR(OPT)
C
C       SPECIAL OPTIONS 'FULSCR' AND 'LINDEN' MUSN'T DO DPINIT
      IF(OPT.EQ.OPTS(68) .OR. OPT.EQ.OPTS(69)) GO TO 5
      IF(DPNEW.NE.DPAK) CALL DPINIT(50000)
C
    5 IRETCD=0
C
C       IS THE OPTION LEGAL ? (GO TO IT IF SO)
C
      IF(OPT1.EQ.RESC.AND.OPT.EQ.ALL) GO TO 5000
C      ALLOW FOR SOME SYNONYMS
      ISYN=0
      DO 7 K=1,9
      IF(OPT.NE.SYNOPT(K)) GO TO 7
      I=SYNDX(K)
      ISYN=1
      GO TO 15
    7 CONTINUE
C
      DO 10 I=1,NOPTS
      IF(OPT.EQ.OPTS(I)) GO TO 15
   10 CONTINUE
C
C------- TEST FOR HMSC SUBOPTS  (FOR MHP USE, DOESN'T DO RES OR ALL)
      JJ=INDEX('XMIN DX   XMTI XMSU YMIN DY   YMTI YMSU'//
     >         'ZMIN DZ   ZMTI ZMSU ROTA ELVA ',OPT)
      IF(JJ.GT.0) THEN
         J=(JJ+4)/5
         IF(OPT1.EQ.GETC) THEN
            IVAL(1)=IHSCALE(J,1)
         ELSE
            IHSCALE(J,1)=IVAL(1)
         ENDIF
         RETURN
      ENDIF
C------- END OF SPECIAL MHP CODE
C
C
C       THIS OPT IS NOT IN THE TABLE -- ILLEGAL OPTION
      IRETCD=1
      WRITE(ERUNIT,12) OPT
   12 FORMAT(' DOPT  CALLED WITH INVALID OPTION -- ''',A4,'''')
      RETURN
C
   15 IF(OPT1.NE.GETC) GO TO 2000
C
      GO TO (
     > 110,120,130,140,150,160,170,180,190,200,
     > 210,220,230,240,250,260,270,280,290,300,
     > 310,320,330,340,350,360,370,380,390,400,
     > 410,420,430,440,450,460,470,480,490,500,
     > 510,520,530,540,550,560,570,580,590,600,
     > 610,620,630,640,650,660,670,680,690,700,
     > 710,720,730,740,750,760,770,780,790,800,
     > 810,820,830,840,850,860,870,880,890,900,
     > 910,920,930,940,950,960,970,980,990,1000,
     > 1010,1020,1030,1040,1050,1060,1070,1080,1090,6000,
     > 6010),I
C
C      A4ID - ID (IN A4 FORMAT)
  110 IVAL(1)=IDA
      RETURN
C
C      CHSCALE - CHARACTER SIZE SCALING
  120 IVAL(1)=CHSCAL
      RETURN
C
C
C      PNTDEN - POINT DENSITY FOR SCATTERPLOTS ON VERSATEC
  130 IVAL(1)=PNTDEN
      RETURN
C
C      TITLE SIZE
  140 IVAL(1)=TITLSZ
      RETURN
C
C      CENT - ENTER OF BIN OR LOW EDGE
  150 ITEMP=BINCEN
      GO TO 1998
C
C       CHAR - CHARACTER,COLOR,ERROR,LINE
  160 K=1
      IF(NARG.GE.3) K=IVAL2
      IF(K.LT.1.OR.K.GT.10) K=1
      IVAL(1)=PLTCHR(K)
      RETURN
C
C       L2CO - NUMBER OF COLUMNS PER BIN FOR DPLP2
  170 IVAL(1)=L2COL
      RETURN
C
C       DEVI - OUTPUT DEVICE NUMBER
  180 IF(NARG.LE.2) GO TO 186
      IF(IVAL2.LE.0) GO TO 186
      TEXT8=DBLANK
      IF(IVAL2.GE.3.AND.IVAL2.LE.20) TEXT8=DEVTYP(IVAL2)
      GO TO 188
  186 TEXT8=DEVTYP(IDEV)
  188 IVAL(1)=ITEXT4(1)
      IVAL(2)=ITEXT4(2)
      RETURN
C
C      ESCT - ESCAPE SEQUENCE FOR GRAPHICS
  190 CONTINUE
      RETURN
C
C      ESCG - ESCAPE SEQUENCE FOR TEXT
  200 CONTINUE
      RETURN
C
C      EJEC - PAGE EJECT
  210 ITEMP=EJECT
      GO TO 1998
C
C      SYMSIZE
  220 IVAL(1)=SYMSIZ
      RETURN
C
C      ERRO - ERROR BARS
  230 IVAL(1)=ERRS
      RETURN
C
C      EUNI - ERROR UNIT NUMBER
  240 IVAL(1)=ERUNIT
      RETURN
C
C      FRAM - FRAME
  250 ITEMP=FRAME
      GO TO 1998
C
C      GCOU - COUNTER FOR GRAPHIC PLOTS
  260 IVAL(1)=NOVRG
      RETURN
C
C      GRAT - GRATICLES (L1)
  270 ITEMP=L1GRAT
      GO TO 1998
C
C      HIST - HISTOGRAM BARS
  280 IVAL(1)=L1FILL
      RETURN
C
C      MARK - MARKER NUMBER
  290 IVAL(1)=MARK
      RETURN
C
C      ID   - ID
  300 IVAL(1)=IDARG
      RETURN
C
C      ITRACE - TRACE BACK FLAG
  310 IVAL(1)=ITRACE
      RETURN
C
C      ITIC - # INTERVENING TICS
  320 IVAL(1)=G1TIC(2,1)
      RETURN
C
C      LCOU - LP PLOT COUNTER
  330 IVAL(1)=0
      RETURN
C
C      LCOL - LENGTH (L2)
  340 IVAL(1)=LCOL
      RETURN
C
C      LINE - LINE PLOT
  350 IVAL(1)=G1LINS
      RETURN
C
C      LOGS - LOG BOTH AXES
  360 ITEMP=ILOG(1)
      GO TO 1998
C
C      AUTO/MANU - AUTO SCALES ON BOTH AXES
  370 IVAL(1)=IAUTO(1)
      IF(ISYN.EQ.0) RETURN
      ITEMP=IAUTO(1)
      GO TO 1998
C
C      G2ANGS - MANUAL ISOMETRIC ANGLES
  380 IVAL(1)=G2ANGS
      RETURN
C
C      OFFS - OFFSET
  390 RTEMP2=GOFSET(2)
      RTEMP=GOFSET(1)
      IVAL(1)=ITEMP
      IVAL2=ITEMP2
      RETURN
C
C      OMIT - OMIT FIRST AND LAST BIN FROM SCALING
  400 ITEMP=IEDGE(1)
      GO TO 1998
C
C      OUNI - OUTPUT UNIT NUMBER
  410 IVAL(1)=LPUNIT
      RETURN
C
C      OVER - OVERPLOT
  420 IVAL(1)=OVRPLT
      RETURN
C
C      LLIN - LINES PER PAGE (L2)
  430 IVAL(1)=L2PGE
      RETURN
C
C      RESC - RESCALE BETWEEN OVERPLOTS
  440 ITEMP=RESCAL
      GO TO 1998
C
C      SLBE - SLICE BEGINNING
  450 IVAL(1)=SLBEG
      RETURN
C
C      PNTS - POINT SYMBOL FOR GRAPHIC SCATTER POINTS
  460 IVAL(1)=PNTSYM
      RETURN
C
C      SLDI - SLICE DIRECTION
  470 IVAL(1)=SLDIR
      RETURN
C
C      SLIC - SLICE FLAG
  480 ITEMP=SLICE
      GO TO 1998
C
C      SIZE - SIZE OF GRAPHIC PLOT
  490 RTEMP2=GSIZE(2)
      RTEMP=GSIZE(1)
      IVAL(1)=ITEMP
      IVAL2=ITEMP2
      RETURN
C
C      NAME
  500 IVAL(1)=JBNAM(1)
      IVAL(2)=JBNAM(2)
      RETURN
C
C      SLWI - SLICE WIDTH
  510 IVAL(1)=SLWDTH
      RETURN
C
C      L2SY - SYMBOL RANGE IN L2
  520 IVAL(1)=L2SYM
      RETURN
C
C      L2SU - L2SUMS FLAG IN L2
  530 IVAL(1)=L2SUMS
      RETURN
C
C      IDEV - UNIT NUMBER
  540 IVAL(1)=IDEV
      RETURN
C
C      2DLINE - DIRECTION OF LINES IN G2
  550 IVAL(1)=G2LINS
      RETURN
C
C      XLOG - LOG SCALE ON X AXIS
  560 ITEMP=ILOG(2)
      GO TO 1998
C
C      XAUTO/XMAN - AUTO SCALES ON X AXIS
  570 IVAL(1)=IAUTO(2)
      IF(ISYN.EQ.0) RETURN
      ITEMP=0
      IF(IAUTO(2).EQ.0) ITEMP=1
      GO TO 1998
C
C      XTIC - NUMBER OF TICS ALONG X
  580 IVAL(1)=G1TIC(1,1)
      RETURN
C
C      L2CA - L2CAUT FLAG IN L2
  590 IVAL(1)=L2CAUT
      RETURN
C
C      XZER - FORCE ZERO ON X AXIS
  600 ITEMP=IZERO(2)
      GO TO 1998
C
C      YLOG - LOG SCALE ON Y AXIS
  610 ITEMP=ILOG(1)
      GO TO 1998
C
C      YAUTO/YMAN - AUTO SCALES ON Y AXIS
  620 IVAL(1)=IAUTO(1)
      IF(ISYN.EQ.0) RETURN
      ITEMP=0
      IF(IAUTO(1).EQ.0) ITEMP=1
      GO TO 1998
C
C      YTIC - NUMBER OF TICS ALONG Y AXIS
  630 IVAL(1)=G1TIC(1,2)
      RETURN
C
C      YZER - FORCE ZERO ON Y AXIS
  640 ITEMP=IZERO(1)
      GO TO 1998
C
C      L2ZA - L2ZAUT FLAG IN L2
  650 IVAL(1)=L2ZAUT
      RETURN
C
C      DATE
  660 IVAL(1)=JBDAT(1)
      IVAL(2)=JBDAT(2)
      RETURN
C
C       TICD - TIC DIRECTION
  670 IVAL(1)=TICDIR
      RETURN
C
C      QUAD - QUADRANT NUMBER
  680 CTEMP=BLANK
      J=1
      DO 688 I=1,2
      IF(GSIZE(I).EQ.1.0 .AND. GOFSET(I).EQ.0.0) GO TO 688
      IF(GSIZE(I).EQ.0.5 .AND. GOFSET(I).EQ.0.0) GO TO 684
      IF(GSIZE(I).EQ.0.5 .AND. GOFSET(I).EQ.0.5) GO TO 686
      IRETCD=2
      GO TO 688
  684 L1TEMP(J)=LRBT(1,I)
      GO TO 687
  686 L1TEMP(J)=LRBT(2,I)
  687 J=J+1
  688 CONTINUE
      READ(CTEMP,'(A4)') ITEMP
      GO TO 1998
C
C      MARG - MARGIN SIZES
  690 DO 695 I=1,4
      RTEMP=G1MARG(I)
  695 IVAL(I)=ITEMP
      RETURN
C
C      LMAR - LEFT MARGIN
  700 RTEMP=G1MARG(1)
      GO TO 1998
C
C      RMAR - RIGHT MARGIN
  710 RTEMP=G1MARG(3)
      GO TO 1998
C
C      BMAR - BOTTOM MARGIN
  720 RTEMP=G1MARG(2)
      GO TO 1998
C
C      TMAR - TOP MARGIN
  730 RTEMP=G1MARG(4)
      GO TO 1998
C
C      HEADER - FOR TOP OF PAGE
  740 DO 742 I=1,24
  742 READ(IHDR(I),'(A4)') IVAL(I)
      RETURN
C
C      LOWIN - INPUT FUNCTION IS AT LOW EDGE OF BIN
  750 ITEMP=LOWIN
      GO TO 1998
C
C      #CALLS - FOR PRINTING NUMBER OF CALLS
  760 ITEMP=ICALLS
      GO TO 1998
C
C      ID FONT
  770 ITEMP=IDFONT
      GO TO 1998
C
C      FULSCR - FULL SCREEN FLAG
  780 ITEMP=FULSCR
      GO TO 1998
C
C       LINDEN - LINE DENSITY (FOR VERSATEC)
  790 ITEMP=LINDEN
C..#IFDEF DGSYS
      CALL DGGET('BRIT',ITEMP)
C..#ENDIF
      GO TO 1998
C
C      X2TIC - # XTICS IN 2-D GRAPHIC PLOT
  800 IVAL(1)=G2TIC(1,1)
      RETURN
C
C      Y2LOG - LOG SCALE FOR Y IN 2-D PLOTS
  810 ITEMP=ILOG(3)
      GO TO 1998
C
C      Y2AUTO/Y2MAN - AUTO SCALES FOR Y IN 2-D PLOTS
  820 IVAL(1)=IAUTO(3)
      IF(ISYN.EQ.0) RETURN
      ITEMP=0
      IF(IAUTO(3).EQ.0) ITEMP=1
      GO TO 1998
C
C      Y2TIC - NUMBER OF Y TICS IN 2-D PLOTS
  830 IVAL(1)=G2TIC(1,2)
      RETURN
C
C      Y2ZERO - FORCED ZERO FOR Y AXIS IN 2-D PLOT
  840 ITEMP=IZERO(3)
      GO TO 1998
C
C      ZLOG - LOG SCALE FOR Y IN 2-D PLOTS
  850 ITEMP=ILOG(1)
      GO TO 1998
C
C      ZAUTO/ZMAN - AUTO SCALES FOR Z IN 2-D PLOTS
  860 IVAL(1)=IAUTO(1)
      IF(ISYN.EQ.0) RETURN
      ITEMP=0
      IF(IAUTO(1).EQ.0) ITEMP=1
      GO TO 1998
C
C      ZTIC - NUMBER OF Z TICS IN 2-D PLOTS
  870 IVAL(1)=G2TIC(1,3)
      RETURN
C
C      ZZERO - FORCED ZERO FOR Z AXIS IN 2-D PLOT
  880 ITEMP=IZERO(1)
      GO TO 1998
C
C      XSUBTIC
  890 IVAL(1)=G1TIC(2,1)
      RETURN
C
C      YSUBTIC
  900 IVAL(1)=G1TIC(2,2)
      RETURN
C
C      X2 SUBTIC
  910 IVAL(1)=G2TIC(2,1)
      RETURN
C
C      Y2 SUBTIC
  920 IVAL(1)=G2TIC(2,2)
      RETURN
C
C      ZSUBTIC
  930 IVAL(1)=G2TIC(2,3)
      RETURN
C
C      XSMOOTH
  940 RTEMP=XSMTH
      GO TO 1998
C
C      YSMOOTH
  950 IVAL(1)=ITEMP
      GO TO 1998
C
C      COLOR
  960 IVAL(1)=COLOR
      RETURN
C
C      ROTA - ROTATION ANGLE IN ISOMETRIC PLOTS
  970 RTEMP=ROTANG
      GO TO 1998
C
C      ELVA - ELEVATION ANGLE IN ISOMETRIC PLOT
  980 RTEMP=ELVANG
      GO TO 1998
C
C      SMOOTH
  990 IVAL(1)=SMOOTH
      RETURN
C
C      WSMOOTH
 1000 RTEMP=WSMTH
      GO TO 1998
C
C      OVPRT - OVER-PRINT FLAG
 1010 IVAL(1)=OVPRT
      RETURN
C
C      NUMFMT - NUMBER FORMAT
 1020 IVAL(1)=NUMFMT
      RETURN
C
C      JBFONT
 1030 IVAL(1)=JBFONT
      RETURN
C
C      CHFMT - CHARACTER FORMAT
 1040 CALL DCFMT(1,IVAL(1))
      RETURN
C
C      XSIZE
 1050 RTEMP=GSIZE(1)
      GO TO 1998
C
C      YSIZE
 1060 RTEMP=GSIZE(2)
      GO TO 1998
C
C      XOFFSET
 1070 RTEMP=GOFSET(1)
      GO TO 1998
C
C      YOFSET
 1080 RTEMP=GOFSET(2)
      GO TO 1998
C
C      HIDE
 1090 IVAL(1)=IHIDE
      RETURN
C
C      WAIT
 6000 IVAL(1)=KBWAIT
      RETURN
C
C      MAXPOINTS
 6010 IVAL(1)=IMULT
      RETURN
C
 1998 IVAL(1)=ITEMP
      RETURN
C
C
 2000 IF(OPT1.NE.RESC) GO TO 2005
      IF(INDX(I).LE.0) RETURN
      ITEMP=DPSAVE(INDX(I))
      ITEMP2=DPSAVE(INDX(I)+1)
      GO TO 2010
C
 2005 ITEMP=IVAL(1)
 2010 IF(LTEMP) KVAL=1
      IF(.NOT.LTEMP) KVAL=0
      KVALB=1-KVAL
C      ALLOW FLOATING POINT INSTEAD OF INTEGER IN SOME CASES.
      INTVAL=ITEMP
      IF(IABS(INTVAL).GT.255.AND.ABS(RTEMP).LT.1.E9) INTVAL=IFIX(RTEMP)
      WRITE(CTEMP,'(A4)') ITEMP
C
 2015 GO TO (
     > 2110,2120,2130,2140,2150,2160,2170,2180,2190,2200,
     > 2210,2220,2230,2240,2250,2260,2270,2280,2290,2300,
     > 2310,2320,2330,2340,2350,2360,2370,2380,2390,2400,
     > 2410,2420,2430,2440,2450,2460,2470,2480,2490,2500,
     > 2510,2520,2530,2540,2550,2560,2570,2580,2590,2600,
     > 2610,2620,2630,2640,2650,2660,2670,2680,2690,2700,
     > 2710,2720,2730,2740,2750,2760,2770,2780,2790,2800,
     > 2810,2820,2830,2840,2850,2860,2870,2880,2890,2900,
     > 2910,2920,2930,2940,2950,2960,2970,2980,2990,3000,
     > 3010,3020,3030,3040,3050,3060,3070,3080,3090,3100,
     > 3110),I
C
C      A4ID - ID (IN A4 FORMAT)
 2110 IDA=ITEMP
      RETURN
C
C      CHSCALE - CHARACTER SIZE SCALING
 2120 CHSCAL=INTVAL
      RETURN
C
C
C      PNTDEN -
 2130 PNTDEN=INTVAL
      RETURN
C
C      TITLE SIZE
 2140 TITLSZ=INTVAL
      RETURN
C
C      CENT - CENTER OF BIN OR LOW EDGE
 2150 BINCEN=KVAL
      RETURN
C
C       CHAR - CHARACTER,COLOR,ERROR,LINE
 2160 K=1
      IF(NARG.GE.3) K=IVAL2
      IF(K.LT.1.OR.K.GT.10) K=1
      PLTCHR(K)=ITEMP
      RETURN
C
C       L2CO - NUMBER OF COLUMNS PER BIN FOR DPLP2
 2170 L2COL=INTVAL
      RETURN
C
C       DEVI - OUTPUT DEVICE NUMBER
 2180 IF(OPT1.EQ.RESC) GO TO 2540
C      IF 3'RD ARG PRESENT, THEN ONLY REDEFINE DEVTYP TABLE
      IF(NARG.LE.2) GO TO 2186
      IF(IVAL2.LE.2.OR.IVAL2.GT.20) RETURN
      WRITE(CTEMP8,'(2A4)') IVAL(1),IVAL(2)
      CALL DPUPPR(CTEMP8)
      READ(CTEMP8,'(A8)') DEVTYP(IVAL2)
CCC   ITEXT4(1)=IVAL(1)
CCC   ITEXT4(2)=IVAL(2)
CCC   DEVTYP(IVAL2)=TEXT8
      RETURN
 2186 CALL DPSLCT(IVAL(1))
      RETURN
C
C      ESCT - ESCAPE SEQUENCE FOR A TEXT SCREEN
C      ESCG - ESCAPE SEQUENCE FOR A GRAPHIC SCREEN
 2190 CONTINUE
C      DGESC IS AN ENTRY IN DGSCRN
 2200 IF(OPT1.NE.RESC) CALL DGESC(OPT,IVAL,IVAL2)
      RETURN
C
C      EJEC - PAGE EJECT
 2210 EJECT=KVAL
      RETURN
C
C      SYMSIZE
 2220 SYMSIZ=ITEMP
      RETURN
C
C      ERRO - ERROR BARS
 2230 ERRS=ITEMP
      RETURN
C
C      EUNI - ERROR UNIT NUMBER
 2240 ERUNIT=ITEMP
      RETURN
C
C      FRAM - FRAME
 2250 FRAME=KVAL
      RETURN
C
C      GCOU - COUNTER FOR GRAPHIC PLOTS
 2260 NOVRG=ITEMP
      RETURN
C
C      GRAT - GRATICLES (G1)
 2270 L1GRAT=KVAL
      RETURN
C
C      HIST - HISTOGRAM BARS
 2280 L1FILL=KVAL
      RETURN
C
C      MARK - MARKER NUMBER
 2290 MARK=ITEMP
      RETURN
C
C      ID   - ID
 2300 IDARG=ITEMP
      IF(IDARG.GT.0.AND.IDARG.LT.10000) THEN
         CALL DPITOA(IDARG,CTEMP,NCHR,-4,10)
      ENDIF
      READ(CTEMP,'(A4)') IDA
      RETURN
C
C      ITRACE - TRACE BACK FLAG
 2310 ITRACE=INTVAL
      RETURN
C
C      ITIC - # INTERVENING TICS
 2320 G1TIC(2,1)=ITEMP
      G1TIC(2,2)=ITEMP
      RETURN
C
C      LCOU - LP PLOT COUNTER
 2330 RETURN
C
C      LCOL - LENGTH (L2)
 2340 LCOL=INTVAL
      RETURN
C
C      LINE - LINE PLOT
 2350 G1LINS=INTVAL
      RETURN
C
C      LOGS - LOG BOTH AXES
 2360 ILOG(1)=KVAL
      ILOG(2)=KVAL
      ILOG(3)=KVAL
      RETURN
C
C      AUTO/MANU - AUTO SCALES ON ALL AXES
 2370 IF(ISYN.EQ.0) KVALB=INTVAL
      IAUTO(1)=KVALB
      IAUTO(2)=KVALB
      IAUTO(3)=KVALB
      RETURN
C
C      G2ANGS - MANUAL ISOMETRIC ANGLES
 2380 G2ANGS=KVAL
      RETURN
C
C      OFFS - OFFSET
 2390 IF(OPT1.NE.RESC) ITEMP2=IVAL2
      GOFSET(1)=RTEMP
      GOFSET(2)=RTEMP2
C       SET UG PROGRAMMER LIMITS FOR THIS GSIZE/GOFSET
      CALL DPLIMS
      RETURN
C
C      OMIT - OMIT FIRST AND LAST BIN FROM SCALING
 2400 IEDGE(1)=KVAL
      IEDGE(2)=KVAL
      RETURN
C
C      OUNI - OUTPUT UNIT NUMBER
 2410 LPUNIT=ITEMP
      RETURN
C
C      OVER - OVERPLOT
 2420 IF(OVRPLT.EQ.0.AND.KVAL.EQ.0) RETURN
      IF(OVRPLT.NE.0.AND.KVAL.NE.0) GO TO 2425
      OVRPLT=-1
      IF(IDEV.GT.2) CALL DPICT(KVALB)
      NOVRG=0
      NOVRL=0
 2425 OVRPLT=KVAL
      RETURN
C
C      LLIN - LINES PER PAGE (L2)
 2430 L2PGE=ITEMP
      RETURN
C
C      RESC - RESCALE BETWEEN OVERPLOTS
 2440 RESCAL=KVAL
      RETURN
C
C      SLBE - SLICE BEGINNING
 2450 SLBEG=ITEMP
      RETURN
C
C      PNTS - POINT SYMBOL FOR GRAPHIC SCATTER POINTS
 2460 PNTSYM=ITEMP
      RETURN
C
C      SLDI - SLICE DIRECTION
 2470 SLDIR=ITEMP
      RETURN
C
C      SLIC - SLICE FLAG
 2480 SLICE=KVAL
      RETURN
C
C     GSIZE - SIZE OF GRAPHIC PLOT
 2490 IF(OPT1.NE.RESC) ITEMP2=IVAL2
      GSIZE(1)=RTEMP
      GSIZE(2)=RTEMP2
C       SET UG PROGRAMMER LIMITS FOR THIS GSIZE/GOFSET
      CALL DPLIMS
      RETURN
C
C      NAME
 2500 JBNAM(1)=ITEMP
      IF(OPT1.EQ.RESC) THEN
         JBNAM(2)=ITEMP2
      ELSE
         JBNAM(2)=IVAL(2)
      ENDIF
      RETURN
C
C      SLWI - SLICE WIDTH
 2510 SLWDTH=ITEMP
      RETURN
C
C      L2SY - SYMBOL RANGE IN L2
 2520 L2SYM=INTVAL
      RETURN
C
C      L2SU - L2 SUMS
 2530 L2SUMS=ITEMP
      RETURN
C
C      IDEV - UNIT NUMBER
 2540 CALL DPSLCT(ITEMP)
      RETURN
C
C      2DLINE - DIRECTION OF LINES IN G2
 2550 G2LINS=ITEMP
      RETURN
C
C      XLOG - LOG SCALE ON X AXIS
 2560 ILOG(2)=KVAL
      RETURN
C
C      XAUTO/XMAN - AUTO SCALES ON X AXIS
 2570 IAUTO(2)=INTVAL
      IF(ISYN.EQ.0) RETURN
      IAUTO(2)=KVALB
      RETURN
C
C      XTIC - NUMBER OF TICS ALONG X
 2580 G1TIC(1,1)=INTVAL
      RETURN
C
C      L2CA - L2CAUT FLAG IN L2
 2590 L2CAUT=KVAL
      RETURN
C
C      XZER - FORCE ZERO ON X AXIS
 2600 IZERO(2)=KVAL
      RETURN
C
C      YLOG - LOG SCALE ON Y AXIS
 2610 ILOG(1)=KVAL
      RETURN
C
C      YAUTO/YMAN - AUTO SCALES ON Y AXIS
 2620 IAUTO(1)=INTVAL
      IF(ISYN.EQ.0) RETURN
      IAUTO(1)=KVALB
      RETURN
C
C      YTIC - NUMBER OF TICS ALONG Y AXIS
 2630 G1TIC(1,2)=INTVAL
      RETURN
C
C      YZER - FORCE ZERO ON Y AXIS
 2640 IZERO(1)=KVAL
      RETURN
C
C      L2ZA - L2ZAUT FLAG IN L2
 2650 L2ZAUT=ITEMP
      RETURN
C
C      DATE
 2660 JBDAT(1)=ITEMP
      IF(OPT1.EQ.RESC) THEN
         JBDAT(2)=ITEMP2
      ELSE
         JBDAT(2)=IVAL(2)
      ENDIF
      RETURN
C
C       TICD - TIC DIRECTION
 2670 TICDIR=ITEMP
      RETURN
C
C      QUAD - QUADRANT NUMBER
 2680 GSIZE(1)=1.0
      GSIZE(2)=1.0
      GOFSET(1)=0.0
      GOFSET(2)=0.0
      IF(OPT1.EQ.RESC) ITEMP=0
      DO 2688 I=1,2
CCC   IF(L1TEMP(I).NE.TOP) GO TO 2682
      IF(INDEX('Tt',L1TEMP(I)).EQ.0) GO TO 2682
C       TOP HALF
      GSIZE(2)=0.5
      GOFSET(2)=0.5
      GO TO 2688
C2682 IF(L1TEMP(I).NE.BOT) GO TO 2683
 2682 IF(INDEX('Bb',L1TEMP(I)).EQ.0) GO TO 2683
C       BOTTOM HALF
      GSIZE(2)=0.5
      GOFSET(2)=0.0
      GO TO 2688
C2683 IF(L1TEMP(I).NE.LEFT) GO TO 2684
 2683 IF(INDEX('Ll',L1TEMP(I)).EQ.0) GO TO 2684
C      LEFT HALF
      GSIZE(1)=0.5
      GOFSET(1)=0.0
      GO TO 2688
C2684 IF(L1TEMP(I).NE.RIGHT) GO TO 2688
 2684 IF(INDEX('Rr',L1TEMP(I)).EQ.0) GO TO 2688
C      RIGHT HALF
      GSIZE(1)=0.5
      GOFSET(1)=0.5
 2688 CONTINUE
C       SET UG PROGRAMMER LIMITS FOR THIS GSIZE/GOFSET
      CALL DPLIMS
      RETURN
C
C      MARG - MARGIN SIZES
 2690 DO 2695 K=1,4
      ITEMP=DPSAVE(INDX(I)+K-1)
      IF(OPT1.NE.RESC) ITEMP=IVAL(K)
 2695 G1MARG(K)=RTEMP
      RETURN
C
C      LMAR - LEFT MARGIN
 2700 G1MARG(1)=RTEMP
      RETURN
C
C      RMAR - RIGHT MARGIN
 2710 G1MARG(3)=RTEMP
      RETURN
C
C      BMAR - BOTTOM MARGIN
 2720 G1MARG(2)=RTEMP
      RETURN
C
C      TMAR - TOP MARGIN
 2730 G1MARG(4)=RTEMP
      RETURN
C
C      HEADER - FOR TOP OF PAGE
 2740 K=0
      DO 2748 I=1,96
      J=MOD(I-1,4) + 1
      IF(J.EQ.1) CTEMP=BLANK
      IF(J.EQ.1.AND.OPT1.NE.RESC) WRITE(CTEMP,'(A4)') IVAL((I+3)/4)
      IF(L1TEMP(J).EQ.AT) K=1
      IF(K.EQ.0) C1HDR(I)=L1TEMP(J)
      IF(K.NE.0) C1HDR(I)=L1BLNK
 2748 CONTINUE
      RETURN
C
C      LOWIN - INPUT FUNCTION IS AT LOW EDGE OF BIN
 2750 LOWIN=KVAL
      RETURN
C
C      #CALLS - SET FLAG FOR PRINTING NUMBER OF CALLS
 2760 ICALLS=KVAL
      RETURN
C
C      ID FONT
 2770 IDFONT=KVAL
      RETURN
C
C
C      FULSCR - FULL SCREEN
 2780 FULSCR=KVAL
      RETURN
C
C      LINDEN - LINE DENSITY (FOR VERSATEC)
 2790 LINDEN=IVAL(1)
C..#IFDEF DGSYS
      CALL DGSET('BRIT',IVAL(1))
C..#ENDIF
      RETURN
C
C      X2TIC
 2800 G2TIC(1,1)=INTVAL
      RETURN
C
C      Y2LOG
 2810 ILOG(3)=KVAL
      RETURN
C
C      Y2AUTO/Y2MAN - AUTO SCALES FOR Y IN 2-D PLOTS
 2820 IAUTO(3)=INTVAL
      IF(ISYN.EQ.0) RETURN
      IAUTO(3)=KVALB
      RETURN
C
C      Y2TIC
 2830 G2TIC(1,2)=INTVAL
      RETURN
C
C      Y2ZERO
 2840 IZERO(3)=KVAL
      RETURN
C
C      ZLOG
 2850 ILOG(1)=KVAL
      RETURN
C
C      ZAUTO/ZMAN
 2860 IAUTO(1)=INTVAL
      IF(ISYN.EQ.0) RETURN
      IAUTO(1)=KVALB
      RETURN
C
C      ZTIC
 2870 G2TIC(1,3)=INTVAL
      RETURN
C
C      ZZERO
 2880 IZERO(1)=KVAL
      RETURN
C
C       XSUBTIC
 2890 G1TIC(2,1)=INTVAL
      RETURN
C
C      YSUBTIC
 2900 G1TIC(2,2)=INTVAL
      RETURN
C
C      X2 SUBTIC
 2910 G2TIC(2,1)=INTVAL
      RETURN
C
C      Y2 SUBTIC
 2920 G2TIC(2,2)=INTVAL
      RETURN
C
C      ZSUBTIC
 2930 G2TIC(2,3)=INTVAL
      RETURN
C
C      XSMOOTH - X SMOOTHING
 2940 XSMTH=RTEMP
      RETURN
C
C      YSMOOTH
 2950 YSMTH=RTEMP
      RETURN
C
C      COLOR
 2960 COLOR=INTVAL
      RETURN
C
C      ROTA - ROTATION ANGLE IN ISOMETRIC PLOTS
 2970 ROTANG=RTEMP
      RETURN
C
C      ELVA - ELEVATION ANGLE IN ISOMETRIC PLOTS
 2980 ELVANG=RTEMP
      RETURN
C
C      SMOOTH
 2990 SMOOTH=ITEMP
      RETURN
C
C      WSMOOTH
 3000 WSMTH=RTEMP
      RETURN
C
C      OVPRT - OVERPRINT FLAG
 3010 OVPRT=KVAL
      RETURN
C
C      NUMFMT - NUMBER FORMAT
 3020 NUMFMT=KVAL
      RETURN
C
C      JBFONT
 3030 JBFONT=INTVAL
      RETURN
C
C      CHFMT - CHARACTER FORMAT
 3040 CALL DCFMT(0,INTVAL)
      RETURN
C
C      XSIZE
 3050 GSIZE(1)=RTEMP
      GO TO 3085
C
C      YSIZE
 3060 GSIZE(2)=RTEMP
      GO TO 3085
C
C      XOFFSET
 3070 GOFSET(1)=RTEMP
      GO TO 3085
C
C      YOFFSET
 3080 GOFSET(2)=RTEMP
 3085 CALL DPLIMS
      RETURN
C
C      HIDE
 3090 IHIDE=KVAL
      RETURN
C
C      WAIT
 3100 KBWAIT=KVAL
      RETURN
C
C      MAXPOINTS
 3110 IMULT=ITEMP
      RETURN
C
C      CLR,ALL  RESET ALL OF DPMODE
 5000 IOVR=OVRPLT
      JOVR=DPSAVE(INDX(32))
      OVRPLT=0
      IF(IOVR.NE.JOVR) CALL DPICT(IOVR)
C       preserve value of inter and idev
      DO 5010 I=2,81
 5010 IMODE(I)=DPSAVE(I)
      DO 5020 I=83,172
 5020 IMODE(I)=DPSAVE(I)
      RETURN
C
      END
