      SUBROUTINE DPCLOS(IARG)
C
C   **MEMBER** DPCLOS
C   **ALIAS** DPCLS
C
C   DPCLOS  -  CLOSE THE ACTIVE GRAPHIC DEVICE ONLY, SEE DPCLS BELOW.
C
      INCLUDE 'dpmode.INC'
      INCLUDE 'hcom.INC'
C
      CHARACTER*4 ARG,ALL,SCAT,CARG
      INTEGER HPAK
C..#IFDEF DGSYS
      INTEGER IOPEN(8)
      REAL RDUM
      CHARACTER SDUM
      CHARACTER*3 CTEK
CC..#ELSE
C      CHARACTER*8 CTMP
C..#ENDIF
      DATA HPAK/4HHPAK/, ALL/'ALL '/,SCAT/'SCAT'/
C
C
      NRG=NARGS()
      CARG=' '
      IF(NRG.GE.1) WRITE(CARG,'(A4)') IARG
      GO TO 20
C
      ENTRY DPCLS(ARG)
C
C  IF ARG = '    '     - CLOSE THE ACTIVE GRAPHIC DEVICE ONLY,
C  IF ARG = 'ALL '     - CLOSE ALL DEVICES AND SCATTERPLOT FILE
C  IF ARG = 'SCAT'     - CLOSE SCATTERPLOT FILE ONLY.
C
      NRG=NARGS()
      CARG=' '
      IF(NRG.GE.1) CARG=ARG
C
   20 CONTINUE
      CALL DPUPPR(CARG)
      IF(CARG.EQ.SCAT) GO TO 80
C..#IFDEF DGSYS
      CALL UGINFO('OPENDEV',SDUM,IOPEN,RDUM)
      NOPEN=IOPEN(1)
CC..#ELSE
C      CALL GQOPWK(0,IERR,NOPEN,I)
C..#ENDIF
      IF(NOPEN.LE.0) GO TO 35
C
C        COMPLETE ANY WINDOWING OR OVERPLOTTING IN PROGRESS
C
      IF(WINDOW.LE.0) GO TO 30
      ITEMP=WINDOW
      WINDOW=-1
      CALL DPICT(1)
      WINDOW=ITEMP
   30 IF(OVRPLT.LE.0) GO TO 35
      ITEMP=OVRPLT
      OVRPLT=-1
      CALL DPICT(1)
      OVRPLT=ITEMP
C
   35 IF(CARG.NE.'    '.AND.CARG.NE.'NOCL') GO TO 40
      IF(NOPEN.LE.0) RETURN
C..#IFDEF DGSYS
      CALL UGINFO('ACTDEV',SDUM,IOPEN,RDUM)
      IF(CARG.EQ.' ') THEN
         CALL UGCLOS(' ')
      ELSE
         CALL UGCLOS('NOCLEAR')
      ENDIF
      WRITE(CTEK,'(A3)') DEVTYP(IOPEN(1))
      IF(CTEK.EQ.'TEK') CALL DGSCRN('CLOS')
CC..#ELSE
C      CALL GQWKS(IDEV,IERR,ISTATE)
C      IF(ISTATE.NE.0) CALL GDAWK(IDEV)
C      CALL GCLWK(IDEV)
C      WRITE(CTMP,'(A8)') DEVTYP(IDEV)
C      IF(CTMP.EQ.'DISPLAY ') CALL DGSCRN('CLOS')
C..#ENDIF
      NDEVS=MAX0(0,NDEVS-1)
      IDEV=2
      RETURN
C
   40 IF(CARG.NE.ALL) GO TO 200
      NDEVS=0
      IF(NOPEN.LE.0) GO TO 80
C..#IFDEF DGSYS
      CALL UGCLOS('ALL')
C..#ENDIF
C        Search list of opened devices for TEK4010, flip it if found
      DO 50 I=1,NOPEN
C..#IFDEF DGSYS
      WRITE(CTEK,'(A3)') DEVTYP(IOPEN(I+1))
      IF(CTEK.NE.'TEK') CALL DGSCRN('CLOS')
CC..#ELSE
C      CALL GQOPWK(I,IERR,NOP,IWKID)
C      CALL GQWKS(IWKID,IERR,ISTATE)
C      IF(ISTATE.NE.0) CALL GDAWK(IWKID)
C      WRITE(CTMP,'(A8)') DEVTYP(IWKID)
C      IF(CTMP.EQ.'DISPLAY ') CALL DGSCRN('CLOS')
C..#ENDIF
   50 CONTINUE
      IDEV=2
C      CLOSE SCATTERPLOT FILE, IF IT IS IN USE
   80 IF(HPNEW.NE.HPAK) RETURN
      IF(SCTTOT.LE.0) RETURN
      SCTTOT=0
      SCTUSE=-1
      CLOSE(SCTUNI,STATUS='DELETE',ERR=100)
  100 RETURN
C
C ERROR IN ARGUMENT
  200 WRITE(ERUNIT,250) CARG
  250 FORMAT(/,' DPCLOS - ARG ',A4,' NOT RECOGNIZED')
      RETURN
      END
