      SUBROUTINE DPINIT(ISCBUF)
C
C   **MEMBER** DPINIT
C
C   INITIALIZES GRAPHIC BUFFER AND OBTAINS JOB NAME AND DATE.
C  THE OPTIONAL ARGUMENT ISCBUF PROVIDES THE SIZE OF THE
C  GRAPHICS ELEMENT BUFFER IN /GRACOM/. IF NOT SUPPLIED,
C  THE DEFAULT SIZE OF 500 WORDS IS USED.
C  THE DEFAULT SIZE OF 50000 WORDS IS USED.
C
      INCLUDE 'dpmode.INC'
C
C            ELEMENT BUFFER FOR UNIFIED GRAPHICS CALLS
C
C..#IFDEF DGSYS
      COMMON / SCPBUF / NBUF,BUF(50000)
      INTEGER BUF
C..#ENDIF
C
C
C
      CHARACTER*8 CTEMP
      INTEGER DPAK
      DATA DPAK/4HDPAK/
C
C
C
      NARG=NARGS()
      IF(NARG.LT.0) NARG=1
C       INITIALIZE SIZE OF GRAPHICS ELEMENT BUFFER
C
C..#IFDEF DGSYS
      IF(NARG.LE.0) NBUF=50000
      IF(NARG.GE.1) NBUF=ISCBUF
      CALL DGBUF(BUF,NBUF)
C..#ENDIF
C
C       FILL /DPMODE/ WITH JOB NAME AND DATE
C
      CALL DJOBDAY(0,CTEMP)
      READ(CTEMP,'(2A4)') JBNAM
      CALL DJOBDAY(1,CTEMP)
      READ(CTEMP,'(2A4)') JBDAT
C
      IF(DPNEW.EQ.DPAK) RETURN
C
C
C       SET FLAG TO INITIALIZED STATE, SO THAT DPINIT NOT CALLED AGAIN
C
      DPNEW=DPAK
C
C      MAKE REFERENCE TO (IBM) MODULE WHERE BLOCK DATA IS STORED
      CALL DBLOAD
      RETURN
C
      END
