      FUNCTION H2Y(I)
C
C   **MEMBER** H2Y
C
C  THE FUNCTION RETURNS THE FOLLOWING VALUES:
C
C     H2Y(I)    (LOW EDGE) VALUE OF Y FOR BIN I IN A 2-D HIST
C
      INCLUDE 'hcom.INC'
C
      IF(M(NODE+5).NE.2) GO TO 900
      MP=10
    2 MP=NODE+M(NODE+10)+MP
      MPARM=NODE+M(NODE+10)
      IF(M(MPARM+1).EQ.15) GO TO 3
      H2Y=R(MP)+FLOAT(I-1)*R(MP+1)
      RETURN
C
C       'LPT' MODE OF STORAGE
    3 MBINS=NODE+M(NODE+12)
      IBIN=I
      IF(M(MBINS+1).LT.M(MBINS+2)) IBIN=IBIN+M(MBINS+1)
      IF(IBIN.GT.M(MPARM+5)) IBIN=IBIN-M(MPARM+5)
      H2Y=0.0
      IF(IBIN.GT.M(MBINS+2)) RETURN
      H2Y=R(MBINS+2*IBIN+1)
      MDISP=NODE+M(NODE+14)
      IALT=M(MDISP+6)
      IF(IALT.EQ.0) RETURN
      I0=M(MBINS+1)
      IF(IALT.EQ.2) GO TO 4
      I0=I0+1
      IF(M(MBINS+1).GE.M(MBINS+2)) I0=1
      IF(I0.GT.M(MPARM+5)) I0=I0-M(MPARM+5)
    4 H2Y=H2Y-R(MBINS+2*I0+1)
      RETURN
C
C       ERROR - THIS IS NOT A 2-D HIST
  900 H2Y=9999.
      RETURN
C
      END
