      FUNCTION HZ(I,J)
C
C   **MEMBER**  HZ
C
C  THE FUNCTION RETURNS THE FOLLOWING VALUES:
C
C     HZ(I,J)   CONTENTS STORED IN BIN (I,J) FOR A 2-D HIST.
C
      INCLUDE 'hcom.INC'
C
      LOGICAL LW4
      EQUIVALENCE (LW4,IW)
C
      IF(M(NODE+5).NE.2) GO TO 900
      IMS=0
    6 MPARM=NODE+M(NODE+10)
      MBINS=NODE+M(NODE+12)
      HZ=0.
      IF(I.LT.1.OR.I.GT.M(MPARM+5)) RETURN
      IBIN=I
      IF(J.LT.1.OR.J.GT.M(MPARM+9)) RETURN
      IBIN=IBIN+(J-1)*M(MPARM+5)
C
    8 IMS=M(MPARM+1)+IMS
      MDISP=NODE+M(NODE+14)
      RNORM=R(MDISP+1)
      IALT=M(MDISP+6)
      GO TO (10,20,30,40,50,60,70,80,90,100,110,90,100,110,150),IMS
      RETURN
C
C       L*1  VALUE
C
   10 LW4=L(4*MBINS+IBIN)
      HZ=IW
      GO TO 500
C
C       I*2  VALUE
C
   20 HZ=H(2*MBINS+IBIN)
      GO TO 500
C
C       I*4  VALUE
C
   30 HZ=M(MBINS+IBIN)
      GO TO 500
C
C       R*4  VALUE
C
   40 HZ=R(MBINS+IBIN)
      GO TO 500
C
C       E*4 VALUE
C
   50 HZ=R(MBINS+2*IBIN-1)
      GO TO 500
C
C       M*4  VALUE
C
   60 K=MBINS+2*IBIN
      ERR=AMAX1(0.,R(K))
      IF(ERR.NE.0.) HZ=R(K-1)
      GO TO 500
C
C       WEV  VALUE
C
   70 HZ=R(MBINS+2*IBIN-1)
      GO TO 500
C
C       A*4 VALUE
C
   80 HZ=R(MBINS+3*IBIN-2)
      IF(IALT.EQ.2) HZ=R(MBINS+3*IBIN)
      IF(IALT.EQ.3) HZ=R(MBINS+3*IBIN-1)
      IF(IALT.EQ.4) HZ=SQRT(R(MBINS+3*IBIN-1))
      GO TO 500
C
C       EFF VALUE AND ASM VALUE
C
   90 K=MBINS+2*IBIN
      R1TEMP=R(K-1)
      R2TEMP=R(K)
      GO TO 120
C
  100 K=2*MBINS+2*IBIN
      R1TEMP=H(K-1)
      R2TEMP=H(K)
      GO TO 120
C
  110 K=4*MBINS+2*IBIN
      LW4=L(K-1)
      R1TEMP=IW
      LW4=L(K)
      R2TEMP=IW
C
  120 HZ=0.
      IF(IALT.GT.0) GO TO 140
      IF(R2TEMP.LE.0.) RETURN
      HZ=R1TEMP/R2TEMP
      IF(IMS.GE.12) HZ=2.*HZ-1.0
      RETURN
C
C       RETURN HITS, MISSES, OR TOTAL TRIALS FOR EFF OR ASM
  140 IF(IALT.EQ.1) HZ=R1TEMP
      IF(IALT.EQ.2) HZ=R2TEMP-R1TEMP
      IF(IALT.EQ.3) HZ=R2TEMP
  500 HZ=HZ/RNORM
      RETURN
C
C      LPT
C       WORD 1 CONTAINS LOCATION OF LAST POINT,
C       WORD 2 CONTAINS NUMBER OF POINTS
C       WORDS 3&4, 5&6, ETC. CONTAINS X&W VALUES OF POINTS.
C
  150 IF(M(MBINS+1).LT.M(MBINS+2)) IBIN=IBIN+M(MBINS+1)
      IF(IBIN.GT.M(MPARM+5)) IBIN=IBIN-M(MPARM+5)
      HZ=0.0
      IF(IBIN.LE.M(MPARM+5)) HZ=R(MBINS+2*IBIN+2)
      RETURN
C
C       ERROR - THIS IS NOT A 1-D OR 2-D HIST
  900 HZ=9999.
      RETURN
C
      END
