      FUNCTION HZE(I,J,IER,IXYER)
C
C   **MEMBER**  HZE
C
C  THE FUNCTION RETURNS THE FOLLOWING VALUES:
C
C     HZE(I,J,IER)  ERROR FOR BIN (I,J) FOR A 2-D HIST, IER AS FOR HYE
C
      INCLUDE 'hcom.INC'
      INCLUDE 'nargcom.INC'
C
      LOGICAL LW4
      EQUIVALENCE (LW4,IW)
C
C
      IF(M(NODE+5).NE.2) GO TO 900
      NARG=NARGS()-NARG0F
      IF(NARG.LT.0) NARG=2
      IF(NARG.LE.3) GO TO 6
      IF(IXYER.LE.1) GO TO 6
C  X/Y ERROR REQUESTED
      HZE=0.
      MPARM=NODE+M(NODE+10)
      IF(IXYER.EQ.2) HZE=R(MPARM+7)/2.0
      IF(IXYER.EQ.3) HZE=R(MPARM+11)/2.0
      RETURN
C
    6 MPARM=NODE+M(NODE+10)
      MBINS=NODE+M(NODE+12)
      HZE=0.
      IF(I.LT.1.OR.I.GT.M(MPARM+5)) RETURN
      IBIN=I
      IF(J.LT.1.OR.J.GT.M(MPARM+9)) RETURN
      IBIN=IBIN+(J-1)*M(MPARM+5)
C
    8 IMS=M(MPARM+1)
      MDISP=NODE+M(NODE+14)
      RNORM=R(MDISP+1)
      IALT=M(MDISP+6)
      GO TO (210,220,230,240,250,260,270,280, 90,100,
     >       110, 90,100,110,350),IMS
      RETURN
C
C       L*1  ERROR
C
  210 LW4=L(4*MBINS+IBIN)
      HZE=IW
      GO TO 400
C
C       I*2  ERROR
C
  220 HZE=H(2*MBINS+IBIN)
      GO TO 400
C
C       I*4  ERROR
C
  230 HZE=M(MBINS+IBIN)
      GO TO 400
C
C       R*4  ERROR
C
  240 HZE=R(MBINS+IBIN)
      GO TO 400
C
C       E*4  ERROR
C
  250 HZE=R(MBINS+2*IBIN)
      GO TO 410
C
C       M*4  ERROR
C
  260 HZE=SQRT(AMAX1(0.,R(MBINS+2*IBIN)/RNORM))
      RETURN
C
C       WEV  ERROR
C
  270 HZE=R(MBINS+2*IBIN)
      GO TO 410
C
C       A*4 ERROR
C
  280 HZE=R(MBINS+3*IBIN-1)
      IF(IALT.EQ.1) HZE=HZE/AMAX1(1.0,R(MBINS+3*IBIN))
      IF(IALT.EQ.2) HZE=R(MBINS+3*IBIN)
      IF(IALT.EQ.3) HZE=2.*HZE**2/AMAX1(1.0,R(MBINS+3*IBIN))
      IF(IALT.EQ.4) THEN
         HZ=R(MBINS+3*IBIN-1)
         HZE=2.*HZE**2/AMAX1(1.0,R(MBINS+3*IBIN))
         IF(IER.EQ.1) THEN
            HZE=SQRT(HZ+HZE)-SQRT(HZ)
         ELSE
            HZE=SQRT(HZ)-SQRT(AMAX1(0.,(HZ-HZE)))
         ENDIF
      ENDIF
      GO TO 410
C
C       EFF VALUE AND ASM VALUE
C
   90 K=MBINS+2*IBIN
      R1TEMP=R(K-1)
      R2TEMP=R(K)
      GO TO 120
C
  100 K=2*MBINS+2*IBIN
      R1TEMP=H(K-1)
      R2TEMP=H(K)
      GO TO 120
C
  110 K=4*MBINS+2*IBIN
      LW4=L(K-1)
      R1TEMP=IW
      LW4=L(K)
      R2TEMP=IW
C
  120 HZE=0.
      IF(IALT.GT.0) GO TO 140
      IF(R2TEMP.LE.0.) RETURN
      HZE=R1TEMP/R2TEMP
  130 CONTINUE
      JER=1
      IF(NARG.GE.3) JER=IER
      HZE=H95CL(R1TEMP,R2TEMP,JER)
  135 IF(IMS.GE.12) HZE=2.*HZE
      RETURN
C
C       RETURN HITS, MISSES, OR TOTAL TRIALS FOR EFF OR ASM
  140 IF(IALT.EQ.1) HZE=R1TEMP
      IF(IALT.EQ.2) HZE=R2TEMP-R1TEMP
      IF(IALT.EQ.3) HZE=R2TEMP
      GO TO 400
C
C        LPT ERROR (NOT ALLOWED)
C
  350 HZE=0.
      RETURN
C
C
  400 HZE=AMAX1(R(MDISP+5),HZE)
  410 HZE=SQRT(AMAX1(0.,HZE))
  500 HZE=HZE/RNORM
      RETURN
C
C       ERROR - THIS IS NOT A 1-D OR 2-D HIST
  900 HZE=9999.
      RETURN
C
      END
